2008-06-27  Dan Nicolaescu  <dann@ics.uci.edu>

	* s/usg5-4.h: Fix previous change: keep the correct branch of a
	removed #if.
	(USG_SHARED_LIBRARIES): Remove duplicate definition.

2008-06-26  Juanma Barranquero  <lekktu@gmail.com>
	    Eli Zaretskii  <eliz@gnu.org>

	* makefile.w32-in (LOCAL_FLAGS):
	Don't include WINDOWSNT, DOS_NT and _UCHAR_T.

	* sysdep.c (_spawnlp, _getpid):
	Declare with explicit _cdecl instead of _CRTAPI1.

	* editfns.c (Fget_internal_run_time):
	Check for WINDOWSNT with #ifdef, not #if.

2008-06-26  Jason Rumney  <jasonr@gnu.org>

	* w32font.h (FONT_HANDLE, FONT_TEXTMETRIC): New macros.

	* w32term.c (x_draw_glyph_string_foreground):
	(x_draw_composite_glyph_string_foreground): Sync with xterm.c.
	Use FONT_HANDLE macro.
	(x_draw_glyph_string): Use FONT_TEXTMETRIC macro.

	* w32uniscribe.c (uniscribe_otf_capability, uniscribe_shape):
	(uniscribe_encode_char): Use FONT_HANDLE macro.

	* w32font.c (Fx_select_font): Use FONT_HANDLE macro.
	(w32font_text_extents): Use precast w32_font.
	(w32font_close): Free cached metrics.
	(w32font_open_internal): Allocate space for name on stack.

2008-06-26  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (extend_face_to_end_of_line): Fix last change.

2008-06-26  Jason Rumney  <jasonr@gnu.org>

	* w32term.h (FONT_AVG_WIDTH): Remove obsolete macro.
	(CP_8BIT, CP_UNICODE, CP_UNKNOWN): Remove obsolete constants.

2008-06-26  Juanma Barranquero  <lekktu@gmail.com>

	* Makefile.in (SOME_MACHINE_OBJECTS): Remove w32bdf.o.

2008-06-26  Jason Rumney  <jasonr@gnu.org>

	* w32bdf.c, w32bdf.h: Remove obsolete files.

	* makefile.w32-in: Remove refs to w32bdf.h and w32bdf.c.

	* w32gui.h: Don't include w32bdf.h.
	(XCharStruct, enum w32_char_font_type, W32FontStruct):
	Remove obsolete font support.

	* w32font.h (struct w32font_info): Remove compat_w32_font.
	Add hfont member.
	(FONT_COMPAT): Remove obsolete macro.

	* w32font.c (w32font_close): Remove compat code. Delete hfont member.
	(w32font_encode_char, w32font_text_extents): Use new hfont member.
	(w32font_open_internal): Remove compat code. Set new hfont member.
	(Fx_select_font): Use new hfont member.

	* w32uniscribe.c (uniscribe_otf_capability, uniscribe_shape):
	(uniscribe_encode_char): Use new hfont member.

	* w32term.c (x_draw_glyph_string_foreground):
	(x_draw_composite_glyph_string_foreground): Use new hfont member.
	(x_draw_glyph_string): Use metrics in w32font_info.

2008-06-26  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (handle_auto_composed_prop): Fix for the terminal case.

2008-06-26  Dan Nicolaescu  <dann@ics.uci.edu>

	* unexnext.c:
	* m/ews4800.h:
	* m/hp9000s300.h:
	* m/ibm370aix.h:
	* m/mips-siemens.h:
	* m/ncr386.h:
	* m/next.h:
	* m/pmax.h:
	* m/powerpcle.h:
	* m/tandem-s2.h:
	* s/386bsd.h:
	* s/bsd386.h:
	* s/bsd4-1.h:
	* s/bsd4-2.h:
	* s/bsdos2-1.h:
	* s/bsdos2.h:
	* s/bsdos3.h:
	* s/bsdos4.h:
	* s/nextstep.h:
	* s/ultrix4-3.h:
	* s/usg5-0.h:
	* s/usg5-2-2.h:
	* s/usg5-2.h:
	* s/usg5-4-3.h:
	* s/ux4800.h:
	* s/uxpds.h:
	* s/uxpv.h: Remove support for obsolete systems.
	* s/hpux.h, s/hpux10.h, s/hpux8.h, s/hpux9.h, s/hpux9shr.h:
	Remove, insert contents in s/hpux-10.20.h
	* s/aix3-1.h, s/aix3-2-5.h, s/aix3-2.h, s/aix4-1.h, s/aix4.h:
	Remove, insert contents in s/aix-4.2.h
	* s/usg5-3.h: Remove, insert contents in s/usg5-4.h.
	* s/bsd4-3.h: Rename to ..
	* s/bsd-common.h: ... this.
	* src/data.c:
	* src/doc.c:
	* src/ecrt0.c:
	* src/emacs.c:
	* src/fileio.c:
	* src/floatfns.c:
	* src/keyboard.c:
	* src/mem-limits.h:
	* src/print.c:
	* src/process.c:
	* src/sysdep.c:
	* src/syssignal.h:
	* src/systty.h:
	* src/syswait.h:
	* src/term.c:
	* src/unexec.c:
	* src/unexelf.c:
	* src/unexhp9k800.c:
	* src/m/hp800.h:
	* src/m/ibmrs6000.h:
	* src/m/mips.h:
	* src/m/vax.h:
	* src/s/darwin.h:
	* src/s/freebsd.h:
	* src/s/gnu.h:
	* src/s/ms-w32.h:
	* src/s/msdos.h:
	* src/s/netbsd.h:
	* src/s/template.h: Remove references to obsolete variables.

	* Makefile.in: Add dependencies for all unexec files.
	(admindir): Remove unused variable.
	(UNEXEC_SRC): Remove references.

2008-06-25  Chong Yidong  <cyd@stupidchicken.com>

	* xfns.c (x_default_font_parameter): If Xft is available, first
	try Monospace-12 for the default font.

2008-06-25  Jason Rumney  <jasonr@gnu.org>

	* xdisp.c (get_glyph_face_and_encoding): Encode invalid glyphs as 0.

2008-06-25  Stefan Monnier  <monnier@iro.umontreal.ca>

	* bytecode.c (Fbyte_code): Disable debugging code that doesn't compile.

	* buffer.c (syms_of_buffer): Remove default-word-wrap.

2008-06-25  Juanma Barranquero  <lekktu@gmail.com>

	* xdisp.c (syms_of_xdisp) <truncate-partial-width-windows>: Doc fix.
	<scroll-conservatively>: Fix typo in docstring.

	* xselect.c (Fx_send_client_event): Doc fix.

2008-06-25  Kenichi Handa  <handa@m17n.org>

	* xfaces.c (Fx_list_fonts): Call Flist_fonts with the arg PREFER.

	* font.c (font_parse_fcname): Remove unused variables.
	(font_sort_entites): Delete the arg SPEC.  Caller changed.
	Fix for the case of ! best_only.
	(font_delete_unmatched): Check DPI and AVGWIDTH too.

	* lisp.h (Fstring_to_unibyte): EXFUN it.

	* character.h (str_to_unibyte): Extern it.

	* character.c (str_to_unibyte): New function.

	* fns.c (Fstring_to_unibyte): New function.
	(syms_of_fns): Defsubr it.

2008-06-24  Kenichi Handa  <handa@m17n.org>

	* font.c (font_score): Even if the PIXEL_SIZE is the same, check
	DPI too.
	(font_sort_entites): Setup prefer_prop[FONT_DPI_INDEX] too.

2008-06-24  Andreas Schwab  <schwab@suse.de>

	* Makefile.in (${lispsource}loaddefs.el): Rename from
	../lisp/loaddefs.el.
	(bootstrap-clean): Do what distclean does but don't remove
	Makefile.
	(distclean): Depend on bootstrap-clean and remove Makefile.

2008-06-24  Chong Yidong  <cyd@stupidchicken.com>

	* buffer.h (struct buffer): New member word_wrap.

	* buffer.c (syms_of_buffer): New variables default-word-wrap and
	word-wrap.
	(init_buffer_once): Initialize them.

	* dispextern.h (struct it): Replace bool truncate_lines_p with a
	line_wrap enum possessing three possible values.

	* termopts.h: Replace truncate_partial_width_windows with
	Vtruncate_partial_width_windows.

	* dispnew.c (direct_output_for_insert): Avoid direct output when
	inserting a space with word wrap on.

	* indent.c (compute_motion): Obey integer values of
	truncate-partial-width-windows.

	* xdisp.c (Vtruncate_partial_width_windows): New Lisp_Object,
	replacing truncate_partial_width_windows.
	(init_iterator): If Vtruncate_partial_width_windows is an integer,
	truncate only if the window width is below that integer.
	(start_display. resize_mini_window, produce_stretch_glyph)
	(display_string, move_it_in_display_line_to): Use line_wrap.
	(back_to_previous_visible_line_start, reseat_1): Reset
	string_from_display_prop_p.
	(display_line): Extend default face to end of line when wrapping.

2008-06-24  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (display_line, move_it_in_display_line_to): Add ability
	to wrap continued lines at word boundaries.

2008-06-24  Jason Rumney  <jasonr@gnu.org>

	* font.c (Ffont_face_attributes): Multiply pixel size before point
	conversion to avoid multiplying rounding error.

2008-06-23  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (x_draw_glyph_string_background)
	(x_draw_glyph_string): Remove old bdf font code.

	* w32term.h (FONT_TYPE_FOR_UNIBYTE, FONT_TYPE_FOR_MULTIBYTE): Remove.

2008-06-22  Kenichi Handa  <handa@m17n.org>

	* font.c (font_find_for_lface): Try the adstyle specified in
	the property of LFACE_FONT of LFACE (if any).

2008-06-21  Seiji Zenitani  <zenitani@mac.com>
	    Ryo Yoshitake  <ryo@shiftmode.net>

	* xterm.c (x_set_frame_alpha): Add x_catch_errors for bug#437.

2008-06-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	* Makefile.in (${lisp} ${SOME_MACHINE_LISP}, ../lisp/loaddefs.el):
	Use $(BOOTSTRAPEMACS) rather than witness-emacs.
	(bootstrap-emacs${EXEEXT}): Merge witness-emacs into it.
	(witness-emacs): Remove.
	(lisp, shortlisp): Move loaddefs.el earlier.
	(mostlyclean): Forget about witness-emacs.

2008-06-22  Glenn Morris  <rgm@gnu.org>

	* Makefile.in (witness-emacs): Depend on temacs${EXEEXT}.
	(.SUFFIXES): Declare .el.elc as a suffix rule, for non-GNU makes.

2008-06-21  Stefan Monnier  <monnier@iro.umontreal.ca>

	* Makefile.in (PRECOMP): Remove.
	(${lisp} ${SOME_MACHINE_LISP}): Remove pseudo dependency on PRECOMP.
	(witness-emacs): Run `compile-first'.
	(.el.elc): Use the new compile-onefile target.

2008-06-21  Kenichi Handa  <handa@m17n.org>

	* xftfont.c (xftfont_open): Handle QCembolden only when
	FC_EMBOLDEN is defined.

2008-06-21  Andreas Schwab  <schwab@suse.de>

	* Makefile.in (witness-emacs): Use ../lisp, not $(lispsource).
	(.el.elc): Likewise.

2008-06-21  Miles Bader  <miles@gnu.org>

	* Makefile.in (../lisp/loaddefs.el): Build autoloads in the lisp
	build dir, not the lisp source dir.

2008-06-21  Stefan Monnier  <monnier@iro.umontreal.ca>

	* Makefile.in (emacs${EXEEXT}): Link the new emacs to bootstrap-emacs.
	(bootstrapclean): Remove.
	(.el.elc): New rule.
	(PRECOMP): New var.
	(../lisp/subdirs.el): Remove.
	(bootstrap-emacs${EXEEXT}): Remove subdirs.el and charpro.el dependency.
	(witness-emacs): New target.
	(mostlyclean): Remove witness-emacs as well.
	(../lisp/loaddefs.el, ${lisp} ${SOME_MACHINE_LISP}):
	Add witness-emacs dependency.

2008-06-20  Chong Yidong  <cyd@stupidchicken.com>

	* font.c (Ffont_face_attributes): Omit key-attribute pairs not
	defined by the font.

2008-06-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* Makefile.in (emacs${EXEEXT}): Depend on the machine-specific files.
	(bootstrap-clean): New target that keeps TAGS around.
	(../lisp/subdirs.el, ../lisp/loaddefs.el): New targets.
	(bootstrap-emacs${EXEEXT}): Depend on subdirs.el.

2008-06-20  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c, w32term.c, w32term.h, w32gui.h [OLD_FONT]:
	Remove obsolete font code.

	* w32font.c (font_matches_spec): Use csb bitfield from font signature
	to determine language support.

2008-06-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* sysdep.c (cfsetspeed): New fun extracted from the code.
	(cfmakeraw): Move before first use.

2008-06-20  Angelo Graziosi  <angelo.graziosi@alice.it>  (tiny change)

	* sysdep.c (cfmakeraw): Provide fallback implementation.
	(serial_configure): Provide fallback implementation of cfsetspeed.

2008-06-20  Kenichi Handa  <handa@m17n.org>

	* xftfont.c (xftfont_open): Add FOUNDRY, SPACING, DPI, SCALABLE to
	the pattern.

	* fontset.c (fontset_from_font): Copy font_spec before changing
	the elements.

	* xfns.c (x_default_font_parameter): Try "monospace-12" too.

2008-06-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* w32fns.c, xfnc.c (x_default_font_parameter): Only set `font-param'
	for explicit `font' parameters.

	* frame.c (x_set_font): Remove unexplained call to fix inf-recursion.

2008-06-19  Kenichi Handa  <handa@m17n.org>

	* frame.c: Include <ctype.h>.
	(x_set_font_backend): Allow spacing characters in the X resource
	for FontBackend.

2008-06-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* w32fns.c, xfns.c (Qfont_param): New var.
	(syms_of_w32fns): Initialize it.
	(x_default_font_parameter): Record explicit `font' into
	`font-parameter'.

2008-06-18  Kenichi Handa  <handa@m17n.org>

	* font.c (font_parse_xlfd): Fix previous change.
	(font_parse_fcname): Don't use :fc-unknown-spec.
	(FRAME_X_DISPLAY_INFO): Besure to have at least 1 pixel height.
	(Fcopy_font_spec): Preserve the order of elements in FONT_EXTRA.
	(font_add_log): Prepend the driver name to the resulting fonts.

	* ftfont.c (ftfont_pattern_entity): New arg extra.  Caller changed.
	(ftfont_spec_pattern): Don't check QCfc_unknown_spec and QCname.
	(ftfont_list) [FC_FONTFORMAT]: Include FC_FONTFORMAT in objset.

	* xftfont.c (QChinting , QCautohint, QChintstyle, QCrgba)
	(QCembolden): New variables.
	(syms_of_xftfont): DEFSYM them.
	(xftfont_open): Call XftFontMatch.  Don't trust the result of
	XftTextExtents8 if the pixel_size is less than 5.

2008-06-18  Andreas Schwab  <schwab@suse.de>

	* font.c (Ffont_face_attributes): Only define if HAVE_WINDOW_SYSTEM.
	(syms_of_font): Only defsubr if HAVE_WINDOW_SYSTEM.

2008-06-18  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_list, w32font_match): Add logging.

	* w32uniscribe (uniscribe_list, uniscribe_match): Add logging.

2008-06-17  Chong Yidong  <cyd@stupidchicken.com>

	* font.c (font_parse_fcname): Store divider characters for
	unknown-spec list.  For known key symbols, intern using correct
	symbol name.

2008-06-17  Kenichi Handa  <handa@m17n.org>

	* xfaces.c (realize_default_face): If the frame is not on window
	system, set the fontset of face to nil.

2008-06-17  Naohiro Aota  <nao.aota@gmail.com>  (tiny change)

	* fontset.c (fontset_pattern_regexp): Escape some reg-expr characters.

2008-06-16  Juanma Barranquero  <lekktu@gmail.com>

	* dispextern.h (lookup_non_ascii_face, split_font_name_into_vector)
	(build_font_name_from_vector): Delete externs.

	* xfaces.c (struct font_name): Don't declare.

2008-06-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	* font.c (font_unparse_gtkname): Use EQ to compare Lisp_Objects.

2008-06-16  Chong Yidong  <cyd@stupidchicken.com>

	* font.c (font_parse_fcname): Fix handling of unknown-spec string.

2008-06-16  Juanma Barranquero  <lekktu@gmail.com>

	* font.c (Ffont_spec): Fix usage in docstring.
	(Ffont_face_attributes): Doc fix.

2008-06-16  Andreas Schwab  <schwab@suse.de>

	* font.c (Ffont_face_attributes): Fix definition.

2008-06-16  Jason Rumney  <jasonr@gnu.org>

	* font.h (font_style_symbolic_from_value): Remove.

	* font.c (font_style_symbolic_from_value): Remove.
	(font_style_symbolic): Revert to pre 2008-06-13 version.

	* w32font.c (w32_to_fc_weight): New function.
	(w32font_full_name, logfont_to_fcname): Use it.

2008-06-16  Kenichi Handa  <handa@m17n.org>

	* font.c (font_check_object): Delete it.
	(font_clear_cache): Check if a font-object is alive.
	(font_open_entity): Likewise.  Set FONT_OBJLST_INDEX of a
	font-object to nil.
	(font_close_object): Don't check FONT_CLOSE_OBJECT.
	(font_at): Don't call font_check_object.
	(Ffont_get): Return a symbol for :weight, :slant, and :width.

2008-06-16  Katsumi Yamaoka  <yamaoka@jpl.org>

	* puresize.h (BASE_PURESIZE): Increase to 1230000.

2008-06-16  Chong Yidong  <cyd@stupidchicken.com>

	* font.c (font_parse_fcname): Correctly parse KEY=VAL values.

2008-06-15  Chong Yidong  <cyd@stupidchicken.com>

	* font.c (font_parse_fcname): Only one decimal point.
	(font_unparse_fcname): Handle data in family and foundry indices
	as symbols, not strings.
	(font_unparse_gtkname, Ffont_face_attributes): New functions.

	* xfns.c (Fx_select_font): Give GTK font dialog the default font name.

	* font.h (font_unparse_gtkname): Add prototype.

2008-06-15  Naohiro Aota  <nao.aota@gmail.com>  (tiny change)

	* fontset.c (fontset_pattern_regexp): Escape `+' characters in pattern.

2008-06-15  Andreas Schwab  <schwab@suse.de>

	* font.c (font_update_drivers): Fix crash when no drivers match.

2008-06-15  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xfns.c (Fx_create_frame): internal-border-width default to 0 for Gtk.
	* gtkutil.c (xg_create_frame_widgets): Don't set internal_border_width.

2008-06-14  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (syms_of_xdisp): Default underline-minimum-offset to 1.

2008-06-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	* process.c (Fserial_process_configure, Fprocess_send_eof):
	Use EQ to compare Lisp_Objects.

2008-06-13  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (Fw32_select_font): Remove old font API function.

	* w32font.c (logfont_to_fcname): New function.
	(Fx_select_font): New font dialog function compatible with
	GTK/fontconfig version.

	* font.c (font_style_symbolic_from_value): New function.
	(font_style_symbolic): Use it.

	* font.h (font_style_symbolic_from_value): Declare new function.

2008-06-13  Juanma Barranquero  <lekktu@gmail.com>

	* font.c (syms_of_font) <font-weight-table, font-slant-table>:
	<font-width-table>: Fix typos in docstrings.

2008-06-13  Daniel Engeler  <engeler@gmail.com>

	These changes add serial port access.
	* process.c: Add HAVE_SERIAL.
	(Fdelete_process, Fprocess_status, Fset_process_buffer)
	(Fset_process_filter, Fset_process_sentinel, Fprocess_contact)
	(list_processes_1, select_wrapper, Fstop_process)
	(Fcontinue_process, Fprocess_send_eof, kill_buffer_processes)
	(status_notify): Modify to handle serial processes.
	[HAVE_SERIAL] (Fserial_process_configure)
	[HAVE_SERIAL] (make_serial_process_unwind, Fmake_serial_process):
	New functions.
	* process.h (struct Lisp_Process): Add `type'.
	* sysdep.c [HAVE_TERMIOS] (serial_open, serial_configure):
	New functions.
	* w32.c (_sys_read_ahead, sys_read, sys_write): Modify to handle
	serial ports.
	(serial_open, serial_configure) New functions.
	* w32.h: Add FILE_SERIAL.
	(struct _child_process): Add ovl_read, ovl_write.

2008-06-13  Kenichi Handa  <handa@m17n.org>

	* dispextern.h (enum lface_attribute_index): New member
	LFACE_FOUNDRY_INDEX.

	* font.c (font_score): Delete arg alternate_families.  Check only
	weight, slant, width, and size.  Ignore the difference of alias
	style symbols.
	(font_sort_entites): Adjust for the above change.  Reflect the
	order of font-driver to scores.
	(font_list_entities): Don't check alternate_familes here.
	(font_clear_prop): Handle foundry.
	(font_update_lface): Don't parse "foundry-family" form here.
	Handle FONT_FOUNDRY_INDEX.
	(font_find_for_lface): Likewise.  Handle alternate families here.
	If registry is nil, try iso8859-1 and ascii-0.
	(font_open_for_lface): Pay attention to size in ENTITY.
	(font_open_by_name): Simplify by calling font_load_for_lface.
	(free_font_driver_list): Delete it.
	(font_update_drivers): Preserve the order of backends.
	(syms_of_font): Setting of sort_shift_bits adjusted for the change
	of font_score and font_sort_entites.
	(font_update_sort_order): Likewise.

	* xfaces.c (LFACE_FOUNDRY): New macro.
	(check_lface_attrs): Check foundry.
	(set_lface_from_font): Don't parse "FOUNDRY-FAMILY" form.
	(merge_face_vectors): Check foundry.
	(merge_face_ref): Likewise.
	(Finternal_set_lisp_face_attribute): Likewise.
	(x_update_menu_appearance): Likewise.
	(Finternal_get_lisp_face_attribute): Likewise.
	(lface_hash): Likewise.
	(lface_same_font_attributes_p): Likewise.
	(x_supports_face_attributes_p): Likewise.
	(tty_supports_face_attributes_p): Likewise.
	(Finternal_set_alternative_font_family_alist): Intern strings.
	(Finternal_set_alternative_font_registry_alist): Downcase strings.
	(realize_default_face): Set LFACE_FOUNDRY (lface).

	* xfns.c (Fx_create_frame, x_create_tip_frame): Register X
	font-driver at first.

	* ftfont.c (ftfont_font_format) [! FC_FONTFORMAT]: Declare "int len;".

2008-06-12  Emanuele Giaquinta  <emanuele.giaquinta@gmail.com>  (tiny change)

	* lread.c (Fload): Use xfree, not free on saved_doc_string.

2008-06-12  Jim Meyering  <meyering@redhat.com>

	Make unexec_free handle NULL the same way free does.
	* unexmacosx.c (unexec_free): Ignore a NULL argument.

2008-06-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* character.h (CHAR_TO_BYTE_SAFE): New macro.
	* character.c (Fmultibyte_char_to_unibyte): Obey the docstring.
	* regex.c (RE_CHAR_TO_UNIBYTE): Use the new macro.
	(WEAK_ALIAS): Simplify.
	* syntax.c (skip_chars): Don't mark non-byte chars in the fastmap
	when searching a unibyte buffer.

2008-06-12  Chong Yidong  <cyd@stupidchicken.com>

	* xfns.c (Fx_select_font): Rename from x-font-dialog.

2008-06-12  Juanma Barranquero  <lekktu@gmail.com>

	* w32font.c: Include ctype.h.

2008-06-11  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_encode_char): Detect missing glyphs that are
	misreported as space.
	(add_font_entity_to_list): Support unicode-bmp and unicode-sip
	as aliases for registry iso10646-1.

2008-06-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* buffer.c (clone_per_buffer_values): Skip `name'.

2008-06-11  Chong Yidong  <cyd@stupidchicken.com>

	* font.c (font_parse_fcname): Fix last change; accept decimal
	points in font size.

2008-06-10  Jason Rumney  <jasonr@gnu.org>

	* w32uniscribe.c (add_opentype_font_name_to_list):
	Skip non unicode fonts.

2008-06-10  Chong Yidong  <cyd@stupidchicken.com>

	* xfns.c (Fx_font_dialog): New function.

	* gtkutil.c (xg_dialog_response_cb): Rename from
	xg_file_response_callback.
	(pop_down_dialog): Rename from pop_down_file_dialog.
	(xg_get_file_name): Callers changed.
	(xg_get_font_name): New function.

	* gtkutil.h (xg_get_font_name): Insert prototype.

2008-06-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (underline_minimum_offset): Rename from xterm.c's
	x_underline_minimum_display_offset.
	(syms_of_xdisp): Declare it here rather than in xterm.c.
	* dispextern.h (underline_minimum_offset): Declare it.
	* w32term.c (x_draw_glyph_string): Use it.
	* xterm.c (x_underline_minimum_display_offset): Move to xdisp.c.
	(syms_of_xterm): Don't declare it any more.
	(x_draw_glyph_string): Adjust to the new name.

2008-06-10  David De La Harpe Golden  <david@harpegolden.net>  (tiny change)

	* xterm.c (x_underline_minimum_display_offset): New var.
	(x_draw_glyph_string): Use it.
	(syms_of_xterm): Declare it.

2008-06-10  Chong Yidong  <cyd@stupidchicken.com>

	* font.c (font_parse_fcname): Accept GTK-style font names too.

2008-06-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* dired.c (file_name_completion): Don't return t if the match is exact
	but with different capitalization.
	* minibuf.c (Ftry_completion): Simplify.

	* window.c (Vwindow_point_insertion_type): New var.
	(set_window_buffer): Use it.
	(syms_of_window): Init and export it to Lisp.

2008-06-10  Kenichi Handa  <handa@m17n.org>

	* font.h (font_intern_prop): Prototype adjusted.

	* font.c (font_intern_prop): New arg force_symbol.
	(font_parse_xlfd, font_parse_fcname, font_parse_family_registry):
	Adjust for the change of font_intern_prop.

	* ftfont.c (ftfont_pattern_entity):
	* w32font.c (add_font_name_to_list, w32_enumfont_pattern_entity)
	(w32_registry):
	* w32uniscribe.c (add_opentype_font_name_to_list): Adjust for
	the change of font_intern_prop.

2008-06-09  Juanma Barranquero  <lekktu@gmail.com>

	* w32menu.c (digest_single_submenu): Declare extern.

2008-06-09  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (x_make_frame_visible): Use alternate restore flags.

	* w32menu.c (Fx_popup_menu): Unwind protect while building menu.
	(parse_single_submenu): Remove.
	(digest_single_submenu): Remove.
	(syms_of_w32menu): Don't initialise variables that have moved
	to menu.c.
	(set_frame_menubar): Sync with version in xmenu.c.
	(w32_menu_show): Sync with xmenu_show in xmenu.c.

	* menu.c (single_keymap_panes, push_menu_pane, push_menu_item):
	Make static again.

2008-06-09  Jason Rumney  <jasonr@gnu.org>

	Changes to w32 files related to the move of common menu code
	to menu.c on 2008-06-08 by Chong Yidong.

	* menu.c [HAVE_NTGUI]: Include w32term.h, move widget related
	defs to w32gui.h.
	(single_keymap_panes, push_menu_item, push_menu_pane):
	Make globally visible.

	* w32menu.c (enum button_type, widget_value, local_heap, local_alloc)
	(local_free, malloc_widget_value, free_widget_value)
	(MENU_ITEMS_ITEM_NAME, MENU_ITEMS_ITEM_ENABLE, MENU_ITEMS_ITEM_VALUE)
	(MENU_ITEMS_ITEM_EQUIV_KEY, MENU_ITEMS_ITEM_DEFINITION)
	(MENU_ITEMS_ITEM_TYPE, MENU_ITEMS_ITEM_SELECTED, MENU_ITEMS_ITEM_HELP)
	(MENU_ITEMS_ITEM_LENGTH, enum menu_item_idx): Remove defs.
	(menu_items, menu_items_allocated, menu_items_used)
	(menu_items_n_panes, menu_items_submenu_depth): Remove global vars.
	(init_menu_items, finish_menu_items, discard_menu_items)
	(grow_menu_items, push_submenu_start, push_submenu_end)
	(push_left_right_boundary, push_menu_pane, push_menu_item)
	(keymap_panes, single_keymap_panes, list_of_panes, list_of_items)
	(free_menubar_widget_tree_value, parse_single_submenu)
	(update_submenu_strings): Remove functions.
	(xmalloc_widget_value): Remove and declare extern.

	* makefile.w32-in ($(SRC)/menu.$(O)): New target.
	(OBJ1): Build it.

	* w32gui.h (widget_value, XtPointer, Boolean, enum button_type)
	(local_heap, local_alloc, local_free, malloc_widget_value)
	(free_widget_value): Define here.

2008-06-09  Kenichi Handa  <handa@m17n.org>

	* font.h (Qascii_0): Extern it.

	* font.c (Qascii_0): New variable.
	(syms_of_font): DEFSYM it.
	(font_open_by_name): If the registry "iso8859-1" fails, try also
	"ascii-0".

	* ftfont.c (ftfont_spec_pattern): Accept the registry `ascii-0'.

2008-06-08  Kenichi Handa  <handa@m17n.org>

	* .gdbinit (xfont): New command.

2008-06-08  Andreas Schwab  <schwab@suse.de>

	* menu.c [HAVE_X_WINDOWS]: Include "xterm.h".
	* Makefile.in (menu.o): Update dependencies.

	* Makefile.in (obj): Always add menu.o.
	* emacs.c (main): Always call syms_of_menu.
	* keyboard.h: Remove extra #ifdef HAVE_X_WINDOW.

2008-06-08  Chong Yidong  <cyd@stupidchicken.com>

	* Makefile.in: Compile menu.c.

	* lisp.h: Declare syms_of_menu.

	* emacs.c (main): Call syms_of_menu.

	* keyboard.h: Relocate platform-independent menu definitions from
	xmenu.c.

	* menu.c: New file.  Relocate platform-independent menu
	definitions from xmenu.c.  Suggested by Adrian Robert.

	* xmenu.c: Remove platform-independent menu definitions.
	(menu_items menu_items_inuse, menu_items_allocated)
	(menu_items_used, menu_items_n_panes)
	(menu_items_submenu_depth): Move to keyboard.h.
	(init_menu_items, finish_menu_items, unuse_menu_items)
	(discard_menu_items, restore_menu_items, save_menu_items)
	(grow_menu_items, push_submenu_start, push_submenu_end)
	(push_left_right_boundary, push_menu_pane, push_menu_item)
	(keymap_panes, single_keymap_panes, single_menu_item)
	(list_of_panes, list_of_items, find_and_call_menu_selection)
	(xmalloc_widget_value, free_menubar_widget_value_tree)
	(parse_single_submenu, digest_single_submenu)
	(update_submenu_strings): Move to menu.c.

2008-06-07  Stefan Monnier  <monnier@iro.umontreal.ca>

	* dispnew.c (Flast_nonminibuf_frame): Handle the NULL case.

2008-06-06  Miles Bader  <miles@gnu.org>

	* xdisp.c (x_produce_glyphs): Calculate tab width based on current
	face, not frame default.

2008-06-05  Martin Rudalics  <rudalics@gmx.at>

	* window.c (pop_up_windows, pop_up_frames)
	(display_buffer_reuse_frames, Vpop_up_frame_function)
	(Vdisplay_buffer_function, Veven_window_heights)
	(Vspecial_display_buffer_names, Vspecial_display_regexps)
	(Vspecial_display_function, Vsame_window_buffer_names)
	(Vsame_window_regexps, split_height_threshold)
	(Vsplit_window_preferred_function): Move those vars to window.el.
	(display_buffer_1, Fspecial_display_p, Fsame_window_p)
	(Fdisplay_buffer): Move those functions to window.el.
	(syms_of_window): Remove corresponding declarations.
	(display_buffer): New function.
	(temp_output_buffer_show, Fother_window_for_scrolling): Use it.
	* dispnew.c (Flast_nonminibuf_frame): New function.
	* buffer.c (Fpop_to_buffer): Move to window.el.

2008-06-05  Stefan Monnier  <monnier@iro.umontreal.ca>

	* data.c (set_internal): Fix up call to let_shadows_buffer_binding_p.

2008-06-05  Kenichi Handa  <handa@m17n.org>

	* coding.c (detect_coding): Fix previous change.
	(detect_coding_system): Likewise.

2008-06-05  Stefan Monnier  <monnier@iro.umontreal.ca>

	* character.h (MAKE_CHAR_MULTIBYTE): Check the arg is a (uni)byte.

	* keymap.c (Vminibuffer_local_filename_must_match_map):
	Rename from Vminibuffer_local_must_match_filename_map.
	(syms_of_keymap):
	* minibuf.c (Fcompleting_read): Adjust accordingly.
	* commands.h: Rename declaration as well.

2008-06-05  Kenichi Handa  <handa@m17n.org>

	* font.c (Ffont_spec): Don't use font_parse_family_registry for
	family name.
	(Ffont_put): Likewise.

	* fontset.c (fontset_find_font): Call font_open_for_lface with the
	current font-spec.

	* xfont.c (xfont_list): Don't set registry to iso8859-1 even if it
	is unspecified.

	* xfaces.c (realize_x_face): If the font-related face attributes
	are the same as those of default face, realize a new fontset from
	default->fontset.
	(Fx_family_fonts): Use font_parse_family_registry instead of Ffont_put.

2008-06-05  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (move_it_in_display_line_to): Improve the type of its args.
	(move_it_in_display_line): New wrapper.

	* window.c (window_scroll_pixel_based_preserve_x)
	(window_scroll_preserve_hpos, window_scroll_preserve_vpos): New vars.
	(window_scroll_pixel_based, window_scroll_line_based):
	Use them to preserve column positions.
	(syms_of_window): Initialize them.

	* indent.c (Fvertical_motion): Extend first arg to allow passing an
	(HPOS . VPOS) pair.

	* dispextern.h (move_it_in_display_line): Declare.

2008-06-05  Juanma Barranquero  <lekktu@gmail.com>

	* window.c (Fwindow_parameter): Return VALUE, not (PARAMETER . VALUE).
	(Fwindow_parameters): Return copy of parameter alist.  Doc fix.
	(Fset_window_parameter): Return VALUE, not parameter alist.  Doc fix.

2008-06-04  Juanma Barranquero  <lekktu@gmail.com>

	* window.c (Fset_window_parameter): Doc fix.
	(Fwindow_parameters, Fwindow_parameter): Remove redundant check.

2008-06-04  Joakim Verona  <joakim@verona.se>

	* window.h (struct window): Add new member window_parameters.

	* window.c (Fwindow_parameters, Fwindow_parameter)
	(Fset_window_parameter): New defuns.
	(syms_of_window): Defsubr the new defuns.
	(make_window): Initialize window_parameters to nil.

2008-06-04  John Paul Wallington  <jpw@pobox.com>

	* eval.c (Fdefmacro): Doc fix.

2008-06-04  Kenichi Handa  <handa@m17n.org>

	* coding.c (detect_coding): Fix handling of coding->head_ascii.
	Be sure to call setup_coding_system when we find a proper coding system.
	(detect_coding_system): Fix handling of coding->head_ascii.

2008-06-03  Andreas Schwab  <schwab@suse.de>

	* font.c (font_prop_validate_spacing): Fix last change.

2008-06-03  Kenichi Handa  <handa@m17n.org>

	* font.c (font_prop_validate_spacing): Handle uppercase symbols.
	(font_parse_fcname): Fix handling of unknown key.

	* xfont.c (xfont_list): Try an alias.

	* charset.c (char_charset): Return NULL if the arg charset_list is
	specified and C doesn't belong to any of them.

2008-06-02  Chip Coldwell  <coldwell@redhat.com>

	* font.c (font_pixel_size): Don't take cdr of an integer.

2008-06-02  Jim Meyering  <meyering@redhat.com>

	Make "xfree (NULL)" a no-op; remove useless if-before-xfree.
	* alloc.c (xfree): Return right away for a NULL arg.
	* lread.c (nosuffix): Remove now-useless if-before-xfree tests.
	* gtkutil.c (xg_gtk_scroll_destroy): Likewise.
	* mac.c (create_apple_event_from_event_ref): Likewise.
	(create_apple_event_from_drag_ref, cfstring_create_normalized):
	Likewise.
	* doprnt.c (doprnt1): Likewise.
	* frame.c (frame): Likewise.
	* keyboard.c (wipe_kboard): Likewise.
	* macterm.c (x_free_frame_resources, xlfdpat_destroy, XFreePixmap)
	(init_font_name_table, mac_unload_font, x_delete_display): Likewise.
	* term.c (tty_default_color_capabilities, maybe_fatal)
	(delete_tty): Likewise.
	* w16select.c (string): Likewise.
	* w32.c (w32_get_resource, SET_ENV_BUF_SIZE): Likewise.
	* w32bdf.c (w32_free_bdf_font): Likewise.
	* w32fns.c (w32_unload_font): Likewise.
	* w32font.c (w32font_close): Likewise.
	* window.c (size_window): Likewise.
	* xselect.c (receive_incremental_selection): Likewise.
	* xterm.c (x_free_frame_resources, x_delete_display): Likewise.
	* mactoolbox.c (create_apple_event_from_drag_ref): Likewise.
	* w32.c (stat): Likewise.

	Remove useless if-before-free tests.
	* editfns.c (Fset_time_zone_rule): Likewise.
	* lread.c (nosuffix): Likewise.
	* ralloc.c (get_bloc): Likewise.
	* regex.c (reg_free): Likewise.
	* xftfont.c (xftfont_open, xftfont_close): Likewise.
	* xrdb.c (get_user_app, get_environ_db, x_load_resources): Likewise.
	* xsmfns.c (smc_save_yourself_CB): Likewise.

2008-06-02  Kenichi Handa  <handa@m17n.org>

	* font.c (font_find_for_lface): Handle float font size.
	(font_open_for_lface): Likewise.

	* xfaces.c (x_supports_face_attributes_p): Check face->font before
	comparing the properties.

2008-06-01  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32_enumfont_pattern_entity): Use requested registry.
	Treat iso10646-1 and Windows DEFAULT_CHARSET specially.
	Duplicate iso8859-1 fonts as iso10646-1 if no registry specified.
	Don't add empty script list.
	(w32_registry): Only map DEFAULT_CHARSET to iso10646-1 here.

2008-06-01  Dan Nicolaescu  <dann@ics.uci.edu>

	* Makefile.in (dot, dotdot): Remove, update users.
	".." has been used elsewhere in the file for a long time.
	(LIBXT_STATIC): Remove conditional based on unused variable.

2008-06-01  Miles Bader  <miles@gnu.org>

	* xfaces.c (Vface_remapping_alist): New variable.
	(syms_of_xfaces): Initialize it.
	(enum named_merge_point_kind): New type.
	(struct named_merge_point): Add `named_merge_point_kind' field.
	(push_named_merge_point): Make cycle detection respect different
	named-merge-point kinds.
	(lface_from_face_name_no_resolve): Rename from `lface_from_face_name'.
	Remove face-name alias resolution.
	(lface_from_face_name): New definition using
	`lface_from_face_name_no_resolve'.
	(get_lface_attributes_no_remap): Rename from `get_lface_attributes'.
	Call lface_from_face_name_no_resolve instead of lface_from_face_name.
	(get_lface_attributes): New definition that layers face-remapping on
	top of get_lface_attributes_no_remap.  New arg `named_merge_points'.
	(lookup_basic_face): New function.
	(lookup_derived_face): Pass new last arg to `get_lface_attributes'.
	(realize_named_face): Call `get_lface_attributes_no_remap' instead of
	`get_lface_attributes'.
	(face_at_buffer_position): Use `lookup_basic_face' to lookup
	DEFAULT_FACE_ID if necessary.  When optimizing the default-face case,
	return default_face's face-id instead of the constant DEFAULT_FACE_ID.

	* xdisp.c (init_iterator): Pass base_face_id through
	`lookup_basic_face' when we actually use it as a face-id.
	(handle_single_display_prop): Use `lookup_basic_face' to lookup
	DEFAULT_FACE_ID.

	* fontset.c (Finternal_char_font): Use `lookup_basic_face' to
	lookup the initial face-id.

	* dispextern.h (lookup_basic_face, Vface_remapping_alist): New decls.

2008-06-01  Juanma Barranquero  <lekktu@gmail.com>

	* textprop.c (syms_of_textprop) <text-property-default-nonsticky>:
	(Fremove_text_properties): Fix typos in docstrings.

2008-05-31  Kenichi Handa  <handa@m17n.org>

	* font.c (font_list_entities): Fix the car part of data to be
	stored in the cache.

	* ftfont.c (ftfont_font_format): Don't use strcasestr.

2008-05-30  Stefan Monnier  <monnier@iro.umontreal.ca>

	* chartab.c (Foptimize_char_table, optimize_sub_char_table):
	Add a `test' argument so another predicate than `equal' can be used.
	(map_sub_char_table): Use `eq' rather than `equal' to merge ranges.
	(map_char_table): Remove unused vars `c' and `i'.
	* lisp.h (Foptimize_char_table): Adjust declaration.
	* charset.c (Fclear_charset_maps): Adjust call to Foptimize_char_table.

2008-05-30  Kenichi Handa  <handa@m17n.org>

	* font.c (Ffont_info): Define only if HAVE_WINDOW_SYSTEM is defined.
	(syms_of_font): Defsubr Sfont_info only if HAVE_WINDOW_SYSTEM is
	defined.

2008-05-30  Stefan Monnier  <monnier@iro.umontreal.ca>

	* data.c (Fmake_variable_buffer_local, Fmake_local_variable)
	(Fmake_variable_frame_local): Disallow mixing buffer-local and
	frame-local settings for the same variable.

2008-05-30  Kenichi Handa  <handa@m17n.org>

	* fontset.c (Ffont_info): Move to font.c.
	(syms_of_fontset): Delete defsubr of Sfont_info.

	* font.c (font_style_to_value, font_score): Delete casting of the
	args to xstcasecmp.
	(register_font_driver): Increment num_font_drivers only when
	registering the driver globally.
	(Ffont_info): Move from fontset.c.  Handle a font object too.
	(syms_of_font): Defsubr Sfont_info.

2008-05-29  Kenichi Handa  <handa@m17n.org>

	* coding.h (enum define_coding_utf8_arg_index): New enum.
	(enum coding_attr_index): Change coding_attr_utf_16_bom to
	coding_attr_utf_bom.
	(enum utf_bom_type): Rename from utf_16_bom_type.
	(struct utf_16_spec): Adjust for the above change.
	(struct coding_system): Add utf_8_bom in `spec' union.

	* coding.c (CODING_UTF_8_BOM): New macro.
	(enum coding_category): Delete coding_category_utf_8, add
	coding_category_utf_8_auto, coding_category_utf_8_nosig, and
	coding_category_utf_8_sig.
	(CATEGORY_MASK_UTF_8): Delete it.
	(CATEGORY_MASK_UTF_8_AUTO, CATEGORY_MASK_UTF_8_NOSIG)
	(CATEGORY_MASK_UTF_8_SIG): New macros.
	(CATEGORY_MASK_ANY): Delete CATEGORY_MASK_UTF_8, add
	CATEGORY_MASK_UTF_8_AUTO, CATEGORY_MASK_UTF_8_NOSIG, and
	CATEGORY_MASK_UTF_8_SIG.
	(CATEGORY_MASK_UTF_8): New macro.
	(UTF_BOM, UTF_8_BOM_1, UTF_8_BOM_2, UTF_8_BOM_3): New macros.
	(detect_coding_utf_8): Check BOM.
	(decode_coding_utf_8, encode_coding_utf_8): Handle BOM.
	(decode_coding_utf_16): Adjust for the change of enum utf_bom_type.
	(encode_coding_utf_16): Likewise.
	(setup_coding_system): Likewise.  Set CODING_UTF_8_BOM (coding).
	(detect_coding, detect_coding_system): Handle utf-8-auto.
	(Fdefine_coding_system_internal): Handle `bom' property for utf-8.
	(syms_of_coding): Fix setting up of Vcoding_category_table.

2008-05-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	* process.c (Faccept_process_output): If `millisec' is non-nil,
	`seconds' default to 0.
	(wait_reading_process_output): Also return non-nil if we read output
	from a non-running process.

2008-05-29  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_open_internal): Prefer truetype fonts unless
	`raster' specified.
	(add_font_entity_to_list): Allow non-opentype truetype fonts back
	in the uniscribe backend, but disallow any font that has no
	unicode subrange support.

2008-05-29  Juanma Barranquero  <lekktu@gmail.com>

	* xfaces.c (Fx_list_fonts, Finternal_copy_lisp_face):
	Fix typos in docstrings.

2008-05-29  Kenichi Handa  <handa@m17n.org>

	* xfaces.c (Fx_list_fonts): Make it return a list of font names.
	(Fx_family_fonts): Set frame correctly.

2008-05-28  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (x_draw_glyph_string): Use clipmask if specified.

2008-05-28  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Fwrite_region): Delay the defaulting to beg&z to after
	calling build_annotations.

2008-05-28  Juanma Barranquero  <lekktu@gmail.com>

	* coding.c (Fdecode_coding_region, Fencode_coding_region)
	(Fencode_coding_string):
	(syms_of_coding) <coding-system-for-read, coding-system-for-write>:
	<latin-extra-code-table>: Fix typos in docstrings.
	(syms_of_coding) <coding-system-alist>: Doc fix.
	(syms_of_coding) <translation-table-for-input>: Reflow docstring.

2008-05-28  Kenichi Handa  <handa@m17n.org>

	* fontset.c (Ffont_info): Don't call font_close_object.

	* font.c (font_parse_family_registry): Use Ffont_put to validate
	foundry and family.
	(font_delete_unmatched): Don't check spacing.
	(font_list_entities): Add spacing to the spec to list fonts.

	* ftfont.c (ftfont_spec_pattern): Don't set FC_SPACING to pattern.
	(ftfont_list): Check spacing here.  Don't include FC_CHARSET in objset.

	* coding.c (encode_coding_raw_text): Fix previous change.
	(encode_coding_object): When the dst_object is a buffer and is
	different from src_object, move gap to PT.

2008-05-27  Chong Yidong  <cyd@stupidchicken.com>

	* xterm.c (x_draw_glyph_string): If a clipmask is specified, use it.

2008-05-27  Stefan Monnier  <monnier@iro.umontreal.ca>

	* coding.c (encode_coding_raw_text): Set coding->produced_char for
	all branches.  Compute it differently.

	* xdisp.c [!HAVE_WINDOW_SYSTEM]: Include font.h for --without-x.

2008-05-27  Juanma Barranquero  <lekktu@gmail.com>

	* w32font.c (compute_metrics): Rewrite an "else { if () ... else ... }"
	into "else if () ... else ...".

2008-05-27  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_open_internal): Determine if glyph indices
	are likely to work here.

2008-05-27  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (draw_glyphs): If mouse-highlighting is on, attempt to
	draw overlap glyphs with appropriate highlighting.

2008-05-27  Kenichi Handa  <handa@m17n.org>

	* xfont.c (xfont_open): Fix calculation of font->average_width.

2008-05-27  Stefan Monnier  <monnier@iro.umontreal.ca>

	* casefiddle.c (casify_object): Try to guess better whether the
	argument is a byte or a char.

2008-05-26  Andreas Schwab  <schwab@suse.de>

	* xselect.c (x_reply_selection_request): Properly handle format == 32.
	Always send multiples of format size.

	* xterm.c (x_set_frame_alpha): Fix type mismatch.

2008-05-26  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_text_extents): Zero whole metrics struct first.
	(compute_metrics): Don't set failure if we just cleared the cache.
	(w32_weight_table): Remove unused variable.
	(w32_enumfont_pattern_entity): Use FONT_SPACING_CHARCELL for
	backwards compatibility.

2008-05-25  Kenichi Handa  <handa@m17n.org>

	* w32term.c (x_draw_glyph_string):
	* xterm.c (x_draw_glyph_string): Fix calculation of underline position.

	* xfaces.c: Delete unused function prototypes.
	(xstrlwr, font_frame): Delete them.
	(clear_face_cache): Delete unused variable.

	* xftfont.c (xftfont_open): Delete unused variable.
	If underline_thickness is not 1, adjust underline_position.

	* ftxfont.c (ftxfont_open): Delete unused variable.

	* fontset.c (face_for_char): Optimize for the case of no charset
	property.

	* font.c (LGSTRING_HEADER_SIZE, LGSTRING_GLYPH_SIZE)
	(check_gstring, check_otf_features, otf_list, otf_tag_symbol)
	(otf_open, font_otf_capability, generate_otf_features)
	(font_otf_DeviceTable, font_otf_ValueRecord, font_otf_Anchor):
	Comment out by surrounding "#if 0" and "#endif" for the moment.
	(Ffont_drive_otf, Ffont_otf_alternates): Likewise.
	(syms_of_font): Codes for accessing above commented out.

2008-05-24  Eli Zaretskii  <eliz@gnu.org>

	* w32proc.c: Include dispextern.h.

	* w32.c: Include dispextern.h.

2008-05-23  Juanma Barranquero  <lekktu@gmail.com>

	* charset.c (Fencode_char, Fsplit_char): Doc fixes.
	(Fget_unused_iso_final_char, Fdecode_char, Fiso_charset):
	Fix typos in docstrings.

2008-05-23  Jason Rumney  <jasonr@gnu.org>

	* xsmfns.c: Remove includes that are already included by config.h.

2008-05-23  Kenichi Handa  <handa@m17n.org>

	* charset.c (Qemacs, charset_emacs): New variables.
	(char_charset): Fix for non-Unicode characters.
	(syms_of_charset): Define charset_emacs.

	* w32term.c (x_draw_glyph_string): Be sure to update
	s->underline_thickness and s->underline_position.  Be sure to draw
	underline within the current line area.

	* xterm.c (x_draw_glyph_string): Be sure to update
	s->underline_thickness and s->underline_position.  Be sure to draw
	underline within the current line area.

	* fontset.c: Delete unused variables and add casting for char *
	throughout the file.
	(fontset_font): Try the fallback fonts of the current fontset
	before consulting the default fontset.

	* ftfont.c (ftfont_spec_pattern): Free charset if necessary.

	* xfont.c (xfont_list_pattern): Free names returned from XListFonts.

2008-05-22  Jason Rumney  <jasonr@gnu.org>

	* font.c: Don't include strings.h.

	* dispextern.h, xfaces.c (xstrcasecmp): Rename from xstricmp.

	* dosfns.c, fileio.c, font.c, fontset.c, image.c, macfns.c:
	* macterm.c, process.c, w32.c, w32fns.c, w32proc.c, xfaces.c:
	* xfns.c, xfont.c: All callers of stricmp and strcasecmp changed
	to call xstrcasecmp.

	* xfont.c (xfont_list_pattern, compare_font_names): Use xstrcasecmp.

	* fontset.c (fs_query_fontset): Use xstrcasecmp.

	* font.c (font_style_to_value, font_score): Use xstrcasecmp.

	* dosfns.c (msdos_stdcolor_idx): Use xstrcasecmp.

2008-05-22  Kenichi Handa  <handa@m17n.org>

	* puresize.h (BASE_PURESIZE): Increase to 1220000.

	* font.c (font_prop_validate_style): Adjust for the format
	change of font_style_table.

	* w32font.c (w32font_open_internal): Call Ffont_xlfd_name with
	two args.

	* xfaces.c (x_update_menu_appearance): Call Ffont_xlfd_name with
	two args.

2008-05-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	* minibuf.c (keys_of_minibuf): Delete.
	* lisp.h (keys_of_minibuf): Delete.
	* emacs.c (main): Don't call keys_of_minibuf.

2008-05-22  Kenichi Handa  <handa@m17n.org>

	* ftfont.c (ftfont_resolve_generic_family): Rename from
	ftfont_list_generic_family.  Return a single family for each
	generic family.
	(ftfont_spec_pattern): Add FC_FAMILY to pattern.
	(ftfont_list): Adjust for the change of ftfont_resolve_generic_family.
	Call font_add_log.
	(ftfont_match): Call font_add_log.

	* font.h (Ffont_xlfd_name): EXFUN adjusted.
	(FONT_DEBUG): Define it.
	(font_add_log): Extern it.
	(font_assert): Rename from xassert.

	* xfont.c (xfont_get_pcm): Change xassert to font_assert.
	(xfont_list_family): Call font_add_log.
	(xfont_match): Likewise.
	(memq_no_quit): Delete.

	* fontset.c (fontset_from_font, Ffontset_info): Add the 2nd arg in
	call of Ffont_xlfd_name.

	* xfaces.c (struct table_entry, slant_table, weight_table)
	(swidth_table): Move to font.c.

	* font.c: Checking of FONT_DEBUG is moved to font.h.  All calls of
	xassert are changed to font_assert.  Delete many unused variables.
	(Vfont_weight_table, Vfont_slant_table, Vfont_width_table):
	New variables.
	(struct table_entry): Move from xfaces.c and modified.
	(weight_table, slant_table, width_table): Move from xfaces.c and
	contents adjusted for the change of struct table_entry.
	(font_style_to_value, font_style_symbolic): Adjust for the
	format change of font_style_table.
	(font_parse_family_registry): Don't overwrite existing foundry and
	family of font_spec.
	(font_score): Fix calculation of diff for sizes.
	(font_sort_entites): Call font_add_log.
	(font_delete_unmatched): Return a newly created list.
	(font_list_entities): Fix previous change.  Call font_add_log.
	(font_matching_entity, font_open_entity, font_close_entity):
	Call font_add_log.
	(Ffont_xlfd_name): New arg FOLD-WILDCARDS.
	(Finternal_set_font_style_table): Delete.
	(BUILD_STYLE_TABLE): New macro.
	(build_style_table): New function.
	(Vfont_log, font_log_env_checked): New variables.
	(font_add_log): New function.
	(syms_of_font): Delete defsubr Sinternal_set_font_style_table.
	Declare Lisp variables "font-weight-table", "font-slant-table",
	"font-width-table", and "font-log".  Initialize font_style_table.

2008-05-21  Dan Nicolaescu  <dann@ics.uci.edu>

	* xterm.c (x_set_frame_alpha): Move declarations before statements.

2008-05-21  Seiji Zenitani  <zenitani@mac.com>
	    Ryo Yoshitake  <ryo@shiftmode.net>

	* frame.c (Qalpha): Add a new frame parameter `alpha'.
	(Vframe_alpha_lower_limit): New variable.
	(x_set_alpha): New function.

	* frame.h (Qalpha, Vframe_parameter_lower_limit): Export them.

	* xfns.c (x-create-frame, Qalpha):
	Initialize the frame parameter `alpha'.
	* xterm.c (OPAQUE, OPACITY): New.
	(x_set_frame_alpha): New function.
	(frame_highlight, frame_unhighlight): Call x_set_frame_alpha.

	* macfns.c (mac_frame_parm_handlers): A null handler for x_set_alpha.
	* w32fns.c (w32_frame_parm_handlers): Likewise.

2008-05-20  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (add_font_entity_to_list): Don't add non-opentype
	truetype fonts to opentype list.

2008-05-20  Juanma Barranquero  <lekktu@gmail.com>

	* fontset.c (Ffontset_info): Doc fix.
	(syms_of_fontset) <font-encoding-charset-alist, use-default-ascent>:
	<ignore-relative-composition>: Fix typos in docstrings.

	* font.c (syms-of-font) <font-encoding-alist>:
	(Ffontp, Ffont_make_gstring): Fix typos in docstrings.
	(Flist_fonts, Ffont_family_list, Ffont_fill_gstring, Fquery_font)
	(Ffont_otf_alternates): Doc fixes.

2008-05-20  Kenichi Handa  <handa@m17n.org>

	* Makefile.in (FONTSRC): Delete it.  Change all $(FONTSRC) to
	font.h through out the file.
	(FONT_DRIVERS): Rename from FONTOBJ.
	(obj): Change $(FONTOBJ) to $(FONT_DRIVERS).  Add font.o.
	(SOME_MACHINE_OBJECTS): Change $(FONTOBJ) to $(FONT_DRIVERS).

	* emacs.c (main): Call syms_of_font unconditionally.

	* font.h (find_font_encoding): Extern it.

	* font.c (Vfont_encoding_alist, find_font_encoding): Move from
	fontset.c.
	(font_pixel_size)[! HAVE_WINDOW_SYSTEM]: Return 1.
	(font_open_entity): Update FRAME_X_DISPLAY_INFO (f)->n_fonts,
	FRAME_SMALLEST_CHAR_WIDTH (f), and FRAME_SMALLEST_FONT_HEIGHT (f)
	only when HAVE_WINDOW_SYSTEM is defined.
	(font_close_object): Update FRAME_X_DISPLAY_INFO (f)->n_fonts only
	when HAVE_WINDOW_SYSTEM is defined.

	* fontset.c (Vfont_encoding_alist, find_font_encoding): Move to font.c.
	(syms_of_fontset): Move declaration of font-encoding-alist to font.c.

	* xfaces.c: Include font.h unconditionally.
	(merge_face_ref, merge_face_vectors)
	(Finternal_set_lisp_face_attribute): Cancel the previous change.

2008-05-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (select_frame_for_redisplay): Adjust for last change to
	indirect_variable.
	* eval.c (lisp_indirect_variable): New fun.
	(Fuser_variable_p): Use it.

2008-05-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp.h (indirect_variable):
	* data.c (indirect_variable, let_shadows_buffer_binding_p):
	Use Lisp_Symbol pointers rather than Lisp_Object.
	Adjust callers.
	* buffer.c (buffer_slot_type_mismatch): Use wrong-type-argument.
	To this end, change calling-convention.

	* minibuf.c (Finternal_complete_buffer): Only strip out hidden buffers
	if some non-hidden buffers are selected by string&pred.

2008-05-19  Chong Yidong  <cyd@stupidchicken.com>

	* process.c (wait_reading_process_output): Always check status
	when in batch mode.

2008-05-19  Kenichi Handa  <handa@m17n.org>

	* font.c (font_list_entities): Fix handling of cache.
	(font_matching_entity): Likewise.

	* ftfont.c (cs_iso8859_1): Delete.
	(ft_face_cache): New variable.
	(struct ftfont_info): New member fc_charset_idx.
	(ftfont_build_basic_charsets): Delete.
	(fc_charset_table): New variable.
	(ftfont_pattern_entity): New arg fc_charset_idx.  Store (FILENAME
	. FC_CHARSET_IDX) as :font-entity property in the font entity.
	Callers changed.
	(ftfont_lookup_cache, ftfont_get_charset): New functions.
	(ftfont_spec_pattern): New argument fc_charset_idx.
	Check registry more rigidly.  Change callers.
	(ftfont_open, ftfont_close, ftfont_has_char): Adjust for the
	change of :font-entity property of the font.

	* xftfont.c (xftfont_open): Adjust for the change of :font-entity
	property of the font.

2008-05-18  Juanma Barranquero  <lekktu@gmail.com>

	* coding.c (Fcoding_system_p): Rename argument to match docstring.
	(Funencodable_char_position, Fcheck_coding_systems_region)
	(Fdecode_coding_string, Fencode_coding_string): Fix typos in docstrings.
	(Fdetect_coding_region, Fdetect_coding_string, Fencode_coding_region)
	(Ffind_operation_coding_system, Fset_coding_system_priority)
	(Fcoding_system_eol_type): Doc fixes.

2008-05-17  Glenn Morris  <rgm@gnu.org>

	* sysdep.c (child_setup_tty): Handle systems with NLDLY, without FFDLY.

2008-05-16  Eli Zaretskii  <eliz@gnu.org>

	* dired.c (Ffile_attributes): Shut up GCC warnings about st_uid
	and st_gid.

	* frame.c (Fdelete_frame): Don't call font_update_drivers if
	HAVE_WINDOW_SYSTEM is not defined.

	* xfaces.c (merge_face_ref, merge_face_vectors)
	(Finternal_set_lisp_face_attribute): Use FONT_*_INDEX only when
	HAVE_WINDOW_SYSTEM is defined.
	(Fface_font): Fix non-HAVE_WINDOW_SYSTEM case.

2008-05-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keyboard.c (parse_menu_item): Do not cache key shortcut any more.

2008-05-15  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (x_draw_relief_rect): Remove unused variable `dpy'.

2008-05-15  Kenichi Handa  <handa@m17n.org>

	* font.c (font_find_for_lface): Reflect LFACE_FONT in the font
	preference.

2008-05-15  Glenn Morris  <rgm@gnu.org>

	* emacs.c (USAGE1, standard_args): Remove -disable-font-backend.

2008-05-15  Chong Yidong  <cyd@stupidchicken.com>

	* fns.c (init_fns): Don't initialize weak_hash_tables here.
	(init_weak_hash_tables): New fun.  Initialize weak_hash_tables.

	* alloc.c (init_alloc_once): Call init_weak_hash_tables.

2008-05-15  Kenichi Handa  <handa@m17n.org>

	* ftfont.c (ftfont_list): Downcase family name to check generic
	families.

	* xfaces.c (Finternal_set_lisp_face_attribute): Be sure to make a
	font-spec for QCfont value.

	* fontset.c (Fnew_fontset): Call font_unparse_xlfd with 256-byte
	buffer.  Check the return value of it.

2008-05-14  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (w32_get_glyph_overhangs): Remove.
	(w32_redisplay_interface): Use x_get_glyph_overhangs instead.

2008-05-14  Kenichi Handa  <handa@m17n.org>

	* font.c (font_prop_validate): Make nil a valid value.
	(font_clear_cache): Check if the cached vector of entities is nil
	or not.

2008-05-14  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* emacs.c (main_thread): Conditionalize on
	FORWARD_SIGNAL_TO_MAIN_THREAD instead of HAVE_GTK_AND_PTHREAD.
	(main) [FORWARD_SIGNAL_TO_MAIN_THREAD]: Initialize it.

	* syssignal.h (FORWARD_SIGNAL_TO_MAIN_THREAD): New define.
	(main_thread, SIGNAL_THREAD_CHECK): Conditionalize on
	FORWARD_SIGNAL_TO_MAIN_THREAD instead of HAVE_GTK_AND_PTHREAD.

2008-05-14  Kenichi Handa  <handa@m17n.org>

	* coding.c (detect_coding_iso_2022): Ignore a coding category that
	has no corresponding coding system.

2008-05-14  Jason Rumney  <jasonr@gnu.org>

	* font.h (struct font) [WINDOWSNT]: Remove codepage member.

	* w32font.h (w32font_open_internal): Update declaration.

	* w32font.c (w32font_open_internal): Change last argument from
	w32font_info struct to font object.  Fill in font object from
	font_entity.  Get Outline metrics if possible.  Use them to
	calculate underline position and thickness.  Use xlfd name as name
	property.  Don't set codepage.
	(w32font_open): Pass font_object to w32font_open_internal.  Don't
	update dpyinfo->smallest_font_height and dpyinfo->smallest_char_width.
	(w32font_draw): Use s->font.
	(clear_cached_metrics): Don't clear non-existent blocks.

	* w32term.c (w32_compute_glyph_string_overhangs): Don't compute if
	font was not found.
	(x_draw_glyph_string): Use underline position and thickness from font.

	* w32uniscribe.c (uniscribe_open): Pass font_object to
	w32font_open_internal.

2008-05-14  Kenichi Handa  <handa@m17n.org>

	These changes are to delete all legacy font-handling codes, and
	make Emacs use only font-backends.

	* Makefile.in: Delete USE_FONT_BACKEND conditionals.
	(frame.o, image.o, print.o): Depend on $(FONTSRC).

	* makefile.w32-in (WIN32OBJ): Add w32reg.$(O), remove w32bdf.$(O).

	* charset.h (Vcharset_non_preferred_head)
	(Vcurrent_iso639_language): Extern them.

	* charset.c (Vcharset_non_preferred_head): New variable.
	(Vcurrent_iso639_language): New variable.
	(syms_of_charset): Declare it as a Lisp variable.
	(char_charset): Don't check non preferred charsets.  As a last
	resort, return charset_unicode.
	(Fset_charset_priority): Update Vcharset_non_preferred_head.

	* composite.c: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.  Don't check enable_font_backend.  Delete all codes
	used only when USE_FONT_BACKEND is not defined.

	* dispextern.h (struct glyph_string): Change type of `font' to
	`struct font *'.
	(struct glyph_string): New member underline_position and
	underline_thickness.
	(enum lface_attribute_index): Remove LFACE_AVGWIDTH_INDEX.
	(struct face): Change type of `font' to `struct font *'.  Remove
	members `font_name', `font_info_id'.
	(per_char_metric, encode_char): Delete externs.
	(calc_pixel_width_or_height): Adjust the prototype.

	* emacs.c (enable_font_backend): Delete extern.
	(main): Don't set enable_font_backend.  Don't check the command
	line argument "-disable-font-backend".

	* font.h (Qfont_spec, Qfont_entity, Qfont_object): Extern them.
	(enum font_property_index): New members FONT_DPI_INDEX,
	FONT_SPACING_INDEX, FONT_AVGWIDTH_INDEX, FONT_NAME_INDEX,
	FONT_FULLNAME_INDEX, FONT_FILE_INDEX, FONT_FORMAT_INDEX,
	FONT_OBJECT_MAX.  Delete FONT_FRAME_INDEX.
	(FONT_WEIGHT_NUMERIC, FONT_SLANT_NUMERIC, FONT_WIDTH_NUMERIC)
	(FONT_WEIGHT_SYMBOLIC, FONT_SLANT_SYMBOLIC, FONT_WIDTH_SYMBOLIC)
	(FONT_WEIGHT_FOR_FACE, FONT_SLANT_FOR_FACE, FONT_WIDTH_FOR_FACE)
	(FONT_WEIGHT_NAME_NUMERIC, FONT_SLANT_NAME_NUMERIC)
	(FONT_WIDTH_NAME_NUMERIC, FONT_SET_STYLE): New macros.
	(struct font_spec, struct font_entity): New structs.
	(FONT_ENCODING_NOT_DECIDED): Moved from fontset.h.
	(struct font): Many members from old "struct font_info" moved to
	here.  Members font and entity deleted.
	(FONT_SPEC_P, FONT_ENTITY_P, FONT_OBJECT_P, FONTP): Modified for
	the new font-related objects.
	(CHECK_FONT_SPEC, CHECK_FONT_ENTITY, CHECK_FONT_OBJECT)
	(CHECK_FONT_GET_OBJECT): Likewise.
	(XFONT_SPEC, XFONT_ENTITY, XFONT_OBJECT, XSETFONT): New macros.
	(PT_PER_INCH, POINT_TO_PIXEL, PIXEL_TO_POINT): Moved from font.h.
	(struct font_driver): New members case_sensitive anc check.  Type
	of the member list and open changed.
	(enable_font_backend, font_symbolic_weight, font_symbolic_slant)
	(font_symbolic_width, font_find_object, font_get_spec)
	(font_set_lface_from_name): Delete extern.
	(Fcopy_font_spec, Fmerge_font_spec, Ffont_family_list): New EXFUNs.

	* font.c: Include <strings.h>.
	(enable_font_backend): Delete it.
	(Qfont_spec, Qfont_entity, Qfont_object): New variables.
	(CHECK_VALIDATE_FONT_SPEC): Delete it.
	(PT_PER_INCH, POINT_TO_PIXEL, PIXEL_TO_POINT): Moved to font.h.
	(null_string): Delete it.
	(null_vector): Make it static.
	(font_family_alist): Delete it.
	(Qnormal): Extern it.
	(QCextra, QClanguage): Delete it.
	(QClang, QCavgwidth, QCfont_entity, QCfc_unknown_spec): New variables.
	(font_make_spec, font_make_entity, font_make_object)
	(font_intern_prop): Renamed from intern_downcase.  Don't downcase
	the string.  Callers changed.
	(font_pixel_size): Adjusted for the format change of font-related
	objects.
	(prop_name_to_numeric, prop_numeric_to_name): Delete them.
	(font_style_to_value, font_style_symbolic): New function.
	(build_font_family_alist): Delete it.
	(font_registry_charsets): Use Fassoc_string instead of
	assq_no_quit.
	(font_prop_validate_symbol): Don't return null_string.
	(font_prop_validate_style): Adjusted for the change of
	style-related values in a font vector.
	(font_property_table): Delete entries for QClanguage and
	QCantialias, add entries for QCavgwidth.
	(get_font_prop_index): Delete the 2nd argument FROM.
	(font_prop_validate): Arguments changed.
	(font_put_extra): Adjusted for the change of font-related objects.
	(font_expand_wildcards, font_parse_xlfd, font_unparse_xlfd)
	(font_parse_fcname, font_unparse_fcname)
	(font_prepare_composition): Likewise.
	(font_parse_family_registry): Renamed from font_merge_old_spec.
	(otf_open): Delete the 1st arg entity.
	(font_otf_capability): Adjusted for the above change.
	(font_score): New arg alternate_families.  Adjusted for the change
	of font-related objects.
	(font_sort_entites): New arg best_only.
	(font_symbolic_weight, font_symbolic_slant, font_symbolic_width):
	Delete them.
	(font_match_p): Check alternate families.
	(font_find_object): Delete it.
	(font_check_object): New function.
	(font_clear_cache): Adjusted for the change of font-related objects.
	(font_delete_unmatched): New arg.
	(font_list_entities): Call font_driver->list with a spec that
	doesn't specify style-related properties.
	(font_matching_entity): Arguments changed.  Caller changed.
	(font_open_entity): Adjusted for the change of font-related objects.
	(font_close_object, font_has_char, font_encode_char)
	(font_get_name, font_get_spec): Likewise.
	(font_spec_from_name, font_clear_prop, font_update_lface):
	New functions.
	(font_find_for_lface, font_open_for_lface, font_load_for_lface)
	(font_prepare_for_face, font_done_for_face, font_open_by_name)
	(font_at): Adjusted for the change of font-related objects.
	(font_range): New function.
	(Ffontp, Ffont_spec, Ffont_get, Ffont_put, Flist_fonts)
	(Ffont_xlfd_name): Adjusted for the change of font-related objects.
	(Fcopy_font_spec, Fmerge_font_spec): New function.
	(Ffont_family_list): Renamed from list-families.
	(Finternal_set_font_style_table): Arguments changed.
	(Ffont_fill_gstring, Ffont_shape_text, Fopen_font)
	(Ffont_drive_otf, Fquery_font, Ffont_match_p): Adjusted for the
	change of font-related objects.
	(syms_of_font): Delete "ifdef USE_FONT_BACKEND".  DEFSYM new symbols.

	* fontset.h (struct font_info): Delete it.  Most members go to
	struct font.
	(FONT_ENCODING_NOT_DECIDED): Moved to font.h.
	(enum FONT_SPEC_INDEX): Delete it.
	(font_info, list_fonts_func, load_font_func, query_font_func)
	(set_frame_fontset_func, find_ccl_program_func)
	(get_font_repertory_func, new_fontset_from_font_name): Delete
	externs.
	(fontset_from_font_name): Extern it.
	(FS_LOAD_FONT, FONT_INFO_ID, FONT_INFO_FROM_ID)
	(FONT_INFO_FROM_FACE): Deleted.
	(face_for_font): Adjust prototype.

	* fontset.c: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.  Don't check enable_font_backend.  Delete all codes
	used only when USE_FONT_BACKEND is not defined.
	(get_font_info_func, list_font_func, load_font_func)
	(query_font_func, set_frame_fontset_func, find_ccl_program_func)
	(get_font_repertory_func): Delete them.
	(FONTSET_SPEC, FONT_DEF_NEW, FONT_DEF_SPEC, FONT_DEF_ENCODING)
	(FONT_DEF_REPERTORY, RFONT_DEF_FACE, RFONT_DEF_SET_FACE)
	(RFONT_DEF_FONT_DEF, RFONT_DEF_SPEC, RFONT_DEF_REPERTORY)
	(RFONT_DEF_OBJECT, RFONT_DEF_SET_OBJECT, RFONT_DEF_SCORE)
	(RFONT_DEF_SET_SCORE, RFONT_DEF_NEW): New macros.
	(fontset_compare_rfontdef): New function.
	(reorder_font_vector): Remove the argument CHARSET-ID.  Sort
	ront-defs by qsort.  Adjusted for the change of font-group vector.
	(load_font_get_repertory): Deleted.
	(fontset_find_font): Use new macros to ref/set elements of
	font-def and rfont-def.
	(fontset_font): Fix the timing of remembering that no font for C.
	(free_face_fontset): Do nothing if the face has no fontset.
	(face_suitable_for_char_p): Use new macros to ref/set elements of
	rfont-def.
	(face_for_char): Likewise.  Call face_for_char with font_object.
	(fs_load_font): Delete.  Delete #pragma surrounding it.
	(fs_query_fontset): Use strcasecmp instead of strcmp.
	(generate_ascii_font_name): Adjusted for the format change of
	font-spec.
	(Fset_fontset_font): Likewise.  Use new macros to set elements of
	font-def.
	(Fnew_fontset): Use font_unparse_xlfd to generate
	FONTSET_ASCII (fontset).
	(new_fontset_from_font_name): Deleted.
	(fontset_from_font): Renamed from new_fontset_from_font.  Check if
	a fontset is already created for the font.  FIx updating of
	Vfontset_alias_alist.
	(fontset_ascii_font): Deleted.
	(Ffont_info): Adjusted for the format change of font-spec.
	(Finternal_char_font): Likewise.
	(Ffontset_info): Likewise.
	(syms_of_fontset): Don't check load_font_func.

	* fns.c (internal_equal): Handle PREV_FONT.

	* frame.h: Delete USE_FONT_BACKEND conditional.

	* frame.c: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.  Don't check enable_font_backend.  Delete all codes
	used only when USE_FONT_BACKEND is not defined.
	(x_set_font): Call x_new_font, not x_new_fontset2.
	(x_set_font_backend): Use FRAME_FONT macro to check if a font is
	already set for the frame.

	* ftfont.c (ftfont_pattern_entity): Argument FRAME removed.  Make
	a font-entity by font_make_entity.  Use font_intern_prop instead
	of intern_downcase.  Use FONT_SET_STYLE to set a style-related
	font property.  If a font is scalable, set avgwidth property to 0.
	Set font-entity property by font_put_extra.
	(ftfont_list_generic_family): Argument SPEC and REGISTRY removed.
	(ffont_driver): Adjusted for the change of struct font_driver.
	(ftfont_spec_pattern): New function.
	(ftfont_list): Return a list, not vector.
	(ftfont_match): Use ftfont_spec_pattern to get a pattern.
	(ftfont_list_family): Don't downcase names.
	(ftfont_free_entity): Deleted.
	(ftfont_open): Return a font-ojbect.  Adjusted for the change of
	struct font.  Get underline_thickness and underline_position from
	font property.  Don't update dpyinfo->smallest_font_height and
	dpyinfo->smallest_char_width.
	(ftfont_close): Don't free `struct font'.
	(ftfont_has_char): Adjusted for the format change of font-entity.
	(ftfont_encode_char, ftfont_text_extents): Likewise.

	* ftxfont.c (ftxfont_list): Return a list, not vector.
	(ftxfont_open): Return a font-ojbect.  Adjusted for the change of
	struct font.  Get underline_thickness and underline_position from
	font property.  Don't update dpyinfo->smallest_font_height and
	dpyinfo->smallest_char_width.
	(ftxfont_close): Don't decrese FRAME_X_DISPLAY_INFO (f)->n_fonts.
	(ftxfont_draw): Adjusted for the change of struct font.

	* image.c (image_ascent): Don't include "charset.h".  Include
	"character.h" and "font.h".

	* lisp.h (enum pvec_type): New member PREV_FONT.
	(Fassoc_string): EXFUN it.

	* print.c: Include font.h.
	(print_object): Handle font-related objects.

	* xdisp.c: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.  Don't check enable_font_backend.  Delete all codes
	used only when USE_FONT_BACKEND is not defined.
	(handle_auto_composed_prop): Do nothing if it->f is not on a
	window system.  Check how many following characters can be
	displayed by the same font.
	(calc_pixel_width_or_height): Type of the 4th arg is changed to
	'struct font *'.
	(get_char_face_and_encoding): Assign the whole encoding task to
	the `encode-char' method of a font driver.
	(fill_composite_glyph_string): Adjusted for the change of `struct
	face' and `struct glyph_string'.
	(fill_glyph_string): Likewise.
	(get_per_char_metric): Arguments changed.
	(x_get_glyph_overhangs): Adjusted for the change of `struct face'
	and `struct glyph_string'.
	(produce_stretch_glyph, calc_line_height_property)
	(x_produce_glyphs): Likewise.

	* xfaces.c: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.  Don't check enable_font_backend.  Delete all codes
	used only when USE_FONT_BACKEND is not defined.  Use
	FONT_XXX_NAME_NUMERIC instead of face_numeric_xxx.
	(QCfoundry, QCadstyle, QCregistry, QCspacing, QCsize, QCavgwidth)
	(Qp): Extern them.
	(clear_font_table, load_face_font, xlfd_lookup_field_contents):
	Deleted.
	(struct font_name): Deleted.
	(xlfd_numeric_value, xlfd_symbolic_value): Deleted.
	(compare_fonts_by_sort_order): New function.
	(xlfd_numeric_slant, xlfd_symbolic_slant, xlfd_numeric_weight)
	(xlfd_symbolic_weight, xlfd_numeric_swidth, xlfd_symbolic_swidth):
	Deleted.
	(Fx_family_fonts): Use font_list_entities, and sort fonts by
	compare_fonts_by_sort_order.
	(Fx_font_family_list): Call Ffont_family_list.
	(face_numeric_value, face_numeric_weight, face_numeric_slant)
	(face_numeric_swidth, face_symbolic_value, face_symbolic_weight)
	(face_symbolic_slant, face_symbolic_swidth)
	(split_font_name_into_vector, build_font_name_from_vector)
	(xlfd_fixed_p, xlfd_point_size, pixel_point_size)
	(font_rescale_ratio, split_font_name, build_font_name)
	(free_font_names, sort_fonts, x_face_list_fonts)
	(face_font_available_p, sorted_font_list, cmp_font_names)
	(font_list_1, concat_font_list, font_list, remove_duplicates):
	Deleted.
	(Fx_list_fonts): Use Ffont_list.
	(LFACE_AVGWIDTH): Deleted.
	(check_lface_attrs): Don't check LFACE_AVGWIDTH.  Check LFACE_FONT
	by FONTP.
	(lface_fully_specified_p): Don't check LFACE_AVGWIDTH.
	(set_lface_from_font_name): Delete it.
	(set_lface_from_font): Renamed from
	set_lface_from_font_and_fontset.  Caller changed.  Don't set
	LFACE_AVGWIDTH.  Use FONT_XXX_FOR_FACE to get a symbol suitable
	for face.
	(merge_face_vectors): Copy font-spec if necessary.
	Clear properties of the font-spec if necessary.
	(merge_face_ref): Clear properties of the font-spec if necessary.
	(Finternal_set_lisp_face_attribute): Likewise.
	(set_font_frame_param): Use font_load_for_lface to load a
	font-object, and call Fmodify_frame_parameters with it.
	(x_update_menu_appearance): Don't check LFACE_AVGWIDTH.  Get XLFD
	font name by Ffont_xlfd_name.
	(Finternal_lisp_face_attribute_values): Don't check QCweight,
	QCslant, and QCwidth.
	(Fface_font): Get a font name from font->props[FONT_NAME_INDEX].
	(lface_same_font_attributes_p): Don't check LFACE_AVGWIDTH.
	Compare fonts by EQ.
	(lookup_non_ascii_face): Deleted.
	(face_for_font): The 2nd argument changed.
	(x_supports_face_attributes_p): Don't check LFACE_AVGWIDTH.
	Check atomic font properties by case insensitive.
	(realize_non_ascii_face): Set face->overstrike correctly.
	(realize_x_face): Likewise.  Check if LFACE_FONT is a font_object.
	(dump_realized_face): Get font name from
	font->props[FONT_NAME_INDEX].  Don't print font_info_id.

	* xfns.c: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.  Don't check enable_font_backend.  Delete all codes
	used only when USE_FONT_BACKEND is not defined.
	(xic_create_xfontset): Original code deleted and renamed from
	xic_create_xfontset2.  Use FRAME_FONT, not FRAME_FONT_OBJECT.
	(x_make_gc): Don't set GCFont in GCs.
	(Fx_create_frame) [USE_LUCID]: Set xlwmenu_default_font to a font
	opened by "fixed".
	(syms_of_xfns): Don't set get_font_info_func, load_font_func,
	find_ccl_program_func, query_font_func, set_frame_fontset_func,
	get_font_repertory_func.

	* xfont.c: Include <stdlib.h> and "ccl.h".
	(struct xfont_info): New structure.
	(xfont_query_font): Deleted.
	(xfont_find_ccl_program): Renamed from x_find_ccl_program and
	moved from xterm.c.
	(xfont_driver): Adjusted for the change of struct font_driver.
	(compare_font_names): New function.
	(xfont_list_pattern): Sort font names case insensitively.  Make
	font_entity by calling font_make_entity.  Avoid auto-scaled fonts.
	(xfont_list): Return a list, not vector.
	(xfont_match): If the font doesn't have QCname property, generate
	a name from the other font properties.
	(xfont_open): Return a font-ojbect.  Adjusted for the change of
	struct font.  Get underline_thickness and underline_position from
	font property.  Don't update dpyinfo->smallest_font_height and
	dpyinfo->smallest_char_width.
	(xfont_close): Don't free struct font.
	(xfont_prepare_face): Adjusted for the change of struct font.
	(xfont_done_face): Deleted.
	(xfont_has_char): Adjusted for the change of struct font.
	(xfont_encode_char, xfont_draw): Likewise.
	(xfont_check): New function.

	* xftfont.c (xftfont_list): Adjusted for the change of `list'
	callback function.
	(xftfont_match): Adjusted for the fontmat change of font-entity.
	(xftfont_open): Adjusted for the format change of font-entity and
	font-object.  Adjusted for the change of struct font.  Return a
	font-object.  Don't update dpyinfo->smallest_font_height and
	dpyinfo->smallest_char_width.
	(xftfont_close): Block input while calling XftFontClose.
	(xftfont_prepare_face): Don't block input while calling
	xftfont_get_colors.  Adjusted for the change of struct font.
	(xftfont_shape): Return value of error case fixed.

	* xrdb.c (x_load_resources): Don't setup a fontset resource.

	* xterm.h: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.
	(FONT_WIDTH): Return (f)->max_width.
	(struct x_display_info): Delete member `font'.
	(x_list_fonts, x_get_font_info, x_load_font, x_query_font)
	(x_find_ccl_program, x_get_font_repertory): Delete externs.
	(struct x_output): Change type of `font' to `struct font *'.

	* xterm.c: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.  Don't check enable_font_backend.  Delete all codes
	used only when USE_FONT_BACKEND is not defined.  Don't include ccl.h.
	(x_per_char_metric, x_encode_char): Deleted.
	(x_set_cursor_gc, x_set_mouse_face_gc): Don't set GCFont.
	(x_compute_glyph_string_overhangs): Adjusted for the change of
	`struct face'.
	(x_draw_glyph_string_foreground)
	(x_draw_composite_glyph_string_foreground): Likewise.
	(x_draw_glyph_string): Likewise.  Use font->underline_position and
	font->underline_thickness.
	(x_new_font): Renamed from x_new_fontset2.
	(x_new_fontset, x_get_font_info, x_list_fonts): Deleted.
	(x_check_font): Call `check' method of a font driver.
	(x_font_min_bounds, x_compute_min_glyph_bounds, x_load_font)
	(x_query_font, x_get_font_repertory): Deleted.
	(x_find_ccl_program): Renamed and moved to xfont.c.
	(x_redisplay_interface): Adjusted for the change of `struct
	redisplay_interface'.

	* w32fns.c: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.  Don't check enable_font_backend.  Delete all codes
	used only when USE_FONT_BACKEND is not defined.  Surround non-used
	code by "#ifdef OLD_FONT" and "endif".
	(Fw32_select_font): Use FONT_COMPAT to get old font structure.

	* w32font.h (struct w32font_info): New member.
	(FONT_COMPAT): New macro.
	(w32font_open_internal): Prototype adjusted.

	* w32gui.h (XGCValues): Surround `XFontStruct *font' by "if
	OLD_FONT" and "endif".

	* w32font.c: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.  Don't check enable_font_backend.  Delete all codes
	used only when USE_FONT_BACKEND is not defined.
	(w32font_open): Return a font-object.  Make a font-object by
	font_make_object.  Adjusted for the change of struct w32font_info.
	(w32font_close): Don't free struct font.  Adjusted for the change
	of struct w32font_info.
	(w32font_encode_char, w32font_text_extents, w32font_draw):
	Adjusted for the change of struct w32font_info.
	(w32font_draw): Likewise.
	(w32font_list_internal): Return a list, not vector.
	(w32font_open_internal): Change the 4th arg to font-object.
	Adjusted for the change of struct w32font_info and font-object format.
	(add_font_name_to_list): Don't downcase names.
	(w32_enumfont_pattern_entity): Make a font-entity by
	font_make_entity.  Adjusted for the format change of font-entity.
	Use FONT_SET_STYLE to set a style-related font property.  If a
	font is scalable, set avgwidth property to 0.  Set font-entity
	property by font_put_extra.
	(font_matches_spec): Adjusted for the format change of font-entity.
	(w32_weight_table, w32_decode_weight): New variables.
	(w32_encode_weight): New function.
	(fill_in_logfont): Adjusted for the format change of font-spec.
	(w32font_full_name): Use FONT_WEIGHT_SYMBOLIC to get a symbol
	weight value.
	(w32font_driver): Adjusted for the change of struct font_driver.

	* w32term.h: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.  Don't check enable_font_backend.  Surround non-used
	code by "#ifdef OLD_FONT" and "endif".
	(FONT_WIDTH, FONT_HEIGHT, FONT_BASE, FONT_DESCENT)
	(FONT_AVG_WIDTH): Adjusted for the change of struct font.

	* w32term.c: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.  Don't check enable_font_backend.  Delete all codes
	used only when USE_FONT_BACKEND is not defined.  Surround non-used
	code by "#ifdef OLD_FONT" and "endif".

	* w32uniscribe.c: Delete USE_FONT_BACKEND conditional.
	(uniscribe_open): Return value changed to font-object.
	Adjusted for the format change of font-object.
	(uniscribe_otf_capability): Adjusted for the change of struct font.
	(add_opentype_font_name_to_list): Don't downcase names.
	(uniscribe_font_driver): Adjusted for the change of struct
	font_driver.

2008-05-13  Chong Yidong  <cyd@stupidchicken.com>

	* dispnew.c (update_frame_1): Check if tty output is still valid
	before flushing it.

2008-05-13  Jan Djärv  <jan.h.d@swipnet.se>

	* xterm.c (handle_one_xevent): Don't pass buttons higher than 3
	to Gtk+ menus.

2008-05-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	* dired.c (file_name_completion): Tweak the code so as to always do it
	in a single pass.  Tighten the scope of some variables.

	* dired.c (Qdefault_directory): New var.
	(file_name_completion): Use it instead of Fexpand_file_name.
	(syms_of_dired): Initialize it.

2008-05-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (double_dollars): Remove dead code.

2008-05-10  Eli Zaretskii  <eliz@gnu.org>

	* dired.c (Ffile_attributes, Fdirectory_files_and_attributes):
	Mention w32-get-true-file-attributes in doc string.

	* w32proc.c (syms_of_ntproc) <w32-get-true-file-attributes>: Doc fix.

2008-05-09  Glenn Morris  <rgm@gnu.org>

	* fileio.c (Fread_file_name): Remove reference to insdef, deleted
	2008-04-23.

2008-05-09  Eli Zaretskii  <eliz@gnu.org>

	Support for reporting owner and group of each file on MS-Windows:
	* dired.c (stat_uname, stat_gname): New functions, with special
	implementation for w32.
	(Ffile_attributes): Use them instead of getpwuid and getgrgid.

	* w32.c: Rename the_passwd_* to dflt_passwd_*.
	(dflt_group_name): New static variable.
	(dflt_group): Rename from the_group.
	(init_user_info): Init dflt_group fields.  Get user's group name
	from LookupAccountSid.
	(g_b_init_get_file_security, g_b_init_get_security_descriptor_owner)
	(g_b_init_get_security_descriptor_group, g_b_init_is_valid_sid):
	New initialization states.
	(globals_of_w32): Initialize them to zero.  Initialize the default
	group name to "None".
	(GetFileSecurity_Name): New global var, the name of the function
	to call for GetFileSecurity.
	(GetFileSecurity_Proc, GetSecurityDescriptorOwner_Proc)
	(GetSecurityDescriptorGroup_Proc, IsValidSid_Proc): New typedefs.
	(get_file_security, get_security_descriptor_owner)
	(get_security_descriptor_group, is_valid_sid)
	(get_file_security_desc, get_rid, get_name_and_id)
	(get_file_owner_and_group): New functions.
	(stat): Use get_file_security_desc and get_file_owner_and_group to
	report the owner and primary group of each file.  Don't ignore the
	high 32 bits of file's size, now that st_size is 64-bit wide.
	Fix test when to get true file attributes.
	(init_user_info): Use get_rid instead of equivalent inline code.
	(fstat): Don't ignore the high 32 bits of file's size.

2008-05-09  Chong Yidong  <cyd@stupidchicken.com>

	* image.c (png_load): Use correct bit-depth for setting background
	color.

2008-05-08  Eli Zaretskii  <eliz@gnu.org>

	* Makefile.in (lisp, shortlisp): Rename epa-file-hook.elc to
	epa-hook.elc.

2008-05-08  Juanma Barranquero  <lekktu@gmail.com>

	* font.c (Ffont_match_p): Don't use `iff' in docstring.

2008-05-07  Dan Nicolaescu  <dann@ics.uci.edu>

	* macfns.c (Fx_create_frame): Make a copy of frame parameters
	because the original parameters are in pure storage now.
	(mac_window): Remove unused params.  Update callers.

2008-05-06  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lread.c (substitute_object_recurse): Use lower-level primitives.
	Don't signal errors when traversing sub-char-tables.
	Don't loop over all the possible characters when traversing char-tables.

	* print.c (print_preprocess): Add sub-char-tables to the print-table,
	just like we do in print.c.

2008-05-05  Stefan Monnier  <monnier@iro.umontreal.ca>

	* minibuf.c (Ftry_completion): Remove code left over from when we used
	scmp instead of Fcompare_strings.

2008-05-04  Juanma Barranquero  <lekktu@gmail.com>

	* w32fns.c (Fw32_battery_status): Fix computation of %t (h:min) format.

2008-05-04  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c [USE_MAC_IMAGE_IO] (image_load_image_io):
	Create bitmap context in native byte order.

	* macterm.c (XDrawLine)
	(XCreatePixmapFromBitmapData) [USE_MAC_IMAGE_IO]: Create bitmap
	context in native byte order.

2008-05-04  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* config.in: Regenerate.

	* image.c (PIX_MASK_DRAW, PIX_MASK_RETAIN) [USE_MAC_IMAGE_IO]:
	New definitions for Image I/O support.
	(XGetImage, XPutPixel, XGetPixel, XDestroyImage)
	(mac_create_cg_image_from_image, x_create_x_image_and_pixmap)
	[USE_MAC_IMAGE_IO]: Add implementations for Image I/O support.
	(mac_data_provider_release_data, image_load_image_io)
	[USE_MAC_IMAGE_IO]: New functions.
	(CGImageCreateWithPNGDataProviderProcType) [MAC_OSX]: Remove typedef.
	(MyCGImageCreateWithPNGDataProvider) [MAC_OSX]: Remove variable.
	(init_image_func_pointer) [MAC_OSX]: Remove function.
	(image_load_quartz2d) [MAC_OSX]: Check availability of
	CGImageCreateWithPNGDataProvider at compile time.
	Use lowercase `false' for boolean constant.
	(png_load, jpeg_load, tiff_load, gif_load) [USE_MAC_IMAGE_IO]:
	Use image_load_image_io.
	(png_load) [!USE_MAC_IMAGE_IO && MAC_OSX]:
	Don't check MyCGImageCreateWithPNGDataProvider.
	(init_image) [MAC_OSX && TARGET_API_MAC_CARBON]:
	Don't call init_image_func_pointer.

	* macgui.h (Pixmap) [USE_MAC_IMAGE_IO]: New definition for Image I/O.

	* macterm.c (mac_cg_color_space_rgb) [USE_CG_DRAWING]:
	Make variable non-static.
	(XDrawLine, XCreatePixmap, XCreatePixmapFromBitmapData, XFreePixmap)
	[USE_MAC_IMAGE_IO]: Add implementations for Image I/O support.

	* macterm.h (ARGB_TO_ULONG, ALPHA_FROM_ULONG): New macros.
	(RED_FROM_ULONG): Mask off higher bits.
	(mac_cg_color_space_rgb) [USE_MAC_IMAGE_IO]: New extern.

	* s/darwin.h [HAVE_CARBON && HAVE_AVAILABILITYMACROS_H]:
	Include AvailabilityMacros.h.
	(USE_MAC_IMAGE_IO, LIBS_IMAGE) [HAVE_CARBON]: New defines.
	(LIBS_CARBON) [HAVE_CARBON]: Use LIBS_IMAGE.

2008-05-03  Stefan Monnier  <monnier@iro.umontreal.ca>

	* chartab.c (Fset_char_table_range): If range is t, really set all
	chars to that value.

2008-05-03  Eli Zaretskii  <eliz@gnu.org>

	* dired.c (Ffile_attributes): Don't allow the device number become
	negative.

2008-05-02  Daiki Ueno  <ueno@unixuser.org>

	* Makefile.in (lisp, shortlisp): Add epa-file-hook.elc.

2008-05-02  Juri Linkov  <juri@jurta.org>

	* minibuf.c (Fread_from_minibuffer, Fread_string, Fread_command)
	(Fread_variable, Fread_buffer, Fcompleting_read): Document the
	DEFAULT argument as a list of default values in docstrings.

2008-05-01  Chong Yidong  <cyd@stupidchicken.com>

	* puresize.h (BASE_PURESIZE): Increase to 1210000.

2008-05-01  Martin Rudalics  <rudalics@gmx.at>

	* dispnew.c (change_frame_size_1): Preserve small windows when
	shrinking frames by calling set_window_height|width with third
	arg 2.

	* window.h (struct window): Replace field too_small_ok by field
	resize_proportionally.

	* window.c (make_window): Initialize resize_proportionally.
	(enlarge_window): Temporarily set resize_proportionally to make
	sure that shrink_windows does scale the window proportionally.
	(shrink_windows): When window has resize_proportionally set try
	to shrink it proportionally by stealing from other windows.
	(struct saved_window, Fset_window_configuration)
	(compare_window_configurations): Handle resize_proportionally.
	(WINDOW_TOTAL_SIZE): New macro.
	(window_min_size, shrink_windows, size_window): Use it.
	(check_min_window_sizes): Remove.  Invalid values of
	window-min-height|width are handled by window_min_size_2 now.
	(size_window, Fsplit_window, enlarge_window)
	(adjust_window_trailing_edge, grow_mini_window): Don't call
	check_min_window_sizes.
	(window_min_size_2, window_min_size_1, window_min_size):
	New argument safe_p for retrieving "safe" minimum sizes.
	(Fdisplay_buffer, Fsplit_window, enlarge_window)
	(adjust_window_trailing_edge, grow_mini_window):
	Adjust arguments of window_min_size... functions.
	(shrink_windows): Argument min_size removed.  New argument
	safe_p allows shrinking windows to their safe minimum sizes.
	Calculate minimum size and decide whether a window shall be
	deleted for each window individually.
	(size_window): When nodelete_p equals 2, tell shrink_windows to
	delete windows only if their new minimum size is no more safe.
	(shrink_window_lowest_first): Call window_min_size_1 to make
	sure to preserve modeline of bottom-most window when resizing
	the minibuffer.
	(Fset_window_configuration, Fcurrent_window_configuration)
	(compare_window_configurations): Do not handle
	window-min-height|width any more.
	(syms_of_window): Clarify window-min-height|width doc-strings.

2008-04-30  Stefan Monnier  <monnier@iro.umontreal.ca>

	* dired.c (file_name_completion): Fix up the encoding/decoding issue
	some more.  Copy some of the code from Ftry_completions.
	Remove special case code that dates back to revision 1.1 when the
	slash was only added when necessary and that can't trigger nowadays.

2008-04-27  Kenichi Handa  <handa@m17n.org>

	* font.c (font_prop_validate): Signal `error' instead of `font'.

2008-04-29  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (Fw32_battery_status): New defun.
	(syms_of_w32fns): Defsubr it.

2008-04-28  Andreas Schwab  <schwab@suse.de>

	* dired.c (file_name_completion): Fix another mixing of encoded
	and decoded names.

2008-04-28  Juanma Barranquero  <lekktu@gmail.com>

	* w32fns.c (Fw32_define_rgb_color): Fix typo in docstring.

2008-04-27  Juanma Barranquero  <lekktu@gmail.com>

	* fringe.c (Fdefine_fringe_bitmap): Doc fix.

2008-04-27  Andreas Schwab  <schwab@suse.de>

	* dired.c (file_name_completion): Fix inappropriate mixing of
	encoded and decoded names.

	* xterm.c (XTread_socket): Fix use of uninitialized variable.

	* puresize.h (BASE_PURESIZE): Increase to 1200000.

2008-04-26  Eli Zaretskii  <eliz@gnu.org>

	* dired.c (Ffile_attributes) [WINDOWSNT]: Undo change from
	2008-03-31, it's not needed anymore with `struct stat' definition
	on nt/inc/sys/stat.h.  Undo changes from 2007-01-12 and 2007-01-13
	for the same reasons.

2008-04-25  Dennis Gilmore  <ausil@fedoraproject.org>  (tiny change)

	* m/sparc.h: Additional redefinitions for GNU/Linux.

2008-04-23  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (Vmac_ts_active_input_buf) [USE_MAC_TSM]: New variable.
	(syms_of_macterm) [USE_MAC_TSM]: Defvar it.
	(Qmouse_drag_overlay) [MAC_OSX]: New variable.
	(syms_of_macterm) [MAC_OSX]: Intern and staticpro it.
	(mac_get_selected_range, mac_store_buffer_text_to_unicode_chars)
	(mac_ax_selected_text_range) [MAC_OSX]: New functions.
	(mac_ax_number_of_characters) [MAC_OS_X_VERSION_MAX_ALLOWED >= 1030]:
	Likewise.

	* mactoolbox.c (Vmac_ts_active_input_buf) [USE_MAC_TSM]: Add extern.
	(fast_find_position, x_y_to_hpos_vpos, mac_ax_selected_text_range)
	(mac_ax_number_of_characters): Add externs.
	(mac_get_selected_range, mac_store_buffer_text_to_unicode_chars)
	[USE_MAC_TSM]: Likewise.
	(mac_handle_text_input_event) [MAC_OSX]:
	Handle kEventTextInputOffsetToPos for no active input area case.
	Handle kEventTextInputPosToOffset and kEventTextInputGetSelectedText.
	(mac_handle_document_access_event)
	[MAC_OS_X_VERSION_MAX_ALLOWED >= 1030]: New function.
	(install_application_handler) [MAC_OSX]: Register handlers for
	kEventTextInputPosToOffset and kEventTextInputGetSelectedText.
	(install_application_handler) [MAC_OS_X_VERSION_MAX_ALLOWED >= 1030]:
	Register mac_handle_document_access_event.

	* xdisp.c (x_y_to_hpos_vpos, fast_find_position) [HAVE_CARBON]:
	Make functions non-static.

2008-04-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Vread_file_name_function, Vread_file_name_predicate)
	(read_file_name_completion_ignore_case, insert_default_directory)
	(Qdefault_directory): Move to minibuffer.el.
	(Fread_file_name): Call the new `read-file-name' instead.

2008-04-23  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c (create_apple_event) [TARGET_API_MAC_CARBON]:
	Make function non-static.
	(create_apple_event_from_event_ref) [TARGET_API_MAC_CARBON]:
	Remove function.
	(create_apple_event_from_drag_ref) [TARGET_API_MAC_CARBON]:
	Move to mactoolbox.c.
	(mac_event_parameters_to_lisp) [TARGET_API_MAC_CARBON]: New function.

	* macgui.h (CGFloat) [!CGFLOAT_DEFINED]: New typedef.
	(mac_rect_make): New macro.

	* macterm.c (mac_draw_image_string_atsui) [MAC_OSX]: Use CGFloat
	instead of float.
	(mac_draw_image_string_cg) [USE_CG_TEXT_DRAWING]: Likewise.
	(init_cg_color, mac_draw_line, mac_draw_cg_image, XSetForeground)
	(XSetBackground) [USE_CG_DRAWING]: Likewise.
	(mac_draw_image_string_atsui) [MAC_OSX]: Use mac_rect_make instead of
	CGRectMake.
	(mac_draw_image_string_cg) [USE_CG_TEXT_DRAWING]: Likewise.
	(mac_erase_rectangle, mac_draw_cg_image, mac_fill_rectangle)
	(mac_set_clip_rectangles) [USE_CG_DRAWING]: Likewise.
	(XCreatePixmap, XCreatePixmapFromBitmapData): Use Window
	instead of WindowRef in argument type.
	(XCreatePixmap) [!MAC_OS8]: Don't call SetPortWindowPort.
	(mac_invert_rectangle): Use CGContextSetBlendMode if available.
	(mac_set_clip_rectangles, mac_reset_clip_rectangles): Take argument F
	instead of DISPLAY.  All uses changed.
	(mac_handle_size_change): Don't call SET_FRAME_GARBAGED.
	(x_calc_absolute_position): Simplify so as not to use
	FRAME_PIXEL_WIDTH/FRAME_PIXEL_HEIGHT.

	* macterm.h (XCreatePixmap, XCreatePixmapFromBitmapData): Use Window
	instead of WindowRef in argument type.
	(create_apple_event_from_event_ref, create_apple_event_from_drag_ref)
	[TARGET_API_MAC_CARBON]: Remove externs.
	(create_apple_event, mac_event_parameters_to_lisp)
	[TARGET_API_MAC_CARBON]: Add externs.

	* mactoolbox.c (Vmac_ts_script_language_on_focus)
	(saved_ts_script_language_on_focus) [USE_MAC_TSM]: Remove externs.
	(XTread_socket) [USE_MAC_TOOLBAR]: Select window if its structure part
	is clicked.
	(x_activate_menubar): Remove extern for saved_menu_event_location.
	(create_apple_event_from_drag_ref) [TARGET_API_MAC_CARBON]:
	Move from mac.c.

2008-04-23  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* alloc.c [!SYSTEM_MALLOC && !SYNC_INPUT] (uninterrupt_malloc)
	[HAVE_GTK_AND_PTHREAD && !DOUG_LEA_MALLOC]: Don't use recursive mutex.

2008-04-23  Jason Rumney  <jasonr@gnu.org>

	* w32.c (stat): When Vw32_get_true_file_attributes is Qlocal, get
	attributes only for local files.

	* w32proc.c (syms_of_ntproc): Change Vw32_get_true_file attributes
	default to Qlocal.

2008-04-22  Juri Linkov  <juri@jurta.org>

	* buffer.c (Fswitch_to_buffer): Change interactive spec to call
	read-buffer-to-switch instead of using the letter "B".

2008-04-21  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Qdefault_directory): New variable.
	(Fread_file_name): Use it to pass `dir' to the completion functions.

2008-04-20  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (pos_visible_p): Check if iterator stops on a display string.

2008-04-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keyboard.c (Vpre_help_message): Remove.
	(show_help_echo): Remove default C code.

	* dired.c (directory_files_internal, file_name_completion):
	Only call ENCODE_FILE if the string is indeed decoded.

2008-04-18  Stefan Monnier  <monnier@iro.umontreal.ca>

	* Makefile.in (TOOLKIT_DEFINES): Remove.
	(LIBW): Use a bit less #if, remove left over OPEN_LOOK stuff.

2008-04-18  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* Makefile.in (MAC_OBJ): Add mactoolbox.o.
	(mactoolbox.o): New target.

	* mac.c [MAC_OSX] (select_and_poll_event, sys_select):
	Use mac_run_loop_run_once instead of CFRunLoopRunInMode.

	* macfns.c (x_set_background_color, mac_window, x_create_tip_frame):
	Use mac_set_frame_window_background instead of XSetWindowBackground.
	(x_set_tool_bar_lines) [USE_MAC_TOOLBAR]:
	Use mac_is_window_toolbar_visible instead of IsWindowToolbarVisible.
	(x_set_name_internal) [TARGET_API_MAC_CARBON]: Use mac_set_window_title
	instead of SetWindowTitleWithCFString.
	(mac_update_proxy_icon) [TARGET_API_MAC_CARBON]: Remove BLOCK_INPUT.
	Move function to mactoolbox.c.
	(mac_update_title_bar) [TARGET_API_MAC_CARBON]:
	Use mac_set_window_modified instead of SetWindowModified.
	Add BLOCK_INPUT around mac_set_window_modified/mac_update_proxy_icon.
	(mac_window, x_create_tip_frame): Use mac_create_frame_window.
	(Fx_focus_frame): Use mac_front_non_floating_window instead of
	FrontNonFloatingWindow.  Use mac_activate_window instead of
	ActivateWindow.  Use mac_active_non_floating_window instead of
	ActiveNonFloatingWindow.
	(show_hourglass, hide_hourglass) [TARGET_API_MAC_CARBON]:
	Use mac_show_hourglass and mac_hide_hourglass.
	(compute_tip_xy) [TARGET_API_MAC_CARBON]: Use mac_get_global_mouse
	instead of GetGlobalMouse.
	(Fx_show_tip): Use mac_move_window/mac_size_window/mac_show_window
	instead of MoveWindow/SizeWindow/ShowWindow, respectively.
	Use mac_bring_window_to_front instead of BringToFront.
	(Qfile_name_history) [TARGET_API_MAC_CARBON]: Move extern to
	mactoolbox.c.
	(Fx_file_dialog) [TARGET_API_MAC_CARBON]: Move function body to
	mac_file_dialog in mactoolbox.c.  Use mac_file_dialog.
	(mac_nav_event_callback) [TARGET_API_MAC_CARBON]: Move function to
	mactoolbox.c.

	* macgui.h [!HAVE_CARBON]: Include Quickdraw.h instead of QuickDraw.h.
	(XtPointer): Move typedef from macmenu.c.
	(enum button_type): Move enum from macmenu.c.
	(widget_value): Move typedef from macmenu.c.
	(M_APPLE, I_ABOUT, EXTRA_STACK_ALLOC, ARGV_STRING_LIST_ID)
	(DIALOG_LEFT_MARGIN, DIALOG_TOP_MARGIN, DIALOG_RIGHT_MARGIN)
	(DIALOG_BOTTOM_MARGIN, DIALOG_MIN_INNER_WIDTH, DIALOG_MAX_INNER_WIDTH)
	(DIALOG_BUTTON_BUTTON_HORIZONTAL_SPACE)
	(DIALOG_BUTTON_BUTTON_VERTICAL_SPACE, DIALOG_BUTTON_MIN_WIDTH)
	(DIALOG_TEXT_MIN_HEIGHT, DIALOG_TEXT_BUTTONS_VERTICAL_SPACE)
	(DIALOG_ICON_WIDTH, DIALOG_ICON_HEIGHT, DIALOG_ICON_LEFT_MARGIN)
	(DIALOG_ICON_TOP_MARGIN): Move defines from macmenu.c.
	(Selection): Move typedef from macselect.c.
	(RAM_TOO_LARGE_ALERT_ID, ABOUT_ALERT_ID) [MAC_OS8]: Move defines from
	macterm.c.
	(mac_set_window_title, mac_set_window_modified, mac_is_window_visible)
	(mac_is_window_collapsed, mac_bring_window_to_front)
	(mac_send_window_behind, mac_hide_window, mac_show_window)
	(mac_collapse_window, mac_front_non_floating_window)
	(mac_active_non_floating_window, mac_activate_window)
	(mac_move_window_structure, mac_move_window, mac_size_window)
	(mac_get_global_mouse, mac_is_window_toolbar_visible): New defines.

	* macmenu.c [!TARGET_API_MAC_CARBON]: Move includes to mactoolbox.c.
	(enum mac_menu_kind): Move enum to mactoolbox.c.
	(min_menu_id): Move variable to mactoolbox.c.
	(quit_dialog_event_loop) [TARGET_API_MAC_CARBON]: Likewise.
	(DIALOG_WINDOW_RESOURCE): Move define to mactoolbox.c.
	(DIALOG_BUTTON_COMMAND_ID_OFFSET, DIALOG_BUTTON_COMMAND_ID_P)
	(DIALOG_BUTTON_COMMAND_ID_VALUE, DIALOG_BUTTON_MAKE_COMMAND_ID)
	[TARGET_API_MAC_CARBON]: Likewise.
	(XtPointer): Move typedef to macgui.h.
	(enum button_type): Move enum to macgui.h.
	(widget_value): Move typedef to macgui.h.
	(DIALOG_LEFT_MARGIN, DIALOG_TOP_MARGIN, DIALOG_RIGHT_MARGIN)
	(DIALOG_BOTTOM_MARGIN, DIALOG_MIN_INNER_WIDTH, DIALOG_MAX_INNER_WIDTH)
	(DIALOG_BUTTON_BUTTON_HORIZONTAL_SPACE)
	(DIALOG_BUTTON_BUTTON_VERTICAL_SPACE, DIALOG_BUTTON_MIN_WIDTH)
	(DIALOG_TEXT_MIN_HEIGHT, DIALOG_TEXT_BUTTONS_VERTICAL_SPACE)
	(DIALOG_ICON_WIDTH, DIALOG_ICON_HEIGHT, DIALOG_ICON_LEFT_MARGIN)
	(DIALOG_ICON_TOP_MARGIN): Move defines to macgui.h.
	(popup_activated_flag): Make variable non-static.
	(x_activate_menubar, install_menu_quit_handler, pop_down_menu)
	(add_menu_item, fill_menu, dispose_menus):
	Move functions to mactoolbox.c.
	(restore_show_help_function, menu_target_item_handler)
	(install_menu_target_item_handler, mac_handle_dialog_event)
	(install_dialog_event_handler, pop_down_dialog, create_and_show_dialog)
	[TARGET_API_MAC_CARBON]: Likewise.
	(menu_quit_handler) [MAC_OS_X_VERSION_MAX_ALLOWED >= 1030]: Likewise.
	(mac_dialog) [!TARGET_API_MAC_CARBON]: Likewise.
	(find_and_call_menu_selection, name_is_separator): Make function
	non-static.
	(Vshow_help_function, timer_check) [TARGET_API_MAC_CARBON]: Move extern
	to mactoolbox.c.
	(set_frame_menubar): Don't call install_menu_quit_handler.
	(menu_item_selection): New variable.
	(mac_menu_show): Use create_and_show_popup_menu.
	(create_and_show_dialog) [TARGET_API_MAC_CARBON]: Don't return
	selection but set variable menu_item_selection.  All uses changed.
	(mac_fill_menubar): Rename from fill_menubar.  All uses changed.
	Call install_menu_quit_handler.  Move to mactoolbox.c.

	* macselect.c [!TARGET_API_MAC_CARBON]: Don't include Scrap.h.
	(Selection): Move typedef to macgui.h.
	(Vselection_converter_alist, Qmac_scrap_name, Qmac_ostype)
	(Vmac_apple_event_map, Qmac_apple_event_class, Qmac_apple_event_id):
	Make variables non-static.
	(Vmac_dnd_known_types) [TARGET_API_MAC_CARBON]: Likewise.
	(mac_handle_apple_event, cleanup_all_suspended_apple_events):
	Make functions non-static.
	(Vmac_service_selection) [MAC_OSX]: Likewise.
	(mac_get_selection_from_symbol, get_flavor_type_from_symbol)
	(mac_valid_selection_target_p, mac_clear_selection)
	(mac_get_selection_ownership_info, mac_valid_selection_value_p)
	(mac_put_selection_value, mac_selection_has_target_p)
	(mac_get_selection_value, mac_get_selection_target_list)
	(init_apple_event_handler, install_drag_handler, remove_drag_handler):
	Move functions to mactoolbox.c.
	(mac_do_track_drag, mac_do_receive_drag) [TARGET_API_MAC_CARBON]:
	Likewise.
	(copy_scrap_flavor_data, mac_handle_service_event)
	(install_service_handler) [MAC_OSX]: Likewise.
	(syms_of_macselect) <Vmac_dnd_known_types>:
	Use mac_dnd_default_known_types.

	* macterm.h (FRAME_OUTER_TO_INNER_DIFF_X, FRAME_OUTER_TO_INNER_DIFF_Y):
	Move to mactoolbox.c.
	(HOURGLASS_WIDTH, HOURGLASS_HEIGHT): Change to 15.
	(Fx_selection_owner_p): Add EXFUN.
	(install_window_handler, remove_window_handler, XSetWindowBackground):
	Remove externs.
	(do_apple_menu) [!TARGET_API_MAC_CARBON]: Likewise.
	(mac_prepare_for_quickdraw) [USE_CG_DRAWING]: Likewise.
	(x_raise_frame, x_lower_frame, mac_alert_sound_play)
	(install_application_handler, mac_get_frame_bounds, mac_get_frame_mouse)
	(mac_convert_frame_point_to_global, mac_set_frame_window_background)
	(mac_update_begin mac_update_end, mac_frame_up_to_date, x_flush)
	(mac_create_frame_window, mac_dispose_frame_window, mac_begin_clip)
	(mac_end_clip, mac_create_scroll_bar, mac_dispose_scroll_bar)
	(mac_set_scroll_bar_bounds, mac_redraw_scroll_bar, mac_fill_menubar)
	(create_and_show_popup_menu, mac_get_selection_from_symbol)
	(mac_valid_selection_target_p, mac_clear_selection)
	(mac_get_selection_ownership_info, mac_valid_selection_value_p)
	(mac_put_selection_value, mac_selection_has_target_p)
	(mac_get_selection_value, mac_get_selection_target_list): Add externs.
	(mac_update_proxy_icon, mac_show_hourglass, mac_hide_hourglass)
	(mac_reposition_hourglass, mac_file_dialog, create_and_show_dialog)
	(mac_dnd_default_known_types) [TARGET_API_MAC_CARBON]: Likewise.
	(mac_run_loop_run_once) [MAC_OSX]: Likewise.
	(mac_dialog) [!TARGET_API_MAC_CARBON]: Likewise.
	(mac_begin_cg_clip, mac_end_cg_clip) [USE_CG_DRAWING]: Likewise.
	(x_set_toolkit_scroll_bar_thumb) [!USE_TOOLKIT_SCROLL_BARS]: Likewise.
	(x_scroll_bar_set_handle) [!USE_TOOLKIT_SCROLL_BARS]: Likewise.

	* mactoolbox.c: New file.

2008-04-18  Jason Rumney  <jasonr@gnu.org>

	* dired.c (Ffile_attributes) [WINDOWSNT]: Cast uid and gid to unsigned.

2008-04-18  Stefan Monnier  <monnier@iro.umontreal.ca>

	* character.c (Fmultibyte_char_to_unibyte):
	Return latin1 chars unchanged.

	* fileio.c (Fexpand_file_name): Refine last fix so `nm' is only
	relocated if it points to `name'.

2008-04-17  Kenichi Handa  <handa@m17n.org>

	* data.c (Faset): Allow setting a multibyte character in an
	ASCII-only unibyte string.

	* lisp.h (STRING_SET_MULTIBYTE): New macro.

2008-04-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	* Makefile.in: Don't use HAVE_GTK and don't -DUSE_GTK since it's now
	done in config.h.

2008-04-16  Juanma Barranquero  <lekktu@gmail.com>

	* character.c (Fchar_bytes, Fchar_width, Fstring_width)
	(Fchar_direction): Add usage in the docstring.

2008-04-15  Chong Yidong  <cyd@stupidchicken.com>

	* keyboard.c (read_key_sequence): Remove always-true checks.

2008-04-14  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_open_internal): Set max_bounds.descent in
	compatibility struct, for better underline positioning.

2008-04-13  David Hansen  <david.hansen@gmx.net>

	* dbusbind.c (dbus-get-unique-name): Remove extra copying of name
	string.

2008-04-12  Dan Nicolaescu  <dann@ics.uci.edu>

	* m/hp800.h (XUINT, XSET): Remove.

2008-04-12  Juanma Barranquero  <lekktu@gmail.com>

	* fileio.c (Fexpand_file_name): Add declaration for `p' missing in
	previous change.

2008-04-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Fexpand_file_name): Tighten the scope of `p' and `o' vars.
	Relocate `nm' after calling DECODE_FILE, in case the GC was run.

2008-04-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keymap.h (map_keymap_canonical): Declare.
	* xmenu.c (single_keymap_panes): Use it.

2008-04-11  Glenn Morris  <rgm@gnu.org>

	* eval.c (Fdefvaralias): If the alias is bound and the target is not,
	set the target's value to that of the alias.

2008-04-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* term.c (set_tty_color_mode): Left over typo.

2008-04-10  Michael Albinus  <michael.albinus@gmx.de>

	* fileio.c (Fmake_symbolic_link): Surround code by #ifdef S_IFLNK
	only after check for file name handler functions.  Signal, when
	native functionality is not supported.
	(syms_of_fileio): Declare it unconditionally.

2008-04-10  Jason Rumney  <jasonr@gnu.org>

	* w32menu.c (is_simple_dialog, simple_dialog_show): New functions.
	(Fx_popup_dialog): Handle simple yes/no questions as dialogs.

	* w32.c (logon_network_drive): Also logon to remote drives that
	are mapped to drive letters.

2008-04-10  Glenn Morris  <rgm@gnu.org>

	* xdisp.c (truncate-partial-width-windows): Doc fix.

2008-04-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (read_file_name_cleanup, Fread_file_name_internal):
	Move functions to minibuffer.el.
	(syms_of_fileio): Don't declare them.

2008-04-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	* minibuf.c (Vcompletion_auto_help): Move to minibuffer.el.
	(syms_of_minibuf): Remove its initialization.

	* minibuf.c (temp_echo_area_glyphs): Remove unused function.

2008-04-09  Juanma Barranquero  <lekktu@gmail.com>

	* editfns.c (Ffield_string_no_properties): Fix typo in docstring.

2008-04-09  Jason Rumney  <jasonr@gnu.org>

	* makefile.w32-in (distclean): Delete makefile too.
	(maintainer-clean): New target.

	* xdisp.c (redisplay_internal) [!WINDOWSNT]: Conditionalize last change.

	* w32term.c (w32_compute_glyph_string_overhangs): Compute overhangs
	for new font backend and composite cases.

2008-04-09  Jan Djärv  <jan.h.d@swipnet.se>

	* atimer.c (alarm_signal_handler): Call run_timers if not SYNC_INPUT.
	Most of the code moved to run_timers.
	(do_pending_atimers): Call run_timers.
	(run_timers): New function.

	* sysdep.c (emacs_write): If SYNC_INPUT and pending_atimers,
	run atimers.

	* process.c (wait_reading_process_output): The same as above.

2008-04-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	* minibuf.c (last_exact_completion): Remove variable.
	(Fdelete_minibuffer_contents, do_completion, Fminibuffer_complete)
	(complete_and_exit_1, complete_and_exit_2)
	(Fminibuffer_complete_and_exit, Fminibuffer_complete_word)
	(Fdisplay_completion_list, display_completion_list_1)
	(Fminibuffer_completion_help, Fself_insert_and_exit)
	(Fexit_minibuffer, Fminibuffer_message): Move functions to
	minibuffer.el.
	(syms_of_minibuf): Remove corresponding initializations.

	* keyboard.c (Qdeactivate_mark): New var.
	(command_loop_1): Use it to call `deactivate-mark'.
	(syms_of_keyboard): Initialize it.

	* xdisp.c (redisplay_internal): Reset tty's color_mode when switching
	to another frame.
	* frame.c (do_switch_frame): Refine the top_frame/async_visible code.
	Don't call set_tty_color_mode.
	(store_frame_param): Reset previous_frame rather than call
	set_tty_color_mode.
	* term.c (set_tty_color_mode): Rewrite.
	* dispextern.h (set_tty_color_mode): New type.
	* termchar.h (struct tty_display_info): Add `previous_color_mode'.

2008-04-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keymap.c (access_keymap): Remove the value 2 for t_ok which was used
	for generic chars, which do not exist any more in emacs-unicode.

2008-04-08  Michael Albinus  <michael.albinus@gmx.de>

	* coding.c (detect_coding_emacs_mule)
	(Ffind_operation_coding_system): Fix typo.

2008-04-08  Jason Rumney  <jasonr@gnu.org>

	* w32uniscribe.c (SNAME): Extract only symbol name.

	* w32font.h (struct w32_metric_cache): New struct.
	(w32font_info): Use it.
	(W32METRIC_NO_ATTEMPT, W32METRIC_SUCCESS, W32METRIC_FAIL)
	(CACHE_BLOCKSIZE): New constants.

	* w32font.c (Qja, Qko, Qzh): New symbols.
	(syms_of_w32font): Initialise them.
	(font_matches_spec): Use them to filter by language.
	(recompute_cached_metrics): Remove function.
	(compute_metrics, clear_cached_metrics): New functions.
	(w32font_encode_char): Use them to manage metric cache.
	(w32font_text_extents): Cache metrics for all glyphs on demand.
	Delay converting glyph indices to WORD until needed.
	(w32font_open_internal): Initialize metric cache to empty.
	(registry_to_w32_charset): Charset should always be a symbol.
	(fill_in_logfont, list_all_matching_fonts): Family should
	always be a symbol.

2008-04-06  Jason Rumney  <jasonr@gnu.org>

	* w32uniscribe.c (uniscribe_shape): Increase items buffer size.
	Give up if glyph indices not supported.  Use uniscribe obtained
	ABC widths for individual metrics.  Map glyph clusters back to
	characters using fClusterStart flag.  Return number of glyphs
	produced, not chars processed.
	(uniscribe_shape): Map char at FROM to current glyph.

2008-04-05  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macmenu.c (fill_menu) [TARGET_API_MAC_CARBON]:
	Use SetMenuItemHierarchicalMenu.

2008-04-05  Jason Rumney  <jasonr@gnu.org>

	* image.c (pbm_load): Allow color values up to 65535.
	Throw an error if max_color_idx is outside the supported range.
	Report an error when image size is invalid.
	Read two bytes at a time when raw images have max_color_idx above 255.

2008-04-05  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (readdir): If FindFirstFile/FindNextFile return in
	cFileName a file name that includes `?' characters, use the 8+3
	alias in cAlternateFileName instead.

2008-04-05  Kenichi Handa  <handa@ni.aist.go.jp>

	* ccl.c (ccl_driver): If ccl->quit_silently is nonzero, don't
	append "CCL: Quitted" when the CCL program is quitted.
	(setup_ccl_program): Initialize ccl->quit_silently to zero.

	* ccl.h (struct ccl_program): New member quit_silently.

2008-04-05  Chong Yidong  <cyd@stupidchicken.com>

	* search.c (compile_pattern_1): Treat non-nil and non-string of
	search-spaces-regexp as nil.

	* minibuf.c (Fassoc_string): Tweak docstring.

2008-04-05  Eli Zaretskii  <eliz@gnu.org>

	* dired.c (Ffile_attributes): Support inode numbers wider than 32
	bits.  Remove ugly WINDOWSNT-specific kludge introduced on
	2008-03-14 to force inode be positive.

	* w32.c (sys_chown, stat, fstat): Use S_* constants instead of
	_S_* ones, since we now use our own sys/stat.h.
	(stat, fstat): Don't mangle the inode number.
	(init_user_info): Don't restrict UID and GID to 0-60000 range.

2008-04-04  Stefan Monnier  <monnier@iro.umontreal.ca>

	* frame.h (struct frame): Give one more bit to `visible' since we use
	values larger than 1 to indicate obscured frames on ttys.

	* keymap.c (Qkeymap_canonicalize): New var.
	(Fmap_keymap_internal): New fun.
	(describe_map): Use keymap-canonicalize.

	* undo.c (last_boundary_buffer, last_boundary_position): New vars.
	(Fundo_boundary): Set them.
	(syms_of_undo): Initialize them.
	(record_point): Use them instead of last_point_position*.
	(last_undo_buffer): Change type.

2008-04-04  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_text_extents): Use font's ascent and descent.
	(recompute_cached_metrics): Don't set ascent and descent per char.

	* w32uniscribe.c (uniscribe_check_otf): Fix last change.
	(uniscribe_check_otf): Add GC protection before consing.
	Rearrange loop for counting features.

2008-04-03  Stefan Monnier  <monnier@iro.umontreal.ca>

	* insdel.c (insert_from_buffer_1): Don't compare bytes in destination
	buffer with byte-size of source buffer.

2008-04-03  Chong Yidong  <cyd@stupidchicken.com>

	* callint.c (Fcall_interactively): Handle temporary region even
	when shift-select-mode is off.

2008-04-03  Jason Rumney  <jasonr@gnu.org>

	* w32uniscribe.c (uniscribe_check_otf): Sanity check otf_spec.

2008-04-03  Kenichi Handa  <handa@m17n.org>

	* coding.c (CATEGORY_MASK_ANY): Add CATEGORY_MASK_UTF_16_AUTO.
	(CATEGORY_MASK_UTF_16): Likewise.
	(detect_coding_utf_16): Add heuristics to reject utf-16 for a
	binary file.
	(detect_coding): Add null-byte detection for a binary file.
	(detect_coding_system): Likewise.

2008-04-03  Jason Rumney  <jasonr@gnu.org>

	* w32uniscribe.c: New file.

	* font.h (uniscribe_font_driver) [WINDOWSNT]: Declare for w32fns.c.

	* w32font.h (uniscribe_check_otf): Declare for w32font.c.

	* w32font.c (Qbalinese, Qbuginese, Qbuhid, Qcuneiform, Qcypriot)
	(Qdeseret, Qglagolitic, Qgothic, Qhanunoo, Qkharoshthi)
	(Qlimbu, Qlinear_b, Qold_italic, Qold_persian, Qosmanya)
	(Qphags_pa, Qphoenician, Qshavian, Qsyloti_nagri)
	(Qtagalog, Qtagbanwa, Qtai_le, Qtifinagh, Qugaritic)
	(Qphonetic): New symbols.
	(syms_of_w32font): Initialize them.
	(font_supported_scripts): Use them.
	(w32font_list_family): List all charsets.
	(w32font_text_extents, recompute_cached_metrics): Fix metric
	calculations.
	(w32_enumfont_pattern_entity): Make full_type a DWORD.
	Give opentype fonts their own format.
	(font_matches_spec): New arguments backend and logfont.
	Handle :otf spec for uniscribe backend.
	(add_font_entity_to_list): Match truetype fonts in uniscribe backend.
	(fill_in_logfont): Use DEFAULT_CHARSET when charset not supplied.

	* w32fns.c (Fx_create_frame): Conditionally register uniscribe
	font backend.
	(globals_of_w32fns): Initialize uniscribe font backend.

	* makefile.w32-in (CONFIG_H): New variable.  Use it to clean up
	dependencies.
	(w32uniscribe.$(O)): New file to build.
	(FONT_OBJ): Include w32uniscribe.$(O).
	(LIBS): Add uniscribe libraries.

	* ftfont.c (ftfont_get_open_type_spec): Check spec->script, not val.

2008-04-02  Chong Yidong  <cyd@stupidchicken.com>

	* callint.c (Vshift_select_mode): New var.
	(Finteractive): Document new ^ spec.
	(Fcall_interactively): Call handle-shift-selection if the ^ spec
	is present.

	* keyboard.c (Vthis_command_keys_shift_translated): New var.
	(command_loop_1): Avoid running the direct display versions of
	forward-char and backward-char if shift-selection may occur.
	(read_key_sequence): Set Vthis_command_keys_shift_translated if
	shift-translation takes place.

	* buffer.c (Vtransient_mark_mode): Move docstring to simple.el to
	avoid clobbering by define-minor-mode.

	* cmds.c (Fforward_char, Fbackward_char, Fforward_line)
	(Fbeginning_of_line, Fend_of_line): Add ^ interactive spec.

	* syntax.c (Fforward_word): Add ^ interactive spec.

	* window.c (Fscroll_up, Fscroll_down, Fscroll_left)
	(Fscroll_right): Add ^ interactive spec.

2008-04-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (try_window_id): Don't forget to reset delta_bytes.

	* casefiddle.c (casify_object): Fix up int/EMACS_INT mixup.

	* charset.c (Funibyte_charset, Fset_unibyte_charset): Remove.

2008-03-31  Juri Linkov  <juri@jurta.org>

	* window.c (Fdisplay_buffer): Reinitialize `tem' to nil.

2008-03-30  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_set_geometry): Fix indentation.
	(xg_resize_outer_widget): Remove.
	(x_wm_size_hint_off): Fix indentation.
	(xg_frame_set_char_size): Call flush_and_sync after
	gtk_window_resize.
	(x_wm_set_size_hint): Pass NULL as geometry window to
	gtk_window_set_geometry_hints due to Gtk+ bug nr 68668.
	Add menu bar and tool bar height to base height.
	(xg_update_frame_menubar, free_frame_menubar)
	(xg_tool_bar_detach_callback, xg_tool_bar_attach_callback)
	(update_frame_tool_bar, free_frame_tool_bar):
	Change xg_resize_outer_widget to xg_frame_set_char_size.

2008-03-30  Michael Albinus  <michael.albinus@gmx.de>

	* dbusbind.c (QCdbus_timeout): New D-Bus internal symbol.
	(Fdbus_call_method): New parameter TIMEOUT.
	(dbus-send-signal): Optimize UNGCPRO call.

2008-03-29  Juri Linkov  <juri@jurta.org>

	* window.c (Fdisplay_buffer): Move call to
	Vsplit_window_preferred_function out of conditions that check
	if window is eligible for vertical splitting.
	When Vsplit_window_preferred_function is non-nil, call it and use
	its non-nil return value as window.  Otherwise, continue doing
	vertical splitting using Fsplit_window with arg horflag=nil.
	(syms_of_window) <Vsplit_window_preferred_function>: Change the
	default value from `split-window' to nil.

2008-03-29  Juri Linkov  <juri@jurta.org>

	* callint.c (Fcall_interactively): Revert 2008-03-16 change
	for interactive code letters 'b' and 'B'.

2008-03-29  Eli Zaretskii  <eliz@gnu.org>

	* fileio.c (Fexpand_file_name): Convert the value of $HOME to a
	multibyte string.

2008-03-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keyboard.c (pending_funcalls): New var.
	(timer_check): Run it.
	(syms_of_keyboard): Initialize it.
	* terminal.c (Qrun_hook_with_args, Qdelete_terminal_functions)
	(Vdelete_terminal_functions): New vars.
	(syms_of_terminal): Initialize them.
	(Fdelete_terminal): Run delete-terminal-functions.
	* xdisp.c (safe_eval): Rewrite.
	(safe_call2): New fun.
	* frame.c (Qdelete_frame_functions): New var.
	(syms_of_frame): Initialize it.
	(Fdelete_frame): Use it and use safe_call2 and pending_funcalls.
	* lisp.h (safe_call2, pending_funcalls): Declare.

2008-03-28  Andreas Schwab  <schwab@suse.de>

	* indent.c (Fmove_to_column): Move declaration before statements.

2008-03-27  Stefan Monnier  <monnier@iro.umontreal.ca>

	* frame.h (enum fullscreen_type): Give it a name.  Move it before use.
	(struct frame): Use bit fields for boolean vars.

	* process.c (server_accept_connection): Simplify naming.
	(emacs_get_tty_pgrp): Use SDATA.

	* coding.c (decode_coding_object): Fix last change.

2008-03-27  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (start_hourglass): Suppress hourglass on tty frames.

2008-03-27  Kenichi Handa  <handa@ni.aist.go.jp>

	* charset.c (Fdefine_charset_internal): Change the way of
	registering charsets in Vcharset_order_list.
	(syms_of_charset): Make the charset `eight-bit' supplementary.

2008-03-26  Alexandre Oliva  <aoliva@redhat.com>  (tiny change)

	* regex.c (EXTEND_BUFFER): Change order of pointer addition
	operations, to avoid having the difference between pointers
	overflow.

2008-03-26  Stefan Monnier  <monnier@iro.umontreal.ca>

	* indent.c (check_display_width): New fun.
	(scan_for_column): Use it.

	* data.c (syms_of_data): Mark most-positive-fixnum and
	most-negative-fixnum as constants.

	* xdisp.c (redisplay_internal): Reset selected_frame earlier.

	* indent.c (scan_for_column): Extract from current_column_1.
	Merge with the same code from Fmove_to_column.
	(current_column_1, Fmove_to_column): Use it.

2008-03-25  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keymap.c (map_keymap_internal): New fun.
	(map_keymap): Use it.
	(Fmap_keymap_internal): New fun.
	(Fmap_keymap): Remove left-out test from before make_save_value.

	* keymap.c (Fmap_keymap): Use `map-keymap-sorted.

	* frame.c (Fmodify_frame_parameters, x_set_frame_parameters):
	Use XCAR/XCDR.

	* process.h (struct Lisp_Process): Remove filter_multibyte.
	* process.c (QCfilter_multibyte): Remove.
	(setup_process_coding_systems): Don't use filter_multibyte.
	(Fstart_process, Fmake_network_process): Don't set filter_multibyte.
	(read_process_output): Don't adjust multibyteness to filter_multibyte.
	(Fset_process_filter_multibyte): Change the coding-system to
	approximate the previous behavior.
	(Fprocess_filter_multibyte_p): Get the multibyteness straight from the
	coding-system.

	* coding.c (decode_coding_object): When not decoding into a buffer,
	obey the coding system's preference of (uni|multi)byte.

2008-03-24  Stefan Monnier  <monnier@iro.umontreal.ca>

	* casefiddle.c (casify_object): Avoid pathological N^2 worst case if
	every char is changed and has a different byte-length.
	(Fupcase_word, Fdowncase_word, Fcapitalize_word, operate_on_word):
	Fix int -> EMACS_INT.

2008-03-23  David Hansen  <david.hansen@gmx.net>

	* dbusbind.c (xd_read_message): Remove extra copying of message
	strings.  Check for NULL `interface' or `member'.

2008-03-22  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (readdir): If FindFirstFile/FindNextFile return in
	cFileName a file name that includes `?' characters, use the 8+3
	alias in cAlternateFileName instead.

2008-03-21  Stefan Monnier  <monnier@iro.umontreal.ca>

	* buffer.c (enlarge_buffer_text): Fix int -> EMACS_INT.

2008-03-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* intervals.c (temp_set_point, temp_set_point_both): Use EMACS_INT.
	(set_point, set_point_both): Use EMACS_INT.  Remove `buffer' arg,
	work on current_buffer only instead (that was already the case
	for some of the code anyway).
	* buffer.h (set_point, set_point_both): Remove buffer arg, use long int.
	(temp_set_point, temp_set_point_both): Use EMACS_INT.
	(SET_PT, SET_PT_BOTH): Adjust.
	* intervals.h (set_point, temp_set_point, set_point_both)
	(temp_set_point_both): Remove redundant declarations.

2008-03-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Finsert_file_contents):
	* lread.c (Feval_buffer): Use BUF_TEMP_SET_PT.
	* buffer.h (BUF_SET_PT): Remove.  set_point_both doesn't work right
	when buffer != current_buffer anyway.

2008-03-20  Andreas Schwab  <schwab@suse.de>

	* callint.c (Fcall_interactively) [case 'B']: Use other-buffer
	as default.

2008-03-19  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (hourglass_timer, hourglass_hwnd): New variables.
	(syms_of_w32fns): Initialize them.
	(HOURGLASS_ID): New constant.
	(x_window_to_frame): Don't check hourglass_window.
	(w32_wnd_proc) <WM_TIMER>: Handle hourglass_timer.
	(w32_wnd_proc) <WM_EXITMENULOOP>: Set pending hourglass cursor.
	(w32_wnd_proc) <WM_SETCURSOR>: Set the hourglass or current cursor.
	(w32_wnd_proc) <WM_EMACS_SETCURSOR>: Set frame's current_cursor.
	Only change the cursor if hourglass is not active.
	(Fx_create_frame): Initialize frame's current_cursor.
	(hourglass_atimer): Remove.
	(hourglass_started): New function.
	(start_hourglass, cancel_hourglass, hide_hourglass): Adapt to w32.
	(show_hourglass): Adapt to w32, changing argument to frame.

	* w32term.h (struct w32_output): Remove hourglass_window.
	Add current_cursor.

	* eval.c (call_debugger, Fsignal):
	* keyboard.c (recursive_edit_1, cmd_error, Ftop_level)
	(command_loop_1, Fread_key_sequence, Fread_key_sequence_vector)
	(Fexecute_extended_command, cancel_hourglass_unwind):
	* minibuf.c (read_minibuf):
	* fns.c (Fy_or_n_p): Enable hourglass when HAVE_WINDOW_SYSTEM.

2008-03-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (run_funs): New fun.
	(run_window_configuration_change_hook): Use it to run the buffer-local
	and the global part of the hook.

	* xdisp.c (format_mode_line_unwind_data): Add window argument.
	(unwind_format_mode_line): Restore selected window.
	(x_consider_frame_title, Fformat_mode_line): Set selected window.

2008-03-17  Stefan Monnier  <monnier@iro.umontreal.ca>

	* editfns.c (Fchar_equal): Check they are valid characters.

	* buffer.h (Fbuffer_list): Declare (for use in callint.c).

2008-03-17  Andreas Schwab  <schwab@suse.de>

	* regex.c (re_match_2_internal): Properly match raw 8-bit bytes
	against a charset.

	* lisp.h (Fbuffer_list): Declare.

2008-03-17  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (free_frame_tool_bar): Only call gtk_container_remove if
	handlebox_widget is != 0.

2008-03-16  Juri Linkov  <juri@jurta.org>

	* callint.c (Fcall_interactively): For interactive code letters
	'b' and 'B' put the buffer list into the list of default "future"
	values of the minibuffer.

2008-03-16  Andreas Schwab  <schwab@suse.de>

	* keyboard.c (read_key_sequence): Fix downcasing of letters with
	modifiers.

	* regex.c (re_match_2_internal): Correct matching of a charset
	against latin-1 characters.

2008-03-16  Kenichi Handa  <handa@m17n.org>

	* coding.c (CHAR_STRING_ADVANCE_NO_UNIFY)
	(STRING_CHAR_ADVANCE_NO_UNIFY): New macros.
	(coding_alloc_by_making_gap): Fix the way to preserve data in the gap.
	(alloc_destination): Fix the 2nd arg to coding_alloc_by_making_gap.
	(encode_coding_utf_8): Use CHAR_STRING_ADVANCE_NO_UNIFY instead of
	CHAR_STRING_ADVANCE.
	(produce_chars): Fix for the case that the source and the
	destination are the same buffer.  Use CHAR_STRING_ADVANCE_NO_UNIFY
	instead of CHAR_STRING_ADVANCE.
	(consume_chars): Use STRING_CHAR_ADVANCE_NO_UNIFY instead of
	STRING_CHAR_ADVANCE.

2008-03-15  Andreas Schwab  <schwab@suse.de>

	* regex.c (re_match_2_internal): Correct matching of eight bit
	characters in unibyte strings.

2008-03-15  Martin Rudalics  <rudalics@gmx.at>

	* buffer.c (overlays_in, Foverlays_in): Include empty overlays
	at end of range when it coincides with the end of the buffer.

2008-03-14  Eli Zaretskii  <eliz@gnu.org>

	* dired.c (Ffile_attributes) [WINDOWSNT]: Force inode be positive.

	* w32fns.c (globals_of_w32fns, Fx_create_frame): Fix last change.

2008-03-14  Jason Rumney  <jasonr@gnu.org>

	* editfns.c (initial_tz): New variable.
	(syms_of_editfns): Initialize it.
	(Fset_time_zone_rule): Set it when first called.
	Use it when TZSTRING is nil.

	* w32fns.c (MONITOR_DEFAULT_TO_NEAREST, struct MONITOR_INFO)
	(MonitorFromPoint_Proc, GetMonitorInfo_Proc): New definitions.
	(monitor_from_point_fn, get_monitor_info_fn): New globals.
	(globals_of_w32fns): Initialize them.
	(compute_tip_xy): Use them to position tooltips.

2008-03-14  Glenn Morris  <rgm@gnu.org>

	* emacs.c (main): Revert previous change.
	(standard_args): Revert -internal-script back to -scriptload,
	and remove the long-option form.

2008-03-13  Glenn Morris  <rgm@gnu.org>

	* emacs.c (main, standard_args): Rename -scriptload to -internal-script.
	Remove option -enable-font-backend.

2008-03-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* buffer.c (Fswitch_to_buffer): Fall back on pop-to-buffer.

2008-03-11  Jan Djärv  <jan.h.d@swipnet.se>

	* xterm.c (x_connection_closed): For GTK: If this is the last
	terminal just exit without closing the display.

2008-03-11  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_full_name): Use floor to round.

2008-03-10  dhruva  <dhruvakm@gmail.com>  (tiny change)

	* sound.c (alsa_configure): Declare vol at beginning of block.

	* fontset.c (Ffontset_info): Remove extra semicolon.

2008-03-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Fsubstitute_in_file_name): Fix up computation of maximum
	size of resulting string.

2008-03-10  Jason Rumney  <jasonr@gnu.org>

	* dispnew.c (adjust_glyph_matrix): Initialize window_height.

2008-03-10  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* xdisp.c (handle_single_display_spec): Undo 2007-10-16 changes.
	Don't pretend as if characters with display property haven't been
	consumed for string-replacing-string case.

2008-03-08  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (GET_NEXT_DISPLAY_ELEMENT): New macro.
	(get_next_display_element, next_element_from_string)
	(next_element_from_ellipsis, next_element_from_buffer): Use it.

2008-03-08  Andreas Schwab  <schwab@suse.de>

	* process.h (struct Lisp_Process): Declare bit fields as unsigned.

2008-03-06  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32_registry): Take font_type argument.  Use ANSI
	when charset not specified.  Only translate ANSI to unicode when
	font_type is truetype.
	(w32font_coverage_ok): New function.
	(add_font_entity_to_list): Use it to filter unsuitable fonts.

2008-03-05  Kenichi Handa  <handa@ni.aist.go.jp>

	* lread.c (Fread_char): Resolve modifiers.
	(Fread_char_exclusive): Likewise.

	* character.c (char_resolve_modifier_mask): New function.
	(char_string): Use char_resolve_modifier_mask.
	(Fchar_resolve_modifiers): New function.
	(syms_of_character): Declare Fchar_resolve_modifiers as Lisp
	function.

2008-03-04  Jason Rumney  <jasonr@gnu.org>

	* makefile.w32-in: Always include w32font.c in the build.
	* w32font.c: Wrap in USE_FONT_BACKEND conditional.

2008-03-04  Andreas Schwab  <schwab@suse.de>

	* Makefile.in (clean): Remove emacs-*.*.* instead of emacs-*.
	(versionclean): Likewise.

2008-03-04  Juanma Barranquero  <lekktu@gmail.com>

	* .cvsignore: Add oo.

2008-03-03  Andreas Schwab  <schwab@suse.de>

	* coding.c (decode_coding_object): Inhibit gap shrinking while
	decoding in place.

2008-03-03  Dan Nicolaescu  <dann@ics.uci.edu>

	* w32term.c: Remove unused include "gnu.h".
	* makefile.w32-in (w32term.o): Don't depend on gnu.h.

	* gnu.h: Rename to ...
	* emacs-icon.h: ... this.
	* xterm.c: Use emacs-icon.h instead of gnu.h.
	* Makefile (xterm.o): Depend on emacs-icon.h, not gnu.h.

2008-03-03  Juanma Barranquero  <lekktu@gmail.com>

	* w32font.c: Include math.h.

2008-03-03  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (recompute_cached_metrics): Change font arg to w32font_info.
	Compute options separately.
	(w32font_open_internal): Set glyph_idx before caching metrics.

	* w32font.h (NTM_PS_OPENTYPE, NTM_TT_OPENTYPE, NTM_TYPE1):
	Define if system headers don't.
	(struct w32font_info): Enlarge ascii_metrics.  Add glyph_idx.
	(w32font_encode_char): Don't declare here.

	* w32font.c (Quniscribe, QCformat): New symbols.
	(syms_of_w32font): Define them.
	(w32font_has_char): Indicate uncertainty.
	(w32font_encode_char): Encode as glyph point.  Make static.
	(recompute_cached_metrics): New function.
	(w32font_open_internal): Use it.  Set font to use glyph points
	initially.  Set format based on type of font.
	(w32font_text_extents, w32font_draw): Optionally use glyph points.
	(w32_enumfont_pattern_entity): Accept backend arg.  Set type based
	on it.  Set format based on information available here.
	(add_font_entity_to_list): Identify backend based on opentype_only.

2008-03-02  Andreas Schwab  <schwab@suse.de>

	* ftfont.c (ftfont_pattern_entity): Fix aliasing violations.

	* coding.c (decode_coding_big5, produce_chars):
	Fix typos in last change.

2008-03-02  Kentaro Ohkouchi  <nanasess@fsm.ne.jp>

	* gnu.h: New icon.

2008-03-02  Kenichi Handa  <handa@m17n.org>

	* coding.c (decode_coding_utf_8): When eol-type of CODING is
	`dos', don't decode '\r' if that is the last in the source.
	(decode_coding_utf_16, decode_coding_emacs_mule)
	(decode_coding_iso_2022, decode_coding_sjis, decode_coding_big5)
	(decode_coding_raw_text, decode_coding_charset): Likewise.
	(produce_chars): Don't decode EOL here.  Use EMACS_INT.

2008-03-01  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_full_name): Report point size for scalable fonts.

2008-03-01  Kim F. Storm  <storm@cua.dk>

	* dispextern.h (CHAR_GLYPH_SPACE_P): Check for default face.

2008-03-01  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_full_name): New function.
	(w32font_open_internal): Use it.

2008-03-01  Kim F. Storm  <storm@cua.dk>

	* dispnew.c (line_draw_cost): Fix invalid glyph check.

2008-03-01  Jason Rumney  <jasonr@gnu.org>

	* font.c (font_unparse_fcname): Increase len when style is a symbol.

2008-03-01  Jan Djärv  <jan.h.d@swipnet.se>

	* xterm.c (handle_one_xevent): For Gtk+ and ConfigureNotify, call
	xg_frame_resized when the event is for the edit widget.

	* gtkutil.h (xg_frame_resized): Renamed from xg_resize_widgets.

	* gtkutil.c (xg_resize_outer_widget): Only do one of set_geometry or
	set_char_size.
	(xg_frame_resized): Renamed from xg_resize_widgets.  Remove all
	operations on widgets here.  Just set frame size if needed.
	(flush_and_sync, x_wm_size_hint_off, xg_pack_tool_bar): New functions.
	(xg_frame_set_char_size): Call x_wm_size_hint_off before resizing.
	(x_wm_set_size_hint): Set size hints on the edit widget only, not
	the whole frame.
	(xg_create_tool_bar): Move attachement of the tool bar to
	xg_pack_tool_bar.  Do not attach the tool bar if there are no items.
	(free_frame_tool_bar): Remove call to SET_FRAME_GARBAGED.

2008-03-01  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (w32_msg_pump): Disable debug code.

2008-03-01  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* m/intel386.h [MAC_OSX || DARWIN]: Define NO_ARG_ARRAY if _LP64.

2008-02-29  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (next_overlay_string): Don't set
	overlay_strings_at_end_processed_p if we're currently reading from
	a display string.

2008-02-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (get_overlay_strings_1): Fix typo.

2008-02-29  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (get_overlay_strings_1): Add missing argument type.

2008-02-28  Kenichi Handa  <handa@ni.aist.go.jp>

	* ftfont.c (ftfont_match): Explicitly set pixelsize in pattern.

	* xdisp.c (display_mode_element): Cancel the previous change.
	(decode_mode_spec): Likewise.
	(handle_auto_composed_prop): Don't make composition if it->string
	is a string.

2008-02-27  Kim F. Storm  <storm@cua.dk>

	* lisp.h (GLYPH): Change type from int to struct with separate char
	and face_id members.
	(GLYPH_MASK_FACE, GLYPH_MASK_CHAR): Delete macros.
	(GLYPH_CHAR, GLYPH_FACE): Remove slow versions with frame arg.
	(FAST_GLYPH_CHAR, FAST_GLYPH_FACE): Rename macros to ...
	(GLYPH_CHAR, GLYPH_FACE): ... these.  Change users.
	(FAST_MAKE_GLYPH, MAKE_GLYPH): Remove.  Rewrite users to use ...
	(SET_GLYPH, SET_GLYPH_CHAR, SET_GLYPH_FACE): ... these macros instead.
	(GLYPH_CODE_CHAR, GLYPH_CODE_FACE, GLYPH_CODE_P)
	(GLYPH_CODE_CHAR_VALID_P, SET_GLYPH_FROM_GLYPH_CODE): New macros to
	handle new Lisp glyph code encoding, either an integer or a cons.

	* disptab.h (GLYPH_SIMPLE_P): Rewrite.
	(GLYPH_ALIAS): Delete.
	(GLYPH_ALIAS_P, GLYPH_FOLLOW_ALIASES): Rewrite.
	(GLYPH_LENGTH, GLYPH_STRING): Use GLYPH_CHAR.
	(GLYPH_FROM_CHAR): Replace macro by ...
	(SET_GLYPH_FROM_CHAR): ... this macro.  Change users.

	* dispextern.h (CHAR_GLYPH_SPACE_P): Simplify.
	(GLYPH_FROM_CHAR_GLYPH): Replace macro by ...
	(SET_GLYPH_FROM_CHAR_GLYPH): ... this macro.  Change users.
	(GLYPH_INVALID_P): New macro.
	(spec_glyph_lookup_face): Update prototype.

	* dispnew.c (line_draw_cost): Adapt to new glyph type.
	(build_frame_matrix_from_leaf_window): Adapt to new glyph type and
	new glyph code encoding.
	(spec_glyph_lookup_face): No return value; update passed glyph instead.
	(init_display): Use SET_CHAR_GLYPH to initialize space_glyph.

	* xdisp.c (get_next_display_element, next_element_from_display_vector):
	Adapt to new glyph type and new glyph code encoding.

	* term.c (encode_terminal_code, produce_special_glyphs): Likewise.

	* indent.c (current_column, current_column_1, Fmove_to_column)
	(compute_motion): Adapt to new glyph code encoding.

	* msdos.c (IT_write_glyphs): Adapt to new glyph type.

2008-02-27  Chong Yidong  <cyd@stupidchicken.com>

	* process.c (wait_reading_process_output): Check for window
	changes caused by timers.
	Suggested by Johan Bockgård.

2008-02-27  Glenn Morris  <rgm@gnu.org>

	* emacs.c (USAGE1): Add `--disable-font-backend'.

2008-02-27  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Finsert_file_contents): Don't reset undo_list if no change
	is made to the buffer.

2008-02-26  Stefan Monnier  <monnier@iro.umontreal.ca>

	* dispextern.h (face_at_buffer_position, face_for_overlay_string)
	(face_at_string_position):
	* xfaces.c (face_at_buffer_position, face_for_overlay_string)
	(face_at_string_position):
	* xdisp.c (display_string, next_overlay_change):
	* buffer.h (overlays_at):
	* buffer.c (overlays_at): Use EMACS_INT for buffer positions.
	Update callers.

2008-02-26  Chong Yidong  <cyd@stupidchicken.com>

	* editfns.c (Fformat): Doc fix.

2008-02-26  Juanma Barranquero  <lekktu@gmail.com>

	* font.c (Ffont_spec, Ffont_at): Fix typos in docstrings.
	(Ffont_put, Flist_families, Ffont_fill_gstring, Ffont_drive_otf)
	(Ffont_otf_alternates, Fquery_font): Doc fixes.

2008-02-25  Stefan Monnier  <monnier@iro.umontreal.ca>

	* buffer.c (Fbuffer_swap_text): New function.
	(syms_of_buffer): Defsubr it.

2008-02-25  Chong Yidong  <cyd@stupidchicken.com>

	* keyboard.c (command_loop_1): Revert 2006-10-09 change.

2008-02-25  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_draw): Draw one character at a time when padding.

2008-02-25  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (Fdelete_window, Fadjust_window_trailing_edge):
	Handle a nil arg.  Use run_window_configuration_change_hook.
	(delete_window, adjust_window_trailing_edge): Don't handle nil any more.
	(Fenlarge_window, Fshrink_window, Fset_window_configuration):
	Use run_window_configuration_change_hook.

2008-02-25  Kenichi Handa  <handa@ni.aist.go.jp>

	* xdisp.c (x_produce_glyphs): For a visible glyph, assure at least
	1-pixel width.

2008-02-25  Kenichi Handa  <handa@ni.aist.go.jp>

	* xdisp.c (fill_glyph_string): Pay attention to glyph->padding_p.
	(append_glyph): Set glyph->pixel_width and glyph->padding_p to 1
	if the glyph in the font is zero pixel with.

	* dispextern.h (struct glyph_string): New member padding_p.

	* w32font.c (w32font_draw): Pay attention to s->padding_p.

	* ftxfont.c (ftxfont_draw): Pay attention to s->padding_p.

	* xfont.c (xfont_draw): Pay attention to s->padding_p.

	* xftfont.c (xftfont_draw): Pay attention to s->padding_p.

	* font.c: If the font driver doesn't have `shape' function, return Qnil.

2008-02-25  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (enum_font_cb2): Don't use raster fonts for Unicode.

2008-02-24  Stefan Monnier  <monnier@iro.umontreal.ca>

	Allow fine-grained image-cache flushing.
	* dispextern.h (struct image): Add `dependencies' field.
	(clear_image_caches): Change arg to Lisp_Object.
	* image.c (make_image): Initialize `dependencies' field.
	(clear_image_cache): Change arg to allow fine-grained flushing.
	Perform the flush even if image-cache-eviction-delay is nil.
	(clear_image_caches): Change arg to Lisp_Object.
	(Fclear_image_cache): Expand meaning of the argument.
	(mark_image): Mark `dependencies' field.
	* xfaces.c (clear_face_cache): Adapt arg to call to clear_image_caches.
	(lface_hash): Use XHASH rather than XFASTINT.
	(face_at_buffer_position): Fix int -> EMACS_INT position.
	* xdisp.c (next_overlay_change): Fix int -> EMACS_INT position.
	(select_frame_for_redisplay): Remove code duplication.
	(redisplay_internal): Adapt arg to call to clear_image_caches.

2008-02-24  Dan Nicolaescu  <dann@ics.uci.edu>

	* s/vms4-0.h:
	* s/vms4-2.h:
	* s/vms4-4.h:
	* s/vms5-5.h: Remove, unused.

	* s/irix5-2.h:
	* s/irix6-0.h:
	* s/riscos5.h:
	* s/mach-bsd4-3.h:
	* m/mips4.h: Remove files for obsolete systems.

	* Makefile.in:
	* filelock.c:
	* unexmips.c:
	* m/hp9000s300.h:
	* m/iris4d.h:
	* s/aix3-1.h:
	* s/hpux.h:
	* s/msdos.h:
	* s/usg5-0.h:
	* s/usg5-2-2.h:
	* s/usg5-2.h:
	* s/usg5-3.h: Remove references to obsolete variables.

	* s/irix5-0.h: Remove, move all the contents ...
	* s/irix6-5.h: ... here.  Simplify.
	* config.in: Regenerate.

2008-02-24  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (x_draw_glyph_string_background): Clear the background
	manually when cleartype is in use.
	(x_draw_glyph_string_foreground): Draw text transparently when
	cleartype is in use.

	* w32font.c (w32font_text_extents): Avoid getting HDC and selecting
	a font into it unless we have to.

2008-02-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* intervals.h (INT_LISPLIKE): Remove.  It may misfire.
	(NULL_INTERVAL_P, SET_INTERVAL_PARENT): Don't use it.

2008-02-18  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (Fw32_shell_execute): Encode parameters.

2008-02-09  Eli Zaretskii  <eliz@gnu.org>

	* fileio.c (syms_of_fileio) <insert-default-directory>: Doc fix.

2008-02-05  Juanma Barranquero  <lekktu@gmail.com>

	* unexhp9k800.c (read_header): Replace `legal' with `valid'.

2008-02-24  Ulrich Neumerkel  <ulrich@complang.tuwien.ac.at>  (tiny change)

	* xterm.c (x_set_offset): Don't change the gravity if
	CHANGE_GRAVITY is -1.

2008-02-23  Chong Yidong  <cyd@stupidchicken.com>

	* fileio.c (auto_save_error_occurred): New var.
	(auto_save_error): Set it.
	(Fdo_auto_save): Don't overwrite the error message if an auto-save
	error occurred.

2008-02-23  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (globals_of_w32): Add initializations for
	g_b_init_get_sid_sub_authority and
	g_b_init_get_sid_sub_authority_count.

2008-02-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	* font.c (font_match_xlfd, font_check_xlfd_parse): New funs.
	(font_parse_xlfd): Use them for sanity check.
	(Finternal_set_font_style_table): Make sure the table is bijective.

	Consolidate the image_cache to the terminal struct.
	* termhooks.h (P_): Remove redundant def.
	(struct terminal): New field `image_cache'.
	* frame.h (FRAME_IMAGE_CACHE): New macro.  Use it everywhere in place
	of FRAME_X_IMAGE_CACHE.
	* xterm.h (struct x_display_info): Remove image_cache field.
	(FRAME_X_IMAGE_CACHE): Remove.  Use FRAME_IMAGE_CACHE instead.
	* w32term.h (struct w32_display_info): Remove image_cache field.
	(FRAME_X_IMAGE_CACHE): Remove.  Use FRAME_IMAGE_CACHE instead.
	* macterm.h (struct mac_display_info): Remove image_cache field.
	(FRAME_X_IMAGE_CACHE): Remove.  Use FRAME_IMAGE_CACHE instead.
	* xterm.c (x_term_init):
	* w32term.c (w32_term_init):
	* macterm.c (mac_term_init): Set the image_cache in the terminal.
	* dispextern.h (clear_image_cache, forall_images_in_image_cache):
	Remove declarations.
	(clear_image_caches, mark_image_cache): New declarations.
	* xfaces.c (clear_face_cache):
	* xdisp.c (redisplay_internal): Use clear_image_caches.
	* image.c (clear_image_cache): Don't check that a frame is on
	a window-system before checking if it shares the same cache.
	(clear_image_caches): New function.
	(Fclear_image_cache): Use it.
	(mark_image): Move from allo.c.
	(mark_image_cache): Move from alloc.c and forall_images_in_image_cache.
	* alloc.c (mark_image, mark_image_cache): Move to image.c.
	(mark_object): Don't call mark_image_cache for frames.
	(mark_terminals): Call mark_image_cache.

	* lisp.h (Fdelete_terminal): Declare.

	* charset.h (CHECK_CHARSET, CHECK_CHARSET_GET_ID)
	(CHECK_CHARSET_GET_ATTR): Don't use the inexistent return value of
	wrong_type_argument.

2008-02-22  Kenichi Handa  <handa@ni.aist.go.jp>

	* Makefile.in (lisp): Remove devanagari.el, kannada.el,
	malayalam.el, and tamil.el.  Add sinhala.el.

2008-02-21  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xterm.c (x_connection_closed): Consolidate identical tests.
	(x_delete_terminal): Don't crash if called via x_connection_closed.

2008-02-21  Kenichi Handa  <handa@ni.aist.go.jp>

	* xdisp.c (decode_mode_spec): New arg string.
	(display_mode_element): Adjust for the above change.

2008-02-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* callint.c (Fcall_interactively): Use AREF.

2008-02-18  Stefan Monnier  <monnier@iro.umontreal.ca>

	* font.c (font_unparse_xlfd): Don't ignore integer pixel size specs.

2008-02-18  Jan Djärv  <jan.h.d@swipnet.se>

	* xfns.c (Fx_show_tip): Set string to " " if empty.

2008-02-17  Dan Nicolaescu  <dann@ics.uci.edu>

	* callint.c (syms_of_callint): Initialize Vmark_even_if_inactive
	with Qt.

2008-02-17  Kenichi Handa  <handa@m17n.org>

	* ftfont.c (ftfont_shape): Return Lispy number.

	* xfaces.c (prepare_face_for_display): Use display_info->font->fid
	for GCs.
	(Finternal_set_font_selection_order): Call font_update_sort_order
	only when enable_font_backend is set.
	(realize_x_face): Set face->font_info to that of default face only
	when enable_font_backend is set.

	* xdisp.c (handle_composition_prop): Set it->c to the fist
	characte of the composed region.
	(fill_composite_glyph_string): Set base_face->font_info to
	s->font_info.  Get a face for ascii from base_face->ascii_face.
	(BUILD_COMPOSITE_GLYPH_STRING): Call fill_composite_glyph_string
	with a face already decided.
	(x_produce_glyphs): Be sure to set it->ascent and it->descent to
	non-negative.
	(x_produce_glyphs): If the composition method is ..._WITH_GLYPH_STRING,
	call font_prepare_composition unconditionally.

	* xfns.c (x_make_gc): Use the default font id of the frame for GCs.

	* xterm.h (struct x_display_info): New member font.

	* xterm.c (x_set_cursor_gc): Use display_info->font->fid for GCs.
	(x_set_mouse_face_gc, x_new_font): Likewise.
	(x_term_init): Setup display_info->font.
	(x_delete_terminal): Free display_info->font.

	* xfont.c (xfont_draw): Use BLOCK_INPUT and UNBLOCK_INPUT.

	* ftxfont.c (ftxfont_default_fid): Delete it.
	(ftxfont_open): Set xfont->fid to 0.
	(ftxfont_end_for_frame): Clear data specific to the frame and the
	font-driver.

	* xftfont.c (xftfont_default_fid): Delete it.
	(xftfont_open): Set xfont->fid to 0.

	* fontset.c (FONTSET_OBJLIST): New macro.
	(fontset_find_font): Update font-object list of the fontset.
	(free_realized_fontset): New function.
	(free_face_fontset): Call free_realized_fontset.
	(Ffont_info): Call font_close_object only when enable_font_backend
	is set.

	* font.c [HAVE_X_WINDOWS]: Include xterm.h.
	[HAVE_NTGUI]: Include w32term.h.
	[MAC_OS]: Include macterm.ch.
	(font_otf_ValueRecord): Use make_number.
	(font_finish_cache): Fix handling of reference count.
	(font_clear_cache): Update num_fonts.
	(font_open_entity): Update smallest_char_width and
	smallest_font_height of the frame.
	(font_close_object): Update num_fonts.
	(Fclear_font_cache): Fix finding the target cache data.

2008-02-16  Glenn Morris  <rgm@gnu.org>

	* fontset.c (Finternal_char_font): Fix compilation warning.

2008-02-16  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (init_user_info): Use TOKEN_USER and TOKEN_PRIMARY_GROUP
	instead of char arrays.  Enlarge the size of array passed to
	get_token_information.

	* font.c (Ffont_fill_gstring, Fget_font_glyphs): Fix compilation
	warnings.

2008-02-15  Dan Nicolaescu  <dann@ics.uci.edu>

	* .gdbinit: Don't set `args', it breaks gdb --args.

2008-02-14  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Finsert_file_contents): Adjust offsets when replacing
	within a narrowed buffer.

2008-02-14  Kenichi Handa  <handa@ni.aist.go.jp>

	* coding.c (decode_coding_object, encode_coding_object):
	Preserve Vdeactivate_mark.  Delete unnecessary call of Fcurrent_buffer.

2008-02-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* coding.c (coding_set_destination): Use BEG_BYTE rather than
	hardcoding 1.
	(detect_coding_system):
	* lisp.h (detect_coding_system, chars_in_text, multibyte_chars_in_text)
	(string_char_to_byte, string_byte_to_char, insert_from_gap):
	* insdel.c (insert_from_gap):
	* fns.c (string_char_byte_cache_charpos, string_char_byte_cache_bytepos)
	(string_char_to_byte, string_byte_to_char, string_make_multibyte)
	(string_to_multibyte):
	* character.c (chars_in_text, multibyte_chars_in_text):
	* fileio.c (Finsert_file_contents): Use EMACS_INT for buffer positions.

	* character.h (FETCH_STRING_CHAR_ADVANCE)
	(FETCH_STRING_CHAR_AS_MULTIBYTE_ADVANCE)
	(FETCH_STRING_CHAR_ADVANCE_NO_CHECK): Use SDATA and SREF.
	(DEC_POS, BUF_DEC_POS): Use BEG_BYTE rather than hardcoding 1.

	* casefiddle.c (casify_region): Only call after-change and composition
	functions on the part of the region that was changed.

	* keyboard.c (read_avail_input):
	* frame.c (Fdelete_frame): Call Fdelete_terminal.

2008-02-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* buffer.c (clone_per_buffer_values, reset_buffer_local_variables)
	(Fbuffer_local_value, Fbuffer_local_variables): Don't forget undo_list.

2008-02-11  Juanma Barranquero  <lekktu@gmail.com>

	* w32menu.c (push_submenu_start, push_submenu_end)
	(push_left_right_boundary, push_menu_pane, push_menu_item):
	* keyboard.c (read_key_sequence): Don't pass args with side effects
	to AREF, it fails when compiling with -DENABLE_CHECKING.

2008-02-11  Kenichi Handa  <handa@ni.aist.go.jp>

	* Makefile.in (${lispsource}international/charprop.el):
	Delete this target.

	* search.c (boyer_moore): Fix incorrect synching of the trunk and
	emacs-unicode-2.

2008-02-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* terminal.c (Fdelete_terminal): Clean up the `force' path.

2008-02-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* frame.c (Qnoelisp): New symbol.
	(syms_of_frame): Initialize it.
	(Fdelete_frame): Use it to distinguish a mere `force' passed from
	someharmles Elisp code, from a strong `force' from x_connection_closed.
	* frame.h (Qnoelisp): Declare.
	* xterm.c (x_connection_closed): Pass `noelisp'.

	* lisp.h (struct Lisp_Misc_Any, struct Lisp_Marker)
	(struct Lisp_Overlay, struct Lisp_Kboard_Objfwd)
	(struct Lisp_Save_Value, struct Lisp_Free): Use enum Lisp_Misc_Type
	rather than `int' for the type of `type'.

2008-02-10  Dan Nicolaescu  <dann@ics.uci.edu>

	* s/gnu-linux.h: Remove support for non-ELF and linux-1.x.

	* Makefile.in (GNUC): Remove support for gcc-1.x.

2008-02-10  Richard Stallman  <rms@gnu.org>

	* lisp.h (ASET): Use AREF, not ASLOT.

2008-02-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp.h (ASET): Check bounds.

2008-02-10  Glenn Morris  <rgm@gnu.org>

	* buffer.c (mode-name): Doc fix.

2008-02-09  Dan Nicolaescu  <dann@ics.uci.edu>

	* Makefile.in:
	* emacs.c:
	* gmalloc.c:
	* keyboard.c:
	* lisp.h:
	* m/ibm370aix.h:
	* process.c:
	* regex.c:
	* s/hpux.h:
	* sysdep.c:
	* sysselect.h:
	* systty.h:
	* unexec.c:
	* w32term.c:
	* xsmfns.c:
	* xterm.c: Remove code that deals with obsolete variables.

	* s/msdos.h (DONT_NEED_ENVIRON): Don't define.

	* ecrt0.c: Replace the DONT_NEED_ENVIRON test with MSDOS test,
	nothing else needs it anymore.

2008-02-09  Eli Zaretskii  <eliz@gnu.org>

	* buffer.h (FETCH_CHAR_AS_MULTIBYTE): Use unibyte_to_multibyte_table
	instead of unibyte_char_to_multibyte.

2008-02-09  Dan Nicolaescu  <dann@ics.uci.edu>

	* s/gnu-linux.h: Remove commented out code.

	* unexec.c: Remove references to obsolete variable COFF_ENCAPSULATE.

	* Makefile.in: Update what RMS says about using autoconf.
	(C_COMPILER, COFF_ENCAPSULATE, MAKE_PARALLEL): Remove obsolete variable.
	(C_SWITCH_MACHINE_1, C_SWITCH_SYSTEM_1, C_SWITCH_SITE_1)
	(C_SWITCH_X_SITE_1, C_SWITCH_X_MACHINE_1)
	(C_SWITCH_X_SYSTEM_1): Move invariant code outside conditional.

2008-02-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keymap.c (Fkey_description): Move side effect outside of macro call.

	* xfaces.c (Finternal_make_lisp_face):
	* keyboard.c (add_command_key, parse_menu_item): Use ASET.

	* fontset.c (free_face_fontset): Use FONTSET_FROM_ID.
	(syms_of_fontset): Use ASET.

	* fns.c (concat): Move side effect outside of macro call.
	(hash_clear): Use ASET.

2008-02-08  Richard Stallman  <rms@gnu.org>

	* frame.c (Fdelete_frame): If FORCE, don't call hooks.
	If FORCE, and frame has a surrogate minibuffer for another frame,
	delete the other frame first.

2008-02-07  Timo Savola  <timo.savola@iki.fi>

	* xterm.c (x_detect_focus_change): Handle embed client message.
	(handle_one_xevent): Ditto.
	(handle_one_xevent): If embedded and we get a button press/release,
	request focus.
	(xembed_set_info, xembed_send_message): New functions.
	(x_make_frame_visible): Call xembed_set_info if embedded.
	(x_make_frame_invisible): Call xembed_set_info if embedded.
	(x_term_init): Initialize Xatom_XEMBED.
	(x_make_frame_visible): Check for FRAME_X_EMBEDDED_P also.
	(x_iconify_frame): Ditto.

	* xterm.h (struct x_display_info): Add AtomXatom_XEMBED.
	(enum xembed_info, enum xerm srmbed_message, enum xembed_focus)
	(enum xembed_modifier, enum xembed_accelerator): New.
	(xembed_set_info, xembed_send_message): Declare.
	(FRAME_X_EMBEDDED_P): New.

	* gtkutil.c (xg_create_frame_widgets): If frame is embedded, call
	gtk_plug_new.

	* xfns.c (Fx_create_frame): Do not override the explicitly set parent
	window ID of a frame.
	(x_window): Reparent frame if embedded.
	(Fx_create_frame): Don't set border width if embedded.

	* emacs.c (USAGE3): Add --parent-id.
	(standard_args): Ditto.

2008-02-07  Jan Djärv  <jan.h.d@swipnet.se>

	* coding.c (DECODE_EMACS_MULE_COMPOSITION_CHAR): Use "do...while (0)".

2008-02-07  Jim Meyering  <meyering@redhat.com>

	Use "do...while (0)", not "if (1)...else" in macro definitions.
	The latter provokes a warning from gcc about the empty else, when
	followed by ";".  Also, without that trailing semicolon, it would
	silently swallow up any following statement.
	* syntax.h (SETUP_SYNTAX_TABLE)
	(SETUP_SYNTAX_TABLE_FOR_OBJECT): Likewise.
	* buffer.h (DECODE_POSITION): Likewise.
	* character.h (FETCH_STRING_CHAR_ADVANCE): Likewise.
	(FETCH_STRING_CHAR_AS_MULTIBYTE_ADVANCE): Likewise.
	(FETCH_STRING_CHAR_ADVANCE_NO_CHECK): Likewise.
	(FETCH_CHAR_ADVANCE): Likewise.
	(FETCH_CHAR_ADVANCE_NO_CHECK): Likewise.

2008-02-07  Jim Meyering  <meyering@redhat.com>

	* lread.c [lint]: Don't include <sys/inode.h>.

2008-02-07  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xselect.c (x_handle_dnd_message):
	* xmenu.c (digest_single_submenu, xmenu_show):
	* xdisp.c (with_echo_area_buffer_unwind_data)
	(format_mode_line_unwind_data, unwind_format_mode_line)
	(display_menu_bar):
	* eval.c (Ffetch_bytecode):
	* doc.c (store_function_docstring):
	* ccl.c (resolve_symbol_ccl_program, ccl_get_compiled_code)
	(Fccl_execute, Fccl_execute_on_string, Fregister_code_conversion_map):
	* buffer.c (add_overlay_mod_hooklist): Use ASET.

2008-02-07  Kenichi Handa  <handa@m17n.org>

	* ftxfont.c (ftxfont_open): Don't set
	dpyinfo->smallest_font_height and dpyinfo->smallest_char_width to 0.

	* ftfont.c (ftfont_open): Fix previous change.

2008-02-06  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_text_extents): Fill in lbearing metric.
	Use cached metrics for ASCII characters.
	(w32font_open_internal): Don't set font's owning_frame.
	Cache metrics for ASCII characters.

	* w32font.h (struct w32font_info): Add ascii_metrics.
	Remove owning_frame.

2008-02-06  Kenichi Handa  <handa@ni.aist.go.jp>

	* xdisp.c (x_produce_glyphs): Don't set it->ascent and it->descent
	to negative value.

	* ftxfont.c (ftxfont_draw): Use s->font_info, not face->font_info.

	* ftfont.c (ftfont_open): Fix calculation of font->font.average_width.

	* charset.c (syms_of_charset): Set QCtest and Qeq.

2008-02-06  Stefan Monnier  <monnier@iro.umontreal.ca>

	* process.c (Fstart_process):
	* callproc.c (Fcall_process): Handle the case where
	Funhandled_file_name_directory returns nil.

	* font.h (enum lgstring_indices, enum lglyph_indices): New enums.
	(LGSTRING_SLOT, LGSTRING_SET_SLOT): New macros.
	* font.c (check_gstring): Use them and AREF to access the vector before
	we know it's really a gstring.
	(Ffont_shape_text): Fix typo.
	(Ffont_shape_text, Ffont_otf_alternates): Fix up int/Lisp_Oject mixups.

	* composite.h (Fcompose_region_internal, Fcompose_string_internal):
	Declare.

	* chartab.c (make_sub_char_table): Remove noop-yet-incorrect statement.

2008-02-05  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_open_internal): Fill min_width with tmAveCharWidth.
	Set smallest_font_height and smallest_char_width in display info.

2008-02-05  Kenichi Handa  <handa@ni.aist.go.jp>

	* coding.c (decode_eol): Pay attention to coding->dst_multibyte.

2008-02-05  Miles Bader  <miles@gnu.org>

	* xfaces.c (get_lface_attributes, merge_named_face)
	(lookup_named_face, lookup_derived_face, realize_named_face):
	Revert 2008-02-01 change by cyd@stupidchicken.com.

2008-02-04  Kenichi Handa  <handa@ni.aist.go.jp>

	* fontset.c (Ffontset_info): Handle the case of inhibitting the
	fallback fonts.
	(Ffontset_info) [USE_FONT_BACKEND]: Fix getting of opened font names.

2008-02-04  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_open_internal): Use font_unparse_fcname to
	set full_name.
	(w32font_open_internal): Use xmalloc, xrealloc, xfree.

2008-02-03  Jason Rumney  <jasonr@gnu.org>

	* makefile.w32-in (OBJ1): Include font.o here.
	(FONTOBJ) [USE_FONTBACKEND]: Instead of here.

2008-02-02  Jason Rumney  <jasonr@gnu.org>

	* makefile.w32-in (temacs): Bump EMHEAP to 21.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* s/cygwin.h: Define VIRT_ADDR_VARIES.

	* puresize.h [VIRT_ADDR_VARIES]: Don't include CYGWIN in condition.

2008-02-01  Andreas Schwab  <schwab@suse.de>

	* Makefile.in (shortlisp, lisp): Update for rename of
	../lisp/language/myanmar.el.

2008-02-01  Chong Yidong  <cyd@stupidchicken.com>

	* xfaces.c (get_lface_attributes): Delete function.
	(merge_named_face, lookup_named_face, lookup_derived_face)
	(realize_named_face): Call lface_from_face_name directly, and use
	the fact that merge_face_vectors does not alter its FROM argument.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (w32_read_socket) <WM_CHAR>: Decode non-Unicode
	input in the default locale.  Handle non-Unicode multibyte input.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* fontset.c (reorder_font_vector): Exclude nil elements from the
	font group.  Don't try multiple fonts.
	(fontset_font): Adjust for the above change.
	(Finternal_char_font): Return nil if the found font doesn't
	contain the character ch.

	* Makefile.in (lisp, shortlisp): Add cham.el.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* font.h (FONTP): Make it return 1 also for a font-object.

	* .gdbinit (xfontset): New function.

	* font.c (font_find_for_lface): Check if the character C is
	supported or not only for the first font.

	* fontset.c (reorder_font_vector): Fix typo.
	(fontset_find_font): Don't add a font-spec specifying a script.
	Use 0 (not Qt) for the indication of empty font-group.  Change the
	format of RFONT-DEF.  Return Qt if no font in the font-group
	support the character.
	(fontset_font): Adjust for the above change.  If no font was
	found the character, remember that.
	(face_for_char): Adjust for the change of RFONT-DEF.
	(Fset_fontset_font): Allow nil for FONT-SPEC to explicitly specify
	no font for the target.
	(Finternal_char_font): Adjust for the change of RFONT-DEF.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* font.c (font_load_for_face): Handle the case that the font in
	face->lface is a string.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* xfaces.c (set_lface_from_font_and_fontset): Set the fontname in lface.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* xfaces.c (Finternal_set_lisp_face_attribute) [USE_FONT_BACKEND]:
	Fix previous change.  If the frame is not on a window system,
	signal an error.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* coding.c (decode_coding_object, encode_coding_object): Adjust
	marker positions after conversion.

	* lisp.h (struct Lisp_Marker): New member need_adjustment.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* font.c (font_find_for_lface): Fix the handling of the return
	value of font_has_char.
	(Ffont_shape_text): Fix previous change.

	* fontset.c (FONTSET_REF_AND_RANGE): Delete it.
	(fontset_ref_and_range): Delete it.
	(fontset_find_font): Call char_table_ref_and_range instead of
	FONTSET_REF_AND_RANGE.
	(make_fontset): Don't setup font groups of Latin here.
	(Fset_fontset_font): Don't overwrite the setting of FONTSET_ASCII.
	(new_fontset_from_font): Make the specified font the default for
	all Latin characters.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* xfaces.c (Finternal_set_lisp_face_attribute): Check if the frame
	is on a window system before accessing the fontset of the frame.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* Makefile.in (lisp, shortlisp): Add kherm.el and myanmar.el.

	* ftfont.c (ftfont_driver): Set ftfont_shape in ftfont_driver only
	when both HAVE_M17N_FLT and HAVE_LIBOTF are defined.

	* font.c (Ffont_shape_text): If the font driver doesn't have a
	shaper function, make zero-width glyphs to have at least one-pixel
	width.  Fix setting of `to' field of glyphs.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* ftfont.c (ftfont_drive_otf): Fix setting of FROM and TO slots of
	glyphs.

	* font.h (struct font_driver): Improve docstring of member `shape'.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* composite.c (syms_of_composite): Fix docstring of
	auto-composition-function.

	* font.h (LGLYPH_SIZE): New macro.

	* font.c (Ffont_fill_gstring): Stop filling when a character not
	supported by the font is found.
	(Ffont_shape_text): When a shape callback function returns nil,
	try at most two more times with larger gstring.
	(Ffont_at): Fix getting of w.  Call font_at with correct 5th argument.

	* xdisp.c (handle_auto_composed_prop): Change the argument to
	auto-composition-function.

	* ftfont.c (ftfont_encode_char): Use the macro FONT_INVALID_CODE.
	(ftfont_shape_by_flt): If an element of lgstring is nil, make a
	Lispy glyph and store it in the lgstring.

	* xfont.c (xfont_encode_char): Use the macro FONT_INVALID_CODE.

	* xftfont.c (xftfont_encode_char): Use the macro FONT_INVALID_CODE.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* font.c (Ffont_shape_text): Avoid unnecessary composition.

	* fontset.c (Vfont_encoding_charset_alist): New variable.
	(syms_of_fontset): DEFVAR it.
	(reorder_font_vector, fontset_find_font): Optimize for the case of
	no need of reordering.
	(face_for_char): Map the charset property by
	Vfont_encoding_charset_alist.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (logfonts_match): Don't check adstyle here.
	(font_matches_spec): Check here against physical font instead.
	(add_font_entity_to_list): Avoid some substitutions.

	* font.c (font_parse_fcname): Default weight and slant to normal.
	(font_score): Prefer normal fonts if weight or slant unspecified.
	(font_score) [WINDOWSNT]: Scale weight difference down to closer
	match freetype scores.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_text_extents): Don't use the frame stored in the
	font, as it may have been deleted.
	(w32_enumfont_pattern_entity): Map generic family to adstyle using
	most common hyphenless variation.
	(logfonts_match): Check generic family.
	(font_matches_spec): Don't check generic family here.
	(fill_in_logfont): Set generic family based on adstyle.

	* w32font.h (w32font_get_cache): Update declaration.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* ftfont.c (ftfont_get_cache): Adjust the argument type.

	* frame.c (x_set_font_backend): Don't call Fclear_font_cache.
	If none of the new drivers are available, call font_update_drivers
	with the old drivers.

	* w32font.c (w32font_get_cache): Adjust the argument type.

	* xfont.c (xfont_get_cache): Adjust the argument type.

	* font.h (struct font_driver): Change argument type of get_cache.

	* xftfont.c (xftfont_start_for_frame): Delete prototype.

	* font.c (Ffont_get): Fix arguments to Fassoc.
	(font_prepare_cache, font_finish_cache, font_get_cache): New functions.
	(font_clear_cache): New function.
	(font_list_entities, font_matching_entity): Use font_get_cache.
	(font_update_drivers): Call font_clear_cache when finishing a driver.

	* fontset.c (fontset_find_font): Fix previous change.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* xterm.c (x_check_font) [USE_FONT_BACKEND]: Don't access
	dpyinfo->font_table.
	(x_delete_display) [USE_FONT_BACKEND]: Likewise.
	(x_delete_terminal) [USE_FONT_BACKEND]: Likewise.

	* font.c (font_at): Handle the case that the arg C is negative.
	Handle the unibyte case.
	(Ffont_at): Call font_at with the arg C -1.

	* xdisp.c (handle_auto_composed_prop): Don't get a character at
	the position here, and call font_at with the arg C -1.
	Don't check the range of the existing composition at the point.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* fontset.c (fontset_add): New args charset_id and family.
	Change caller.
	(load_font_get_repertory, fontset_find_font): Assume that
	font_spec is always a font-spec object.
	(Fset_fontset_font): Always store a font-spec object in a fontset.

	* xdisp.c (handle_auto_composed_prop): Use Fget_text_property
	instead of get_property_and_range.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* xftfont.c (struct xftfont_info): Delete the member ft_face.
	(xftfont_open): Don't keep locking face.
	(xftfont_close): Don't unlock face.
	(xftfont_anchor_point, xftfont_shape): Lock and unlock face.

	* fontset.c (fontset_find_font): Don't prefer a font of
	supplementary charset.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* ftfont.c (struct OpenTypeSpec): Rename members script_tag to
	script, langsys_tag to langsys, new member script.
	(OTF_TAG_STR): Terminate by '\0'.
	(ftfont_get_open_type_spec): If :otf prop is is spec, Limit the
	listing to the script specified in that property.  Fix arg to
	OTF_check_features.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32font.h: New file.

	* w32font.c: Include it.
	(struct w32font_info): Add owning_frame field.  Move to w32font.h.
	(w32font_open): Set owning_frame.
	(w32font_text_extents): Use owning_frame.
	(struct font_callback_data): Add opentype_only field.
	(add_font_entity_to_list): Use it to filter fonts.
	Don't check against full name.
	(w32font_list_internal): New function.
	(w32font_list): Use it.
	(w32font_match_internal): New function.
	(w32font_match): Use it.
	(w32font_open_internal): New function.
	(w32font_open): Use it.
	(w32font_get_cache, w32font_close, w32font_has_char)
	(w32font_encode_char, w32font_text_extents, w32font_draw):
	Make non-static.

	* makefile.w32-in (w32font.o): Depend on w32font.h.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* charset.c (Fdefine_charset_internal): Record a supplementary
	charset at the tail of Vcharset_order_list.

	* font.c (Ffont_shape_text): Fix the return value.

	* ftfont.c (OTF_SYM_TAG, OTF_TAG_STR): Fix argument names.

	* xdisp.c (handle_auto_composed_prop): Fix previous change.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* ftfont.c (struct OpenTypeSpec): New struct.
	(OTF_SYM_TAG, OTF_TAG_STR): New macros.
	(ftfont_get_open_type_spec): New function.
	(ftfont_list) [HAVE_LIBOTF]: Check otf-spec property.

	* lread.c (read1): Redo the previous change with checking Vpurify_flag.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (add_font_entity_to_list): Compare only the beginning
	of full name.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (handle_auto_composed_prop): Simplify the code.
	Never return HANDLED_RECOMPUTE_PROPS.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* font.c (font_gstring_produce): Delete it.

	* composite.h (COMPOSITION_METHOD):
	Handle COMPOSITION_WITH_GLYPH_STRING.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* xfont.c (Qx): Delete.
	(syms_of_xfont): Don't initialize Qx.

	* composite.h (enum composition_method):
	Define COMPOSITION_WITH_GLYPH_STRING unconditionally.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* xfaces.c [HAVE_WINDOW_SYSTEM]: Include "font.h" unconditionally.
	(choose_face_font): Accept new form of font-spec.

	* frame.h (font_driver_list): Declare it unconditionally.
	(struct frame): Define members font_driver_list and font_data_list
	unconditionally.

	* fontset.c: Include "font.h" unconditionally.
	(generate_ascii_font_name): Use font_parse_xlfd and font_unparse_xlfd.
	(Fset_fontset_font): Accept a font-spec object.

	* font.c (font_unparse_xlfd): If pixel_size is zero, make the
	PIXEL_SIZE part a wild card.

	* dispextern.h (struct glyph_string): Define members clip and
	num_clips unconditionally.
	(struct face): Define members font_info and extra unconditionally.

	* ftfont.c (ftfont_open): Set members maybe_otf and otf of
	ftfont_info only when HAVE_LIBOTF is defined.

2008-02-01  Andreas Schwab  <schwab@suse.de>

	* xdisp.c (back_to_previous_visible_line_start): Fix type of beg
	and end.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_driver): Add new fields.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* Makefile.in (ALL_CFLAGS): Add @M17N_FLT_CFLAGS@.
	(FONTSRC, FONTOBJ) [HAVE_WINDOW_SYSTEM]: Set them unconditionally.
	(LIBES): Add @M17N_FLT_CFLAGS@.

	* composite.c (compose_text): Don't treat the new style
	composition specially.

	* emacs.c (main): Call syms_of_font unconditionally.

	* font.h (FONT_ENTITY_NOT_LOADABLE)
	(FONT_ENTITY_SET_NOT_LOADABLE): New macros.
	(LGSTRING_XXXX, LGLYPH_XXX): Adjust for the change of lispy gstring.
	(struct font_driver): New member shape.
	(font_registry_charsets): Extern it.
	(font_find_for_lface, font_prepare_composition): Adjust prototype.
	(font_otf_capability, font_drive_otf): Delete their externs.

	* font.c [HAVE_M17N_FLT]: Include <m17n-flt.h>.
	(font_charset_alist, font_registry_charsets): Move from xfont.c
	and rename.
	(font_prop_validate_otf): New function.
	(font_property_table): Register it for QCotf.
	(DEVICE_DELTA, adjust_anchor, REPLACEMENT_CHARACTER)
	(font_drive_otf): Delete.
	(font_prepare_composition): New arg F.  Adjust for the change of
	lispy gstring.
	(font_find_for_lface): New arg C.
	(font_load_for_face): Adjust for the change of font_find_for_lface.
	(Ffont_make_gstring, Ffont_fill_gstring): Adjust for the change of
	lispy gstring.
	(Ffont_shape_text): New function.
	(Fopen_font): If the font size is not given, use 12-pixel.
	(Ffont_at): New arg STRING.
	(syms_of_font): Initalize font_charset_alist.
	Declare Ffont_shape_text as a Lisp function.  Call syms_of_XXfont
	conditionally.

	* fontset.c (fontset_find_font) [USE_FONT_BACKEND]: Try multiple
	fonts of the same font-spec.  Change the format of RFONT-DEF.
	(face_for_char, make_fontset_for_ascii_face, Finternal_char_font):
	Adjust for the change of RFONT-DEF.
	(Fset_fontset_font) [USE_FONT_BACKEND]: Handle new format of font-spec.

	* ftfont.h: New file.

	* ftfont.c: Don't include Freetype headers.  Include "ftfont.h".
	(struct ftfont_info) [HAVE_LIBOTF]: New members maybe_otf and otf.
	(ftfont_open) [HAVE_LIBOTF]: Initialize the above members.
	(ftfont_driver) [HAVE_LIBOTF, HAVE_M17N_FLT]: Don't set
	font_otf_capability and font_drive_otf, set ftfont_shape.
	(ftfont_list): Adjust for the change of :otf property value.
	(struct MFLTFontFT) [HAVE_LIBOTF, HAVE_M17N_FLT]: New struct.
	(ftfont_get_glyph_id, ftfont_get_metrics, ftfont_check_otf)
	(adjust_anchor, ftfont_drive_otf, ftfont_shape_by_flt)
	(ftfont_shape) [HAVE_LIBOTF, HAVE_M17N_FLT]: New function.
	(DEVICE_DELTA) [HAVE_LIBOTF, HAVE_M17N_FLT]: New macro.
	(otf_gstring, gstring, m17n_flt_initialized): New variables.

	* w32term.c (x_draw_composite_glyph_string_foreground):
	Adjust for the change of lispy gstring.

	* xdisp.c (handle_composition_prop): Adjust for the change of
	lispy gstring.  Call a function for auto-composition with the
	third arg it->window.
	(fill_composite_glyph_string): Adjust for the change of lispy string.
	(x_produce_glyphs): Adjust for the change of font_prepare_compositionl.

	* xfaces.c (set_font_frame_param): Adjust for the change of
	font_find_for_lface.

	* xfont.c (x_font_charset_alist): Move to font.c and rename.
	(xfont_registry_charsets): Likewise.  Change caller.
	(syms_of_xfont): Don't handle x_font_charset_alist.

	* xftfont.c: Include "ftfont.h".
	(struct xftfont_info) [HAVE_LIBOTF]: New members maybe_otf and otf.
	(xftfont_open) [HAVE_LIBOTF]: Initialize the above members.
	(xftfont_close) [HAVE_LIBOTF]: Close otf.
	(xftfont_shape) [HAVE_LIBOTF, HAVE_M17N_FLT]: New function.
	(syms_of_xftfont) [HAVE_LIBOTF, HAVE_M17N_FLT]:
	Set xftfont_driver.shape to xftfont_shape.

	* xterm.c (x_draw_composite_glyph_string_foreground): Adjust for
	the change of lispy gstring.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* ftxfont.c (ftxfont_end_for_frame): Fix array indexing error.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_draw): Fill background manually.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* font.c (Qfontp): Remove unused symbol.
	(QCantialias): New symbol.
	(syms_of_font): Define it.
	(font_property_table): Set a validator for QCantialias.

	* w32font.c (CLEARTYPE_QUALITY, CLEARTYPE_NATURAL_QUALITY):
	Define if not already.
	(QCfamily): Share with xfaces.c.
	(Qstandard, Qsubpixel, Qnatural): New symbols.
	(syms_of_w32font): Define them.  Don't define QCfamily here.
	(w32_antialias_type, lispy_antialias_type): New functions.
	(w32_enumfont_pattern_entity): New arg requested_font.
	Set antialias parameter if non-default was requested.
	(fill_in_logfont): Fill in lfQuality if :antialias specified.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* lread.c (read1): Undo the previous change.

2008-02-01  CHENG Gao  <chenggao@gmail.com>  (tiny change)

	* frame.c (Fdelete_frame): Call font_update_drivers only when
	USE_FONT_BACKEND is defined.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* font.h (struct font_bitmap): New member bits_per_pixel.
	(struct font_driver): New members start_for_frame and end_for_frame.
	(struct font_data_list): New struct.
	(font_put_frame_data, font_get_frame_data): Extern them.

	* frame.h (struct frame): New member font_data_list.

	* font.c (font_update_drivers): Call driver->start_for_frame and
	driver->end_for_frame at proper timings.
	(font_put_frame_data, font_get_frame_data): New functions.
	(Ffont_spec): Add usage in the docstring.

	* frame.c (make_frame): Initialize f->font_data_list to NULL.
	(Fdelete_frame): Call font_update_drivers.

	* xftfont.c (struct xftface_info): Delete the member xft_draw.
	(xftfont_prepare_face, xftfont_done_face): Adjust for the above change.
	(xftfont_get_xft_draw): New function.
	(xftfont_draw): Get XftDraw by xftfont_get_xft_draw.
	(xftfont_end_for_frame): New function.
	(syms_of_xftfont): Set xftfont_driver.end_for_frame.

	* ftxfont.c (ftxfont_get_gcs): Rename from ftxfont_create_gcs.
	Change argument.  Cache GCs in the per-frame data.
	(struct ftxfont_frame_data): New struct.
	(ftxfont_draw_bitmap): New arg gc_fore and flush.
	(ftxfont_prepare_face, ftxfont_done_face): Delete them.
	(ftxfont_draw): Get GCs by ftxfont_get_gcs.  Reflect s->clip in GCs.
	(ftxfont_end_for_frame): New function.
	(syms_of_ftxfont): Set ftxfont_driver.end_for_frame.

	* ftfont.c (ftfont_get_bitmap): Set bitmap->bits_per_pixel.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xselect.c (Vselection_coding_system)
	(Vnext_selection_coding_system): Delete them.
	(syms_of_xselect): Don't declare selection-coding-system and
	next-selection-coding-system.  They are declared in select.el.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32term.h (WM_UNICHAR, UNICODE_NOCHAR): Define if not already.

	* w32fns.c: Include imm.h.
	(get_composition_string_fn, get_ime_context_fn): New optional
	system functions.
	(globals_of_w32fns): Load them from imm32.dll.
	(ignore_ime_char): New flag.
	(w32_wnd_proc): Handle WM_UNICHAR, WM_IME_CHAR and
	WM_IME_ENDCOMPOSITION messages.

	* w32term.c (w32_read_socket) [WM_UNICHAR]: Handle as
	MULTIBYTE_CHAR_KEYSTROKE_EVENT.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* lread.c (READCHAR): Call readchar with the 2nd arg NULL.
	(READCHAR_REPORT_MULTIBYTE): New macro.
	(readchar): New 2nd arg MULTIBYTE.
	(read1): Use READCHAR_REPORT_MULTIBYTE for the first read.
	Make symbol's name multibyte according to the multibyteness of the
	source.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* xfaces.c (face_for_overlay_string): Call lookup_face with
	correct arguments (fix of synching with the trunk).

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* font.c (font_prop_validate_symbol, font_prop_validate_style)
	(font_prop_validate_non_neg, font_prop_validate_spacing):
	Delete argument prop_index.
	(font_property_table): Change arguments to validater.  Change Callers.
	(font_lispy_object): Delete.
	(font_at): Use font_find_object instead fo font_lispy_object.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* fileio.c (Fexpand_file_name): Adjust multibyteness of directory
	and file names.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (add_font_name_to_list): Avoid vertical fonts.
	(font_matches_spec): Remove debug output.
	(add_font_entity_to_list): Avoid using substituted fonts.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* doc.c (Fsnarf_documentation):
	* Makefile.in (temacs${EXEEXT}, mostlyclean): Undo last change.

2008-02-01  Miles Bader  <miles@gnu.org>

	* dispextern.h (struct glyph_row): Only define "clip" field if
	HAVE_WINDOW_SYSTEM is defined.

2008-02-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	Fix up multi-tty merge.

	* xterm.c (handle_one_xevent): Remove duplicate code and fix up nesting
	and indentation.

	* xfaces.c (free_realized_face, clear_face_gcs):
	Include font_done_for_face in the input_blocked section, just in case.

	* xdisp.c (decode_mode_spec): Use terminal-local coding systems.
	(get_char_face_and_encoding): Undo last change and remove the *other*
	duplicate definition (i.e. keep the one that's better scoped and that
	includes code for the font-backend).

	* terminal.c (create_terminal): Default keyboard_coding to
	`no-conversion' and terminal_coding to `undecided'.

	* lread.c (read1): Use XSETPVECTYPE to set a pseudovector's tag.

	* fontset.c (free_realized_fontsets): Check that the table entry does
	contain a fontset before trying to compare it to `base'.

	* emacs.c (main): Move syms_of_data, syms_of_fileio, syms_of_alloc,
	syms_of_charset, and syms_of_coding earlier because init_window_once
	now needs Vcoding_system_hash_table to be setup.

	* coding.h (default_buffer_file_coding): Remove.

	* coding.c (default_buffer_file_coding): Remove.
	(Fterminal_coding_system, Fkeyboard_coding_system): Use ->id rather
	than ->symbol, and use the terminal-local coding system.
	(syms_of_coding): Don't setup the coding-systems that are not
	terminal-local.
	(Fdefine_coding_system_internal): Use XCAR/XCDR.

	* chartab.c (Fmake_char_table, make_sub_char_table, copy_char_table):
	Use XSETPVECTYPE now that XSETCHAR_TABLE doesn't set the tag anymore.

	* alloc.c (Fmake_char_table, make_sub_char_table): Remove.  They're now
	in chartab.c and were re-added here by mistake.
	(Fpurecopy): Use XSETPVECTYPE after copying a COMPILED pseudovector.

	* doc.c (Fsnarf_documentation):
	* Makefile.in (temacs${EXEEXT}, mostlyclean): Move buildobj.lst from
	src to etc.

	* ChangeLog.10: Add mistakenly removed entry.

2008-02-01  Dan Nicolaescu  <dann@ics.uci.edu>

	* Makefile.in (fringe.o, minibuf.o): Fix dependencies.

2008-02-01  Miles Bader  <miles@gnu.org>

	* xdisp.c (get_char_face_and_encoding): Remove extraneous definition.
	Add extra args to FACE_FOR_CHAR.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* keymap.c (where_is_internal_1): If key is a cons, store the copy
	in sequence.

	* chartab.c (map_sub_char_table, map_char_table): If the range
	contains just one character, call the function with that character
	even if the depth is not 3.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_text_extents): Calculate metrics for the
	whole string.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32xfns.c (get_next_msg): Consolidate WM_PAINT messages.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (x_set_glyph_string_clipping): Use
	get_glyph_string_clip_rects.
	(x_set_glyph_string_clipping_exactly, x_draw_glyph_string):
	Adjust for the change of struct glyph_string.

	* w32font.c (w32font_draw): Do clipping here.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xftfont.c (xftfont_draw): Adjust for the change of struct
	glyph_string.

	* xterm.c (x_set_glyph_string_clipping): Use
	get_glyph_string_clip_rects.
	(x_set_glyph_string_clipping_exactly, x_draw_glyph_string):
	Adjust for the change of struct glyph_string.

	* xdisp.c (get_glyph_string_clip_rects): Reflect s->row->clip to
	the resulting clip(s}.
	(expose_overlaps): Add arg r.  Change callers.  Set it to
	row->clip temporarily.
	(expose_window): Redraw rows overlapping the exposed area.

	* dispextern.h (struct glyph_row): New member clip.
	(struct glyph_string): Delete members clip_x, clip_y, clip_width,
	clip_height, new member clip, and num_clips.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* data.c (Fchar_or_string_p): Fix docstring.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xftfont.c (xftfont_draw): If s->font_info != s->face->font_info,
	create a temporal XftDraw object.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* font.c (Ffontp): Fix docstring.

	* coding.c (detect_coding_iso_2022): Don't treat SI/SO codes as a
	strong evidence of ISO-2022.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* abbrev.c (abbrev_check_chars): Use CHAR_TABLE_REF, not
	SYNTAX_ENTRY_FOLLOW_PARENT.

2008-02-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fns.c (weak_hash_tables): Rename from Vweak_hash_tables and change
	its type.
	(make_hash_table, copy_hash_table, sweep_weak_hash_tables, init_fns):
	Update to the new type of weak_hash_tables and next_weak.

	* lisp.h (struct Lisp_Hash_Table): Change next_weak from Lisp_Object to
	a plain C pointer to Lisp_Hash_Table.

	* lisp.h (XGCTYPE, GC_HASH_TABLE_P, GC_NILP, GC_NUMBERP, GC_NATNUMP)
	(GC_INTEGERP, GC_SYMBOLP, GC_MISCP, GC_VECTORLIKEP, GC_STRINGP)
	(GC_CONSP, GC_FLOATP, GC_VECTORP, GC_OVERLAYP, GC_MARKERP)
	(GC_INTFWDP, GC_BOOLFWDP, GC_OBJFWDP, GC_BUFFER_OBJFWDP)
	(GC_BUFFER_LOCAL_VALUEP, GC_SOME_BUFFER_LOCAL_VALUEP)
	(GC_KBOARD_OBJFWDP, GC_PSEUDOVECTORP, GC_WINDOW_CONFIGURATIONP)
	(GC_PROCESSP, GC_WINDOWP, GC_SUBRP, GC_COMPILEDP, GC_BUFFERP)
	(GC_SUB_CHAR_TABLE_P, GC_CHAR_TABLE_P, GC_BOOL_VECTOR_P, GC_FRAMEP)
	(GC_EQ): Remove since they've been identical to their non-GC_
	alter-egos ever since the markbit was eradicated.

	* alloc.c:
	* buffer.c:
	* buffer.h:
	* data.c:
	* fileio.c:
	* filelock.c:
	* fns.c:
	* frame.h:
	* lisp.h:
	* macterm.c:
	* print.c:
	* process.c:
	* w32fns.c:
	* w32menu.c:
	* w32term.c:
	* xfns.c:
	* xmenu.c:
	* xterm.c: Replace uses of GC_* macros with the non-GC_ versions.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* chartab.c (map_sub_char_table): Make it work for the top-level
	char-table.  Fix handling of parent char-table.
	(map_char_table): Adjust for the above change.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (Qgdi): Rename from Qw32.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32bdf.c (get_quoted_string): Make function static.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xftfont.c (xftfont_open): If one of font's ASCII glyph has
	bigger ascent and descent than those of the font, use them as
	font's ascent and descent.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* Makefile.in (${lispsource}international/charprop.el): Move this
	target within "#ifdef HAVE_UNIDATA" and "#endif".

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* Makefile.in (lisp): Add ${lispsource}language/tai-viet.el.
	(shortlisp): Add ../lisp/language/tai-viet.el.

2008-02-01  Ulrich Mueller  <ulm@gentoo.org>

	* Makefile.in (${lispsource}international/charprop.el): Depend on
	temacs${EXEEXT}.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_close): Delete the GDI font object.

	* w32menu.c: Include character.h.

	* w32proc.c: Likewise.

	* w32select.c: Likewise.

	* makefile.w32-in (w32proc.o): Depend on character.h.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (syms_of_w32fns): Use DEFSYM macro.

	* w32menu.c (syms_of_w32menu): Likewise.

	* w32proc.c (syms_of_ntproc): Likewise.

	* w32select.c (syms_of_w32select): Likewise.

	* w32term.c (syms_of_w32term): Likewise.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_draw): Delete brush after using it.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_open): Don't set font_idx.
	(w32font_text_extents): Try GetTextExtentPoint32W before defaulting
	to font settings.
	(w32font_draw): Fill background explicitly.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (w32_initialize): Don't call w32font_initialize.

	* w32font.c (w32font_info): Remove subranges.
	(QCsubranges, Qmodern, Qswiss, Qroman): Remove.
	(QCfamily, Qmonospace, Qsans_serif, Qmono, Qsans, Qsans__serif)
	(Qraster, Qoutline, Qlatin, Qgreek, Qcoptic, Qcyrillic, Qarmenian)
	(Qhebrew, Qarabic, Qsyriac, Qnko, Qthaana, Qdevanagari, Qbengali)
	(Qgurmukhi, Qgujarati, Qoriya, Qtamil, Qtelugu, Qkannada)
	(Qmalayalam, Qsinhala, Qthai, Qlao, Qtibetan, Qmyanmar, Qgeorgian)
	(Qhangul, Qethiopic, Qcherokee, Qcanadian_aboriginal, Qogham)
	(Qrunic, Qkhmer, Qmongolian, Qsymbol, Qbraille, Qhan)
	(Qideographic_description, Qcjk_misc, Qkana, Qbopomofo, Qkanbun)
	(Qyi, Qbyzantine_musical_symbol, Qmusical_symbol, Qmathematical):
	New symbols.
	(font_callback_data): New struct.
	(w32font_list, w32font_match): Use it.
	(w32font_open): Don't populate subranges.
	(w32font_has_char): Use script Lisp symbols, not subrange bitmask.
	(w32font_encode_char): Always return unicode code-point as-is.
	(w32font_text_extents): Supply a tranformation matrix to
	GetGlyphOutline.  Never look up by glyph index.  Avoid looping
	twice.  Use unicode version of GetTexExtentPoint32 instead of
	glyph index version.
	(set_fonts_frame): Remove.
	(w32_enumfont_pattern_entity): Add frame parameter, use it to
	set frame parameter.  Use backward compatible fake foundries.
	Save generic family in extra slot under QCfamily.  Make width slot
	constant.  Save QCspacing value.  Save list of scripts instead of
	binary subranges.
	(w32_generic_family, logfonts_match, font_matches_spec): New functions.
	(add_font_entity_to_list): Use font_callback_data struct.  Filter
	unwanted fonts.
	(add_one_font_entity_to_list): Use font_callback_data struct.
	(w32_registry): Default to iso10646_1.
	(fill_in_logfont): Use dpi from extra slot.  Don't bother with
	string font registries.  Don't fill in font name if it is a generic
	family name, fill family instead.  Use spacing, family and script
	extra info to fill pitch, family and charset fields.
	(list_all_matching_fonts): Use font_callback_data struct.
	(unicode_range_for_char): Remove.
	(font_supported_scripts): New function.
	(w32font_initialize): Remove.
	(syms_of_w32font): Update which symbols are defined.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* font.c (font_pixel_size): Reverse assq_no_quit args.

	* w32term.h (FONT_WIDTH): Report max width, not average.
	(FONT_MAX_WIDTH): Remove.
	(FONT_AVG_WIDTH): New macro.

	* xfaces.c (Fx_list_fonts) [WINDOWSNT]: Remove Windows only
	redefinition of FONT_WIDTH.

	* w32term.c (x_font_min_bounds): Use FONT_AVG_WIDTH.
	(w32_cache_char_metrics): Use FONT_WIDTH.

	* w32fns.c (w32_load_system_font, w32_list_fonts): Use FONT_AVG_WIDTH.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_open): Make lfHeight negative.

	* w32fns.c (x_default_font_parameter): Use new style font name.
	(Fx_create_frame, x_create_tip_frame): Initialize resx and resy.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (QCsubranges): New symbol.
	(w32font_open, w32font_has_char): Get subranges from subproperty
	of extra.
	(w32_enumfont_pattern_entity): Set subranges as subproperty of extra.
	(syms_of_w32font): Define :subranges symbol.

	* font.c (font_put_extra): Expose externally.

	* font.h (font_put_extra): Move declaration from font.c.

	* font.c (Ffont_get): Use font driver to determine otf capability.
	(adjust_anchor): Check if driver defines anchor_point before using.

	* w32font.c (w32font_open): Handle size, height and pixel_size better.
	(w32font_draw): Use options.
	(w32_enumfont_pattern_entity): Set size to 0 for scalable fonts.
	Fix detection of truetype fonts.
	(registry_to_w32_charset): Handle charsets other than iso8859-1
	expressed as lisp symbols.
	(w32_registry): Express charset as lisp symbol.
	(fill_in_logfont): Reverse pixel and point height logic.
	Don't set width here.  Set quality to default.

	* w32fns.c (w32_load_system_font): Fix detecting FIXED_PITCH fonts.
	(x_to_w32_font): Fill in lfPitchAndFamily correctly.

	* xterm.c (x_draw_glyph_string_foreground) [USE_FONT_BACKEND]:
	Remove redundant loop and allocation.

	* makefile.w32-in (font.o, w32font.o): New objects.
	(fontset.o, xdisp.o, xfaces.o, w32fns.o, w32term.o): Depend on font.h.
	(FONTOBJ): New group of objects conditioned on USE_FONT_BACKEND.

	* xdisp.c (fill_composite_glyph_string): Make the first arg to
	STORE_XCHARB a valid l-value.

	* w32term.c (w32_native_per_char_metric): Swap width and rbearing
	calculations for non-Truetype fonts.
	(x_draw_glyph_string): Sync with xterm.c.
	(x_draw_glyph_string_foreground) [USE_FONT_BACKEND]:
	Remove redundant code.
	(w32_initialize) [USE_FONT_BACKEND]: Call w32font_initialize.

	* w32term.h (w32_output_data) [USE_FONT_BACKEND]: Add fontp member.
	(FRAME_FONT_OBJECT) [USE_FONT_BACKEND]: New macro from xterm.h.

	* w32fns.c [USE_FONT_BACKEND]: Port font backend changes from xfns.c.
	(x_to_w32_charset, w32_to_x_charset): Expose externally.

	* w32font.c: New file for w32 font backend.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* term.c: Don't include "buffer.h" twice.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* character.c (Funibyte_string): New function.
	(syms_of_character): Defsubr it.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32term.c [USE_FONT_BACKEND]:
	(x_get_font_repertory, note_mouse_movement, x_set_mouse_face_gc)
	(x_set_glyph_string_clipping, x_set_glyph_string_clipping_exactly)
	(x_draw_glyph_string, x_draw_glyph_string_foreground)
	(x_draw_composite_glyph_string_foreground, x_new_fontset2)
	(x_free_frame_resources): Sync with xterm.c.

2008-02-01  Andreas Schwab  <schwab@suse.de>

	* lread.c (read1): Use CHAR_TABLE_STANDARD_SLOTS to validate
	char-table size.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* font.c (check_otf_features): Define it regardless of HAVE_LIBOTF.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* ftfont.c (ftfont_driver): Delete font_otf_gsub and
	font_otf_gpos, add font_drive_otf.

	* fontset.c (fontset_find_font): Pay attention to font size
	specified for a font.
	(reorder_font_vector): Check contents of font_def.

	* font.c (struct otf_list): Delete it.
	(otf_list): Make it a lisp variable.
	(otf_open): Use lispy otf_list.
	(generate_otf_features): Rename from parse_gsub_gpos_spec.
	(check_otf_features): New function.
	(font_otf_DeviceTable, font_otf_ValueRecord, font_otf_Anchor):
	New functions.
	(font_drive_otf): New function merging font_otf_gsub and
	font_otf_gpos.
	(font_open_for_lface): New arg spec.  Change argument order.
	(font_load_for_face): Adjust for the change of font_open_for_lface.
	(Ffont_drive_otf): New function merging Ffont_otf_gsub and
	Ffont_otf_gpos.
	(syms_of_font): Staticpro otf_list.  Delete defsubr of
	Sfont_otf_gsub and Sfont_otf_gpos.  Defsubr Sfont_drive_otf.

	* xfaces.c (set_font_frame_param): Adjust for the change of
	font_open_for_lface.

	* font.h (font_open_for_lface): Adjust prototype.
	(struct font_driver): Delete members otf_gsub and otf_gpos, add
	member otf_drive.
	(font_otf_gsub, font_otf_gpos): Delete externs.
	(font_drive_otf): Extern it.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* font.c (font_at): If the window W is not on a window system,
	return Qnil.

	* coding.c (produce_chars, encode_coding): Don't call
	insert_from_gap if no characters to produce.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* fontset.c (free_realized_fontsets): Avoid unnecessary call of
	Fclear_face_cache.

	* xfaces.c (face_for_font): Check also face->font==font->font.font.

2008-02-01  Miles Bader  <miles@gnu.org>

	* emacs.c (main): Change default value of `enable_font_backend' to 1.
	Parse "--disable-font-backend" option.
	(standard_args): Add "--disable-font-backend" option.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* fontset.c (fontset_find_font): New function.
	(fontset_font): Use fontset_find_font.
	(make_fontset_for_ascii_face): Don't set face ID in rfont_def.
	Register the specified font for all Latin characters.
	(new_fontset_from_font): Register the specified font for all Latin
	characters.
	(dump_fontset): For a realized fontset, include the base fontset
	name in the returned vector.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* character.h (CHAR_STRING): Cast C to unsigned on calling
	char_string.

	* character.c (char_string): Type of arg C changed to unsigned.
	Signal an error if C is an invalid character code.

	* editfns.c (general_insert_function, Fchar_to_string):
	Use CHARACTERP, not INTEGERP.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* character.h (MIN_MULTIBYTE_LEADING_CODE)
	(MAX_MULTIBYTE_LEADING_CODE): New macros.

	* regex.c (analyse_first): Fix for multibyte characters in "case
	charset:" and "case categoryspec:".

2008-02-01  Andreas Schwab  <schwab@suse.de>

	* Makefile.in (LIBES): Move standard libraries to the end.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* alloc.c (Fgarbage_collect): If nextb->text->inhibit_shrinking is
	nonzero, don't shrink the buffer nextb.

	* buffer.h (struct buffer_text): New member inhibit_shrinking.

	* coding.c (coding_alloc_by_making_gap): New arg offset.
	(alloc_destination): Call coding_alloc_by_making_gap with the arg
	offset.
	(decode_coding_iso_2022): Update coding->safe_charsets.
	(decode_coding_gap): Temporarily set
	current_buffer->text->inhibit_shrinking to 1.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xterm.c (x_draw_composite_glyph_string_foreground): Fix
	indexing into elements of s->cmp and s->char2b.

2008-02-01  Juanma Barranquero  <lekktu@gmail.com>

	* regex.c (RE_STRING_CHAR_AND_LENGTH) [! emacs]: Add missing arg `len'.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* regex.c (GET_CHAR_BEFORE_2, GET_CHAR_AFTER): Check the variable
	target_multibyte instead of multibyte.
	(re_match_2_internal): Call bcmp_translate with target_multibyte.
	(bcmp_translate): Change the argument name from multibyte to
	target_multibyte.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	These changes are to compile a regexp into a pattern that can be
	used both for multibyte and unibyte targets.

	* Makefile.in (search.o): Depend on charset.h.

	* character.c (multibyte_char_to_unibyte_safe): New function.

	* search.c: Include "charset.h".
	(compile_pattern_1): Delete argument multibyte.  Don't set
	cp->buf.target_multibyte here.  Set cp->buf.charset_unibyte.
	(compile_pattern): Don't compare cp->buf.target_multibyte.
	Compare cp->buf.charset_unibyte.
	(compile_pattern): Set cp->buf.target_multibyte.

	* lisp.h (multibyte_char_to_unibyte_safe): Extern it.

	* regex.h (struct re_pattern_buffer): New member charset_unibyte.

	* regex.c (RE_STRING_CHAR, RE_STRING_CHAR_AND_LENGTH): New arg
	multibyte.  Change callers.
	(RE_CHAR_TO_MULTIBYTE, RE_CHAR_TO_UNIBYTE): New macros.
	(MAKE_CHAR_MULTIBYTE, MAKE_CHAR_UNIBYTE): Delete.  Change callers
	to use RE_CHAR_TO_MULTIBYTE and RE_CHAR_TO_UNIBYTE, respectively.
	(SETUP_ASCII_RANGE, SETUP_UNIBYTE_RANGE): New macros.
	(SETUP_MULTIBYTE_RANGE): Generate a more compact range_table.
	(regex_compile): Make the compiled pattern usable both for
	multibyte and unibyte targets.
	(analyse_first): Make the fastmap usable both for multibyte and
	unibyte targets.
	(TRANSLATE_VIA_MULTIBYTE): Delete.
	(re_match_2_internal): Pay attention to the case that the
	multibyteness of bufp and target may be different.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (x_produce_glyphs): When a font is not found, make the
	empty box occupy at least one column width.

2008-02-01  Miles Bader  <miles@gnu.org>

	* Makefile.in: Remove redundant HAVE_XFT clause.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xrdb.c (x_load_resources): Setup the default fontSet X reource.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* fontset.c (Finternal_char_font): Fix for the case of POSITION
	being nil.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xftfont.c (xftfont_open): Call FcConfigSubstitute.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xftfont.c (xftfont_open): Don't enable antialias explicitly.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* search.c (simple_search): Fix previous change.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xftfont.c (ftfont_font_format): Extern declaration.

	* frame.c (x_set_font): Fix the second arg to fs_query_fontset.

	* xfont.c (xfont_driver): Initialize ftfont_driver.type by 0.
	(xfont_list): Don't directly use Lisp_Object as an operand of &&.

	* ftfont.c (ftfont_driver): Initialize ftfont_driver.type by 0.
	(ftfont_font_format): Fix previous change.

	* font.h (Ffont_xlfd_name): EXFUN it.

	* font.c (font_parse_xlfd): Fix the array size of `f'.
	(register_font_driver): Use EQ to compare driver->type.

	* xfns.c (xic_create_xfontset2) [USE_FONT_BACKEND]: New function.
	(create_frame_xic) [USE_FONT_BACKEND]: Call xic_create_xfontset2.
	(xic_set_xfontset) [USE_FONT_BACKEND]: Likewise.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* ftfont.c (ftfont_pattern_entity, ftfont_list_generic_family)
	(ftfont_list, ftfont_font_format): Check if FC_FONTFORMAT is defined.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xfont.c (xfont_open): Set font->format.

	* xftfont.c (xftfont_open): Set font->format.

	* ftfont.c (ftfont_pattern_entity): Add fontformat in a pattern.
	(ftfont_list): Include FC_FONTFORMAT in FcObject.
	(ftfont_open): Set font->format.
	(ftfont_font_format): New function.

	* font.h (struct font): New memeber format.

	* font.c (Qopentype): New variable.
	(syms_of_font): Defsym it.
	(Fquery_font): Change the format of the last element of the return
	value.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xfns.c (xic_create_xfontset): Try the default fontset name as a
	last resort.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (detect_coding_charset): Fix detection of multi-byte
	charset.

2008-02-01  Bob Halley  <halley@play-bow.org>  (tiny change)

	* ccl.c (ccl_driver): If DST is NULL, set ccl->produced to 0.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (get_next_display_element): Set it->face_id for the
	first component of a composition.
	(x_produce_glyphs): Check if the font is changed or not for composition.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* fontset.c (Qlatin): New variable.
	(syms_of_fontset): Define it as a lisp symbol.
	(Fset_fontset_font): If TARGET is `latin', use FONT_SPEC for ASCII.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* font.c (font_unparse_fcname): Pay attention to the case that
	some of font property is a null string.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* term.c: Include "composite.h".
	(encode_terminal_code): Output all components of composition.
	Check the size of encode_terminal_src.
	(produce_glyphs): For composition, call produce_composite_glyph.
	(append_composite_glyph, produce_composite_glyph): New functions.

	* xdisp.c (x_produce_glyphs): In handling composition, if a font
	is not found, get font_info from the current ascii face.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* fileio.c (Finsert_file_contents): On replacing, temporarily bind
	buffer-file-name to Qnil before calling insert_from_buffer.

	* font.c (font_unparse_fcname): Pay attention to the case that
	foundry is a null string.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* ftfont.c (ftfont_list): Allow registry "unicode-sip".

	* font.c (Qunicode_sip): New variable.
	(syms_of_font): Declare it as a Lisp symbol.

	* font.h (Qunicode_sip): Extern it.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* composite.c (get_composition_id): Pay attention to TAB component.

	* xterm.c (x_draw_composite_glyph_string_foreground): Don't draw
	TAB.  Adjust for the change of s->char2b which always points to
	the first elememnt of allocated memory.

	* xftfont.c (xftfont_text_extents): Fix calculation of descent value.

	* xdisp.c (handle_composition_prop): Set it->c to the first
	non-TAB component.
	(fill_composite_glyph_string): Change argument.
	(BUILD_COMPOSITE_GLYPH_STRING): Adjust for the above change.
	(x_produce_glyphs): Fix handling of left/right padding.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (detect_coding_system): Fix for handling off
	inhibit_iso_escape_detection.  Fix for the case that no coding
	system is defined for a specific coding category.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* font.c (font_matching_entity): Delete unused local var.

	* xftfont.c (xftfont_open): Call XftDefaultSubstitute before
	opening a font.

	* fileio.c (Finsert_file_contents): On recovering a file, assume
	Unix-like eol.
	(choose_write_coding_system): On auto-saving a file, force
	Unix-like eol.

	* coding.c (setup_coding_system): Fix setting of
	coding->common_flags based on eol_type.
	(coding_inherit_eol_type): If PARENT is not nil, be sure to
	inherit from it.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* alloc.c (NSTATICS): Increas to 0x600.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* ftfont.c (ftfont_driver): Set ftfont_driver.match to ftfont_match.
	(ftfont_list): Don't check :name property.
	(ftfont_match): New function.
	(ftfont_pattern_entity): If the pattern doesn't contain
	FC_SPACING, don't assuce FC_MONO.

	* font.h (struct font_driver): New member `match'.
	(font_update_drivers): Adjust prototype.

	* font.c (font_parse_fcname, font_parse_name): Don't change :name
	property of FONT.
	(LGSTRING_HEADER_SIZE, LGSTRING_GLYPH_SIZE, check_gstring): Define
	them unconditionally.
	(font_matching_entity): New function.
	(font_open_by_name): Try font_matching_entity if exact match is
	not found.
	(font_update_drivers): Delete the arg FONT.  Return a list of
	actually used backends.  Don't free faces, font caches here.
	Don't store data in frame parameters.  Don't call x_set_font.
	(Ffont_spec): Store :name property as is.
	(Ffont_get): Check HAVE_LIBOTF before calling font_otf_capability.
	(Ffont_otf_gsub): Call font->driver->otf_gsub instead of font_otf_gsub.
	(Ffont_otf_gpos): Call font->driver->otf_gpos instead of font_otf_gpos.
	(Ffont_otf_alternates): Check if the driver has otf_gsub function.
	Call font->driver->otf_gsub instead of font_otf_gsub.

	* frame.c (x_set_font_backend): Do more works that were done in
	font_update_drivers before.

	* xfont.c (xfont_match): New function.
	(xfont_driver): Set xfont_driver.match to xfont_match.
	(xfont_draw): Set font in GC if necessary.

	* ftxfont.c (ftxfont_match): New function.
	(syms_of_ftxfont): Set ftxfont_driver.match to ftxfont_match.

	* xftfont.c (xftfont_match): New function.
	(syms_of_xftfont): Set xftfont_driver.match to xftfont_match.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* font.h (struct font): New member scalable.
	(struct font_driver): New arg ALTERANTE_SUBST to otf_gsub.
	(font_otf_gsub): Adjust prototype.

	* font.c (font_otf_capability): Fix handling of the default langsys.
	(parse_gsub_gpos_spec): Change type to void.  New arg nbytes.
	Check the contents of SPEC.
	(LGSTRING_HEADER_SIZE, LGSTRING_GLYPH_SIZE): New macros.
	(check_gstring): New function.
	(REPLACEMENT_CHARACTER): New macro.
	(font_otf_gsub): New arg alternate_subst.  Be sure to set all
	glyph codes of GSTRING.
	(font_otf_gpos): Be sure to set all glyph codes of GSTRING.
	(font_prepare_composition): Set cmp->glyph_len.
	(font_open_entity): Set font->scalable.
	(Ffont_get): Handle :otf property.
	(Ffont_otf_gsub, Ffont_otf_gpos, Ffont_otf_alternates): New
	functions.
	(Fquery_font): Use font->font.full_name.
	(syms_of_font): Defsubr Sfont_otf_gsub, Sfont_otf_gpos, and
	Sfont_otf_alternates.

	* ftfont.c (ftfont_open): Set font->font.full_name and
	font->font.name properly.  Fix calculation of font->font.height
	and font->min_width.

	* ftxfont.c (ftxfont_create_gcs): New function.
	(ftxfont_draw_bitmap): Fix arg to ftfont_driver.get_bitmap.
	(ftxfont_draw_backgrond): Fix filling region.
	(ftxfont_default_fid): New function.
	(ftxfont_open): Set xfotn->fid to the return value of
	ftxfont_default_fid.
	(ftxfont_prepare_face): Use ftxfont_create_gcs to create GCs.
	(ftxfont_done_face): Free only GCs that are created by
	ftxfont_create_gcs.
	(ftxfont_draw): If face->gc != s->gc, create proper GCs.

	* xterm.c (x_set_glyph_string_clipping_exactly) [USE_FONT_BACKEND]:
	Clip to src->width, etc (not src->clip_XXX).

	* xfns.c (x_create_tip_frame) [USE_FONT_BACKEND]: Handle
	FontBackend frame parameter.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* font.h (struct font_driver_list): New member `on'.
	(Fclear_font_cache): EXFUN it.
	(font_update_drivers): Extern it.

	* font.c (font_unparse_fcname): Fix typo (swidth->width).
	(font_list_entities): Check driver_list->on.
	(register_font_driver): Initalize `on' member to 0.
	(font_update_drivers): New function.
	(Fclear_font_cache): Check driver_list->on.

	* frame.h (Qfont_backend): Extern it.
	(x_set_font_backend): Extern it.

	* frame.c (Qfont_backend): New variable.
	(frame_parms): New element for font-backend.
	(x_set_font_backend): New function.

	* xfns.c (Fx_create_frame) [USE_FONT_BACKEND]: Handle
	FontBackend frame parameter.
	(x_frame_parm_handlers) [USE_FONT_BACKEND]: New element
	x_set_font_backend.

	* xfont.c (xfont_list): Don't try listing by :name property if the
	name is not for XLFD.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* font.h (LGLYPH_FROM, LGLYPH_TO, LGLYPH_SET_FROM)
	(LGLYPH_SET_TO): New macros.
	(LGLYPH_XOFF, LGLYPH_YOFF, LGLYPH_WADJUST): Check if adjustment
	element of G is vector or not.
	(font_at): Extern it.

	* font.c: Include window.h.
	(font_lispy_object): New function.
	(font_prepare_composition): Check LGLYPH_FORM (g) to detect the
	end of valid glyph.
	(font_close_object): Fix getting (struct font *).
	(font_at): New function.
	(Ffont_get): If FONT is a font-object, get entity from it.
	(Ffont_make_gstring): Initialize elements of glyphs with nil.
	(Ffont_fill_gstring): Use macro LGSTRING_XXX and LGLYPH_XXX.  Fix
	range check.
	(Ffont_at): New function.
	(syms_of_font): Defsubr Sfont_at.

	* xdisp.c (it_props): Move the entry for Qauto_composed to just
	before the entry for Qcomposition.
	(handle_auto_composed_prop): Call auto-composition-function with 4 args.
	(handle_composition_prop) [USE_FONT_BACKEND]: Set it->face_id from
	the font in gstring.
	(fill_composite_glyph_string) [USE_FONT_BACKEND]: Check
	LGLYPH_FORM (g) to detect the end of valid glyph.
	(x_produce_glyphs) [USE_FONT_BACKEND]: Don't update it->face_id if
	we are composing with gstring.

	* xterm.c (x_draw_composite_glyph_string_foreground) [USE_FONT_BACKEND]:
	Check if adjustment is vector or not.

	* Makefile.in (font.o): Make it depends on window.h.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xterm.c (x_draw_composite_glyph_string_foreground): Check if
	adjustment is vector or not.

2008-02-01  Miles Bader  <miles@gnu.org>

	* character.h (CHECK_CHARACTER): Redefine in terms of CHECK_TYPE.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* font.h (LGLYPH_XOFF, LGLYPH_YOFF, LGLYPH_WIDTH, LGLYPH_WADJUST)
	(LGLYPH_SET_WIDTH): Adjusted for the change of LGLYPH format.
	(LGLYPH_ADJUSTMENT, LGLYPH_SET_ADJUSTMENT): New macros.

	* font.c (font_merge_old_spec): Treat '*' in foundry as a wild card.
	(DEVICE_DELTA): Fix typo.
	(font_otf_gpos, font_prepare_compositio): Adjust for the change of
	LGLYPH format.

	* xterm.c (x_draw_composite_glyph_string_foreground): Adjust for
	the change of LGLYPH format.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* ftfont.c (ftfont_list): Fix typo.
	(ftfont_build_basic_charsets): Don't include letters with diacritics.

2008-02-01  Jan Djärv  <jan.h.d@swipnet.se>

	* xfaces.c (realize_non_ascii_face): Set face->extra to NULL.

	* xftfont.c (xftfont_done_face): Call XftDrawDestroy only if
	xftface_info is non-NULL.

2008-02-01  Jan Djärv  <jan.h.d@swipnet.se>

	* ftfont.c (ftfont_list): Move misplaced #endif.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* ftfont.c (ftfont_list): Pay attention to the case that
	FC_CAPABILITY is not defined.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xftfont.c (xftfont_open): Set charset related members to -1.

	* ftfont.c (ftfont_list): Handle QCotf property.  Fix handling of
	QCname.
	(ftfont_open): Set charset related members to -1.

	* fontset.c (Votf_script_alist): New variable.
	(syms_of_fontset): Initialize it.
	(fontset_font): Delete unused variable.

	* fontset.h (Votf_script_alist): Extern it.

	* font.c (font_find_for_lface): Optimize code.

	* font.h (font_close_object, font_merge_old_spec): Extern them.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* font.c (QCscalable, Qc, Qm, Qp, Qd): New variables.
	(syms_of_font): Initialize them.
	(font_pixel_size): Allow float value in dpi.
	(font_prop_validate_type): Delete.
	(font_prop_validate_symbol, font_prop_validate_style): Change argument.
	Change caller.
	(font_prop_validate_non_neg): Rename from font_prop_validate_size.
	(font_prop_validate_extra): Delete.
	(font_prop_validate_spacing): New function.
	(font_property_table): Add elements for all known properties.
	(get_font_prop_index): Rename from check_font_prop_name.  New
	argument FROM.  Change caller.
	(font_prop_validate): Validate all known properties.
	(font_put_extra): Delete argument force.  Change caller.
	(font_expand_wildcards): Make it static.  Fix the way of shrinking
	the possible range.
	(font_parse_xlfd): Delete argument merge.  Fix handling of RESX,
	RESY, SPACING, and AVGWIDTH.  Don't validate property values here.
	Change caller.
	(font_unparse_xlfd): Handle dpi, spacing, and scalable properties.
	(font_parse_fcname): Delete argument merge.  Fix parsing of point
	size.  Don't validate properties values here.  Change caller.
	(font_unparse_fcname): Handle dpi, spacing, and scalable properties.
	(font_open_by_name): Delete unused variable.
	(Ffont_spec): Likewise.  Validate property values.
	(Ffont_match_p): New function.

	* font.h (QCscalable): Extern it.
	(font_parse_xlfd, font_parse_fcname): Adjust prototype.

	* ftfont.c (ftfont_list): Handle properties dpi, spacing, and scalable.

	* xfont.c (xfont_query_font): Adjust for the change of font_parse_xlfd.
	(xfont_list_pattern): New function.
	(xfont_list): Use xfont_list_pattern.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* font.h (Flist_fonts): EXFUN it.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (w32_initialize): Add back smoothing_type and
	smoothing_enabled definitions.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xterm.c (x_draw_glyph_string) [USE_FONT_BACKEND]: Check
	s->face->font on determining underline position.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* font.c (font_parse_xlfd): Fix generating of CHARSET_REGISTRY field.
	(font_has_char): Accept font-object too.
	(font_find_for_lface): Try at first with a size specified in face.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* frame.c (x_set_font) [USE_FONT_BACKEND]: Fix argument to
	font_open_by_name.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* font.h (QCspacing, QCdpi): Extern them.
	(enum font_spacing): New enum.
	(FONT_PIXEL_SIZE_QUANTUM): New macro.

	* font.c (POINT_TO_PIXEL): Don't divice POINT by 10.
	(QCspacing, QCdpi): New variables.
	(syms_of_font): Initialize them.
	(font_pixel_size): New function.
	(font_put_extra): New function.
	(font_parse_xlfd): Fix handling of font size.  Add QCdpi property
	in FONT_EXTRA.
	(font_parse_fcname): Handle enumenrated values (e.g. bold).
	Fix handling font size.  Add QCname property that contains only
	unknown properties.
	(font_score): Change argument.  Change caller.  Pay attention to
	FONT_PIXEL_SIZE_QUANTUM.
	(font_sort_entites, font_list_entities, font_find_for_lface)
	(font_open_for_lface, font_open_by_name): Fix handling of font size.
	(Ffont_spec): Add QCname property that contains only unknown properties.

	* ftfont.c (ftfont_list): Use assq_no_quit, not Fassq.  Don't
	include weight in listing pattern, instead check weight of each
	listed font.  Don't include scalable in pattern.  Pay attention to
	FONT_PIXEL_SIZE_QUANTUM.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* font.c (font_parse_fcname): Fix parsing of point-size.
	(font_unparse_fcname): Produce symbolic names for style properties.
	(font_list_entities): Handle float size correctly.
	(font_open_by_name): Prefer `normal' property values if the name
	doesn't specify them.

	* fontset.c (Finternal_char_font): Use font_get_name, not
	Ffont_xlfd_name.

	* ftfont.c (ftfont_pattern_entity): Use the numeric value 100 for
	FC_WEIGHT_REGULAR.  Exclude FC_SIZE and FC_PIXEL_SIZE from listing
	pattern.  Don't force scalable.

	* xftfont.c (xftfont_open): For generating a name, start from
	96-byte buffer.

2008-02-01  Jan Djärv  <jan.h.d@swipnet.se>

	* frame.h (x_new_fontset2): Fix prototype.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* font.h (struct font_driver): Delete member parse_name.
	(font_match_p, font_get_spec, font_parse_fcname)
	(font_unparse_fcname): Extern them.
	(font_get_name): Adjust prototype.

	* font.c (XLFD_SMALLNUM_MASK): Delete this macro.
	(XLFD_LARGENUM_MASK): Delete XLFD_ENCODING_MASK from it.
	(font_expand_wildcards): Fix handling ENCODING field.  Avoid
	unnecessary checks for weight, slant, and swidth.
	(font_parse_fcname): New function.
	(font_unparse_fcname): New function.
	(font_parse_name): New function.
	(font_match_p): New function.
	(font_get_name): Change return value to Lisp string.
	(font_get_spec): New function.
	(Qunspecified, Qignore_defface): Don't extern them.
	(font_find_for_lface): Assume that LFACE is fully specified.
	(font_load_for_face): If lface[LFACE_FONT_INDEX] is an font
	object, use it for FACE.
	(font_open_by_name): Call Ffont_spec with QCname prop.  Don't call
	driver->parse_name.
	(Ffont_spec): Call font_parse_name, not font_parse_xlfd.

	* fontset.h (new_fontset_from_font) [USE_FONT_BACKEND]: Adjust
	prototype.

	* fontset.c (new_fontset_from_font) [USE_FONT_BACKEND]: Delete
	argument F.  Don't call Fnew_fontset.  Instead, directly call
	make_fontset.

	* frame.h (x_new_fontset2) [USE_FONT_BACKEND]: Adjust prototype.

	* frame.c (x_set_font) [USE_FONT_BACKEND]: Adjust for the change
	of x_new_fontset2.

	* ftfont.c (Qmonospace, Qsans_serif, Qserif, Qmono, Qsans)
	(Qsans__serif): New variables.
	(ftfont_generic_family_list): New variable.
	(syms_of_ftfont): Initialize the above variables.
	(ftfont_pattern_entity): Delete argument NAME.
	(ftfont_list_generic_family): New function.
	(ftfont_parse_name): Delete this function.
	(ftfont_list): Try generic family only when FcFontList found no font.
	(ftfont_list_family): Fix args to FcObjectSetBuild.

	* xfaces.c (check_lface_attrs) [USE_FONT_BACKEND]: Accept font
	object in attrs[LFACE_FONT_INDEX].
	(set_lface_from_font_name): Cancel all changes for font-backend.
	(set_lface_from_font_and_fontset) [USE_FONT_BACKEND]: New
	function.
	(Finternal_set_lisp_face_attribute) [USE_FONT_BACKEND]: Accept a
	font object in QCfont attribute.
	(set_font_frame_param) [USE_FONT_BACKEND]: Likewise.
	(realize_default_face) [USE_FONT_BACKEND]: Call
	set_lface_from_font_and_fontset.

	* xfns.c (x_default_font_parameter) [USE_FONT_BACKEND]: Try also
	"fixed", and signal error here if no suitable font was found.

	* xfont.c (xfont_parse_name): Delete this function.

	* xftfont.c (xftfont_open): Change coding style of error
	handling.  Generate fontconfig's fontname pattern.

	* xterm.h (struct x_output) [USE_FONT_BACKEND]: New member fontp.
	(FRAME_FONT_OBJECT) [USE_FONT_BACKEND]: New macro.

	* xterm.c (x_new_fontset2) [USE_FONT_BACKEND]: Change arguments.
	Both args FONTSET and FONT_OBJECT must be existing ones.

2008-02-01  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (mac_set_unicode_keystroke_event): Don't use MAKE_CHAR.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xfont.c (xfont_open, xfont_encode_char): Fix typo.

	* font.h (struct font): Fix typo.

	* font.c (enum xlfd_field_index): Rename XLFD_XXX_SIZE_INDEX to
	XLFD_XXX_INDEX.
	(enum xlfd_field_mask): New enum.
	(intern_font_field): Changed argument.  Change caller.  If digits
	are followed by non-digits, return a symbol.
	(font_expand_wildcards): New function.
	(font_parse_xlfd): Fix wildcard handling.
	(Ffont_spec): If :name is specified, reflect the info in the other
	properties.

	* ftfont.c (ftfont_pattern_entity): Fix typo.
	(ftfont_list): Enforce FC_LANG in PATTERN to cancel the effect of
	locale.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* font.h (Qiso8859_1, Qiso10646_1, Qunicode_bmp): Extern them.

	* font.c (Qiso8859_1, Qiso10646_1, Qunicode_bmp): Move from ftfont.c.
	(font_unparse_xlfd): Fix argument type declaration.  Append "*" if
	registry doesn't specify encoding part.
	(font_find_for_lface): Pay attention to LFACE_FONT_INDEX.
	(font_open_by_name): At first try parsing the name.
	(syms_of_font): Declare Qiso8859_1, Qiso10646_1, and Qunicode_bmp
	as Lisp symbols.

	* fontset.c (reorder_font_vector): Pay attention to the case that
	the 3rd element of font_def is nil.
	(fontset_font): For the default fontset, append one more fontset
	elements for a script-based font specification.  Don't add script
	attribute on finding a font.
	(new_fontset_from_font): Unconditionally set FONTSET_ASCII to the
	font name.
	(fontset_ascii_font): If a font can't be opened, return nil.

	* ftfont.c (Qiso8859_1, Qiso10646_1, Qunicode_bmp): Move to font.c.
	(ftfont_pattern_entity): New function.
	(ftfont_get_cache): Assume that freetype_font_cache is already
	initialized.
	(ftfont_list): Handle the case that a file is specified in font
	name.  Use ftfont_pattern_entity to generate entities.
	(ftfont_has_char): Check if the pattern contains FC_CHARSET.
	(syms_of_ftfont): Initialize freetype_font_cache.

	* xftfont.c (xftfont_open): Make the font name fontconfig's
	style.  Add BLOCK_INPUT and UNBLOCK_INPUT.
	(xftfont_close): Free font->font.name if not NULL.

	* xfont.c (xfont_list): If script is specified for a font, return
	null_vector.
	(xfont_list_family): Declare argument type.

	* xfaces.c (set_lface_from_font_name): If a font doesn't have a
	name, set LFACE_FONT (lface) to nil.

	* xterm.c (x_new_fontset2): If an ASCII font couldn't be loaded,
	return Qnil.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* emacs.c (main): Check -enable-font-backend arg after the check of -nl.
	(standard_args): Add "-enable-font-backend".

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xftfont.c (xftfont_default_fid): Set fid_known to 1.
	(struct xftdraw_list, xftdraw_list): Delete them.
	(register_xftdraw, check_xftdraw): Delete them.
	(xftfont_prepare_face): Don't call register_xftdraw.
	(xftfont_done_face): Don't call check_xftdraw.
	(xftfont_draw): Get backroudn color only when with_background is
	nonzero.

	* xfont.c (xfont_encode_char): Fix calculation of char2b.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	These changes are for the new font handling codes.

	* Makefile.in (ALL_CFLAGS): Add @FREETYPE_CFLAGS@,
	@FONTCONFIG_CFLAGS@, and @LIBOTF_CFLAGS@.
	(LIB_X11_LIB): If HAVE_XFT is defined, set to @XFT_LIBS@.
	(FONTSRC, FONTOBJ): New variables.
	(obj): Add $(FONTOBJ).
	(SOME_MACHINE_OBJECTS): Lib_X11_Lib.
	(LIBES): Add @FREETYPE_LIBS@, @FONTCONFIG_LIBS@, and
	@LIBOTF_LIBS@.
	(font.o, ftfont.o, xfont.o, xftfont.o, ftxfont.o): New targets.
	(fontset.o, xdisp.o, xfaces.o, xfns.o, xterm.o): Depend on $(FONTSRC).

	* font.h, font.c, xfont.c, ftfont.c, xftfont.c, ftxfont.c: New files.

	* character.h (Vscript_representative_chars): Extern it.

	* character.c (Vscript_representative_chars): New variable.
	(syms_of_character): Declare it as a Lisp variable.

	* composite.c (get_composition_id) [USE_FONT_BACKEND]: If
	enable_font_backend is nonzero, accept the composition method
	COMPOSITION_WITH_GLYPH_STRING.

	* composite.h (enum composition_method) [USE_FONT_BACKEND]: New
	enumeration COMPOSITION_WITH_GLYPH_STRING.

	* dispextern.h (struct glyph_string) [USE_FONT_BACKEND]: New
	members clip_x, clip_y, clip_width, and clip_height.
	(struct face) [USE_FONT_BACKEND]: New members font_info and extra.

	* emacs.c (main) [USE_FONT_BACKEND]: Handle arg
	--enable-font-backend.  Call syms_of_font.

	* fns.c (assoc_no_quit): New function.

	* fontset.h (FONT_INFO_FROM_FACE): New macro.
	(face_for_font, new_fontset_from_font)
	(fontset_ascii_font) [USE_FONT_BACKEND]: Extern them.

	* fontset.c [USE_FONT_BACKEND]: Include "font.h".
	(fontset_font, fontset_ascii, face_for_char)
	(make_fontset_for_ascii_face, Ffont_info)
	(Finternal_char_font) [USE_FONT_BACKEND]: If enable_font_backend
	is nonzero, use font-backend mechanism.
	(find_font_encoding): Make it non-static.
	(new_fontset_from_font, fontset_ascii_font) [USE_FONT_BACKEND]:
	New functions.

	* frame.h (struct frame): New members resx and resy.
	(struct frame) [USE_FONT_BACKEND]: New member font_driver_list.
	(x_new_fontset2) [USE_FONT_BACKEND]: Extern it.

	* frame.c [USE_FONT_BACKEND]: Include "font.h".
	(make_frame, x_set_font) [USE_FONT_BACKEND]: Use font-backend mechanism.

	* lisp.h (assoc_no_quit): Extern it.

	* xdisp.c: If USE_FONT_BACKEND is defined, include "font.h".
	Through out the file, use FONT_INFO_FROM_FACE instead of
	FONT_INFO_FROM_ID, use get_per_char_metric instead of
	rif->per_char_metric.
	(handle_composition_prop) [USE_FONT_BACKEND]: If the composition
	method is COMPOSITION_WITH_GLYPH_STRING, just set it->c to ' '.
	(get_glyph_face_and_encoding, fill_composite_glyph_string)
	(get_char_face_and_encoding, BUILD_COMPOSITE_GLYPH_STRING)
	(x_produce_glyphs) [USE_FONT_BACKEND]: If enable_font_backend is
	nonzero, use font-backend mechanism.
	(get_per_char_metric): New function.

	* xfaces.c [USE_FONT_BACKEND]: Include "font.h".
	(set_lface_from_font_name)
	(set_font_frame_param, free_realized_face)
	(prepare_face_for_display, clear_face_gcs)
	(Finternal_set_font_selection_order, realize_x_face)
	[USE_FONT_BACKEND]: If enable_font_backend is nonzero, use
	font-backend mechanism.
	(clear_face_cache) [USE_FONT_BACKEND]: Don't call clear_font_table.
	(load_face_font) [USE_FONT_BACKEND]: Abort.
	(face_symbolic_value, face_symbolic_weight, face_symbolic_slant)
	(face_symbolic_swidth, face_for_font) [USE_FONT_BACKEND]: New functions.

	* xfns.c [USE_FONT_BACKEND]: Include "font.h".
	(x_default_font_parameter) [USE_FONT_BACKEND]: New function.
	(Fx_create_frame) [USE_FONT_BACKEND]: If enable_font_backend is
	nonzero, register all available font drivers.  Call
	x_default_font_parameter for deciding a font.
	(x_create_tip_frame) [USE_FONT_BACKEND]: Likewise.

	* xterm.c [USE_FONT_BACKEND]: Include "font.h".
	(x_set_mouse_face_gc, x_set_glyph_string_clipping)
	(x_set_glyph_string_clipping_exactly)
	(x_compute_glyph_string_overhangs)
	(x_draw_glyph_string_foreground)
	(x_draw_composite_glyph_string_foreground, x_draw_glyph_string)
	(x_free_frame_resources) [USE_FONT_BACKEND]: If
	enable_font_backend is nonzero, use font-backend mechanism.
	(x_new_fontset2) [USE_FONT_BACKEND]: New function.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (coding_inherit_eol_type): If PARENT is nil, inherit from
	system_eol_type.
	(syms_of_coding): Initialize system_eol_type.

	* process.c (Fset_process_coding_system): Inherit system's eol
	format if necessary.

2008-02-01  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macgui.h (USE_ATSUI): Don't enable on emacs-unicode-2 branch.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (decode_eol): Pay attention to buffer relocation in
	del_range_2.
	(decode_coding): Call decode_eol before restoring undo_list.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* charset.c (Fdefine_charset_internal): Fix setting of
	emacs_mule_bytes.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* keyboard.c (read_char): Check if C is a character or not before
	looking up Vkeyboard_translate_table.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (DECODE_EMACS_MULE_20_RELATIVE_COMPOSITION): Fix
	condition to terminate the loop.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (produce_composition): Compare charbuf[i] instead of
	args[i] against 0.
	(Fterminal_coding_system): Use EQ to compare Lisp objects.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (DECODE_COMPOSITION_START): If the source is short, set
	coding->result to CODING_RESULT_INSUFFICIENT_SRC.
	(decode_coding_gap): Set CODING_MODE_LAST_BLOCK after the call of
	detect_coding.
	(emacs_mule_char): Handle old style (Emacs 20) component character
	of a composition.
	(DECODE_EMACS_MULE_COMPOSITION_RULE_20)
	(DECODE_EMACS_MULE_20_RULEBASE_COMPOSITION): Fix parsing a
	composition rule.
	(decode_coding_emacs_mule): Handle invalid bytes correctly.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (encode_coding_ccl): Allocate destination dynamically
	when necessary.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* ccl.c (Fccl_execute_on_string): Fix the condition of terminating
	the loop.  When quitted, show a proper error message.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xterm.c (x_set_glyph_string_clipping_exactly): Set
	src->clip_head and src->clip_tail temporarily instead of src->hl.

	* ccl.c (CCL_WRITE_STRING): Handle a flag bit for multibyte
	character sequence.
	(Fccl_execute_on_string): Use ASET, not XSET.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* search.c (search_buffer): Fix handling of "\\" in a trivial regexp.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (decode_coding): Fix the condition of terminating the
	decoding loop.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* data.c (Faset): On setting a character bigger than 255 in a
	unibyte string, signal an error instead of make the string multibyte.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* charset.c (map_charset_chars): Fix for ascii-compatible charset
	made by a mapping table.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (fill_composite_glyph_string): Check s->face is NULL or
	not.
	(BUILD_COMPOSITE_GLYPH_STRING): If C is TAB, set s->face to NULL.
	(x_produce_glyphs): If CH is TAB, set cmp->offsets properly.

	* xterm.c (x_draw_composite_glyph_string_foreground): Check
	s->face is NULL or not.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xterm.c (x_set_glyph_string_clipping_exactly): New function.
	(x_draw_glyph_string): Fix drawing of right_overhang and
	left_overhang around/on cursor.

	* xdisp.c (draw_glyphs): Fix inclusion of right_overwriting glyphs.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (x_produce_glyphs): Handle composition with TAB.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (Fdefine_coding_system_internal)
	(Fdefine_coding_system_alias): Avoid a duplicated element in
	Vcoding_system_alist.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xterm.c (handle_one_xevent): Handle keysyms 0x1000000..0x10000FF.

	* coding.c (Qcoding_system_define_form): New variable.
	(syms_of_coding): Intern and staticpro it.
	(Fcoding_system_p): Check Qcoding_system_define_form.
	(Fcheck_coding_system): Try to autoload the definition of CODING-SYSTEM.

	* coding.h (CODING_SYSTEM_P): If ID is not available, call
	Fcoding_system_p.
	(CHECK_CODING_SYSTEM): If ID is not available, call
	Fcheck_coding_system.
	(CHECK_CODING_SYSTEM_GET_SPEC, CHECK_CODING_SYSTEM_GET_ID):
	Try also Fcheck_coding_system.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (code_conversion_restore): GCPRO arg.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* character.c (lisp_string_width): Check multibyteness of STRING.

2008-02-01  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (mac_encode_char): Call ccl_driver with the last arg
	Qnil.  Use JIS_TO_SJIS instead of ENCODE_SJIS.
	(decode_mac_font_name): Use decode_coding_c_string instead of
	decode_coding.
	(x_load_font): Initialize fontp->fontset to -1.  Set
	fontp->encoding_type.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* search.c (search_buffer): Give up BM search on case-fold-search
	if one of a target character has a case-equivalence of different
	byte length even if that target charcter is an ASCII.
	(simple_search): Fix calculation of byte length of matched text.
	(boyer_moore): Fix handling of case-equivalent multibyte characters.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (decode_coding): Fix handling of invalid bytes.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xterm.c (handle_one_xevent): Handle keysyms directly mapped to
	Unicode characters.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (encode_coding_object): If a pre-write-conversion
	function makes a new buffer, kill it.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (QCascii_compatible_p): New variable.
	(syms_of_coding): Initialize it.
	(ONE_MORE_BYTE, ONE_MORE_BYTE_NO_CHECK): Decrement `src' before
	calling string_char.
	(record_conversion_result): Add `default:' case.
	(coding_charset_list): Delete unused variable `coding_type'.
	(Fdefine_coding_system_internal): Add `ascii-compatible-p'
	property in the plist of the coding system.
	(Fcoding_system_put): Check QCascii_compatible_p.

2008-02-01  Miles Bader  <miles@gnu.org>

	* xfaces.c (Finternal_lisp_face_equal_p): Restore previously
	removed calculation of frame `f', as it's now used.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* Makefile.in (RUN_TEMACS): Include "-nl" if HAVE_SHM is defined.
	(emacs${EXEEXT}): Run $(RUN_TEMACS) unconditionally.
	(UNIDATA): New variable.
	(${lispsource}international/charprop.el): Depends on ${UNIDATA}.
	(bootstrap-emacs${EXEEXT}): Depends on charprop.el.  Run
	$(RUN_TEMACS) unconditionally.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* Makefile.in (temacs${EXEEXT}): Build charprop.el if necessary.
	(admindir): New variable.
	($(lispsource)international/charprop.el): New target.

2008-02-01  Miles Bader  <miles@gnu.org>

	* character.c (chars-in-region): Remove obsolete function.
	(syms_of_character): Remove its initialization.

2008-02-01  Benjamin Riefenstahl  <b.riefenstahl@turtle-trading.net>

	* w32select.c (validate_coding_system)
	(setup_windows_coding_system): New functions.
	(convert_to_handle_as_coded, Fw32_get_clipboard_data): Use
	setup_windows_coding_system.
	(setup_config, Fw32_get_clipboard_data): Use
	validate_coding_system.
	(Fx_selection_exists): Move call to setup_config to a place
	where signals are allowed.

	* lisp.h (Fcoding_system_base, Fcoding_system_eol_type)
	(Fcheck_coding_system): Add declarations.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* charset.c (load_charset_map_from_vector): Fix for the first iteration.

2008-02-01  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (Fx_create_frame, x_create_tip_frame): Pass Lisp
	string as the second argument for x_new_fontset.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (decode_coding_object): Use safe_call1 instead of call1.
	(encode_coding_object): Use safe_call instead of call2.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* fontset.c (Fset_fontset_font): Check family element of a given vector.

	* Makefile.in (lisp): Include charprop.el.

2008-02-01  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (Fx_create_frame, x_create_tip_frame): Fix crash.
	Not sure if it's unnecessary.

2008-02-01  Steven Tamm  <steventamm@mac.com>

	* macfns.c (Fx_create_frame, x_create_tip_frame): ifdef'd out
	some possibly unnecessary fontset checking code that crashed
	when creating a new frame.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xfaces.c (merge_faces): Fix argument to lookup_derived_face and
	lookup_face.

	* xdisp.c (Fformat_mode_line): Fix argument to lookup_named_face.

	* fringe.c (draw_fringe_bitmap_1): Fix argument to lookup_named_face.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c: Cancel the change done in HEAD on 2008-02-01.
	(coding_charset_list): New function.

	* coding.h (coding_charset_list): Extern it.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* fontset.c (Fset_fontset_font): Call find_font_encoding with
	concatenation of family and registry.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* character.h (BYTE8_STRING): Fix typo.

	* editfns.c (Ftranslate_region_internal): Don't convert unibyte
	string to multibyte (sync to HEAD).

	* casefiddle.c (casify_region): Handle changes in byte-length
	using replace_range_2 (sync to HEAD).

2008-02-01  Andreas Schwab  <schwab@suse.de>

	* chartab.c (map_char_table): GCPRO table and arg.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* syntax.c (skip_syntaxes): Return lispy 0 (not nil) if point is
	already at limit.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* fontset.c (fs_load_font): Use fast_string_match_ignore_case
	instead of fast_c_string_match_ignore_case.
	(find_font_encoding): Change argument to Lisp_Object.  Use
	fast_string_match_ignore_case instead of
	fast_c_string_match_ignore_case.  Change caller.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (get_next_display_element): In unibyte case, decide to
	display in octal form by checking a chacter by
	UNIBYTE_CHAR_HAS_MULTIBYTE_P.

	* charset.c (Fset_unibyte_charset): Setup unibyte_has_multibyte_table.

	* character.c (unibyte_has_multibyte_table): New variable.

	* character.h (unibyte_has_multibyte_table): Extern it.
	(UNIBYTE_CHAR_HAS_MULTIBYTE_P): New macro.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (encode_coding_iso_2022): Fix handling of charset
	annotation.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (setup_coding_system): If coding_system is nil, use
	Qundecided.
	(Fterminal_coding_system): Return nil if terminal coding system is
	`undecided'.
	(syms_of_coding): Define coding-system `undecided' here.  Setup
	terminal_coding as `undecided'.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (message_dolog, set_message_1): Call
	unibyte_char_to_multibyte with arg type int.

	* lread.c (read1): Fix reading of a char-table.

	* print.c (print_object): Include sub char-table in cicularities
	detection.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* keymap.c (where_is_internal_2): Fix for the case that KEY is a
	cons.  Append the found sequences in car of ARGS instead of prepending.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* fileio.c (report_file_error): Make a unibyte string from
	strerror (errorno).
	(Fsubstitute_in_file_name): Fix the arg to
	unibyte_char_to_multibyte.  It is evaluated twice.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* charset.h (CHAR_CHARSET): Shortcut for ASCII case.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (detect_coding_utf_16): Don't set detect_info->found if
	BOM is not found.
	(detect_coding, detect_coding_system): Optimization for ISO-2022
	when no 8-bit data is found.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (x_to_w32_font): Update to use new coding struct.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* charset.c (Fdeclare_equiv_charset, Fiso_charset): Fix handing of
	CHARS.

2008-02-01  Steven Tamm  <steventamm@mac.com>

	* macterm.c (mac_encode_char): Add charset argument and update
	to use encoding_type.
	(x_new_font, x_new_fontset): Merge in changes from xterm.c;
	switch to pure fontset.
	(decode_mac_font_name): Temporarily remove decoding.
	(x_font_name_to_mac_font_name): Temporarily remove encoding.
	(x_load_font): Temporarily remove encoding.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xfaces.c (Fface_font): If frame is not on a window system,
	ignore CHARACTER arg.  If HAVE_WINDOW_SYSTEM is not defined, don't
	refer to face->font.
	(split_font_name_into_vector, build_font_name_from_vector)
	(lookup_non_ascii_face, realize_non_ascii_face): Define them only
	whne HAVE_WINDOW_SYSTEM is defined.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (BUILD_GLYPH_STRINGS): Check if s is NULL.
	(x_produce_glyphs): Fix setting of members of cmp in case
	cmp->glyph_len is zero.

	* fontset.c (Fset_fontset_font): Fix docstring.
	(Ffontset_info): Make it backward compatible.  New arg ALL.

2008-02-01  Kim F. Storm  <storm@cua.dk>

	* process.c (read_process_output): Grow decoding_buf when needed;
	this could cause a crash in allocate_string and compact_small_strings.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* fileio.c (WRITE_BUF_SIZE): Delete this macro.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (setup_coding_system): Set coding->common_flags
	correctly for raw-text.
	(consume_chars): On encoding unibyte text by raw-text, don't check
	multibyte form.
	(encode_coding): On encoding by raw-text, never use translation tables.

	* fileio.c (e_write): Short cut for the case of no encoding.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (detect_coding, detect_coding_system): Delete unused
	variables.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (encode_coding_utf_8): Fix handling of raw-byte char.
	(consume_chars): Fix handling of 8-bit bytes in unibyte source.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (Ffind_coding_systems_region_internal): Include
	raw-text and no-conversion in the result.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* fontset.c (find_font_encoding): Return `ascii' for unknown encoding.
	(load_font_get_repertory): Delete unnecessary check of ENCODING of
	FONT_DEF.
	(font_def_arg, add_arg, from_arg, to_arg): New args.
	(set_fontset_font): Change argument.
	(Fset_fontset_font): Fix for the case that TARGET is a script
	name and charset name.
	(new_fontset_from_font_name): Fix argument to Fnew_fontset.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* fontset.c (fontset_font): Rename from fontset_face.  Change return
	value.
	(face_suitable_for_char_p, face_for_char): Adjust for the change
	of fontset_font.
	(make_fontset_for_ascii_face): Fix setting of the fontset element
	for ASCII.
	(Finternal_char_font): Use fontset_font instead of FACE_FOR_CHAR
	to get a font name.
	(Ffontset_info): Adjust for the change of fontset_font.

	* coding.c (emacs_mule_char): Check invalid code more regidly.

	* character.h (LEADING_CODE_LATIN_1_MIN)
	(LEADING_CODE_LATIN_1_MAX): Delete these macros.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* editfns.c (check_translation): New function.
	(Ftranslate_region_internal): Handle M:N mapping.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xfaces.c (xlfd_point_size): Set font->numeric[XLFD_PIXEL_SIZE].

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (DECODE_DESIGNATION): Set chars_96 to -1 instead of
	goto invalid_code.
	(decode_coding_iso_2022): Fix handling of invalid designation.

	* fileio.c (Finsert_file_contents): Be sure to call unbind_to
	after calling code_conversion_save.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (handle_auto_composed_prop): Fix Lisp_Object/int mixup.

	* print.c (print_prune_string_charset): Fix Lisp_Object/int mixup.

	* fontset.c: Include "intervals.h".
	(fontset_face): Fix comparing of Lisp_Objects.
	(free_face_fontset, new_fontset_from_font_name): Fix
	Lisp_Object/int mixup.

	* editfns.c (Ftranslate_region_internal): Fix Lisp_Object/int mixup.

	* coding.c: Add many prototypes for static functions.
	(get_translation_table): Allow max_lookup to be NULL.
	(decode_coding, Ffind_coding_systems_region_internal)
	(Funencodable_char_position, Fcheck_coding_systems_region): Call
	get_translation_table with max_lookup NULL.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (get_translation_table): Declare it as Lisp_Object.
	(LOOKUP_TRANSLATION_TABLE): New macro.
	(produce_chars, consume_chars): Use LOOKUP_TRANSLATION_TABLE
	instead of CHAR_TABLE_REF.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (MAX_ANNOTATION_LENGTH): Adjust for the change of
	annotation data format.
	(ADD_ANNOTATION_DATA, ADD_COMPOSITION_DATA, ADD_CHARSET_DATA):
	Change arguments FROM and TO to single argument NCHARS.  Change caller.
	(decode_coding_utf_8, decode_coding_utf_16, decode_coding_emacs_mule)
	(decode_coding_iso_2022, decode_coding_sjis, decode_coding_big5)
	(decode_coding_ccl, decode_coding_charset): Pay attention to
	coding->charbuf_used.
	(get_translation): New function.
	(produce_chars): New arguments translation_table and last_block.
	Translate characters here.  Return number of carryover chars.
	Change caller.
	(produce_composition): New argument pos.  Change caller.
	Adjust for the change of annotation data format.
	(produce_charset, produce_annotation): Likewise.
	(decode_coding, encode_coding): Don't call translate_chars.
	(consume_chars): New arg translation_table.  Change caller.
	(translate_chars): Delete.
	(syms_of_coding): Make translation-table's number of extra slots 2.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* search.c (simple_search): Fix setting this_pos_byte in backward
	search.

	* coding.c (detect_coding_emacs_mule): Fix counting of encoded
	byte sequence.
	(detect_coding_ccl): Fix setting of the variable valids.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xterm.c (x_list_fonts): Fix the detection of an auto-scaled font.

	* coding.c (decode_coding_utf_16): Fix handling of surrogate pair.

	* editfns.c (Ftranslate_region_internal): Rename from
	Ftranslate_region.  Accept a char-table in TABLE.
	(syms_of_editfns): Defsubr Stranslate_region_internal.

	* xfaces.c (set_lface_from_font_name): If a font is specified for
	a frame, generate a fontset from the font.
	(build_scalable_font_name): If the scalable font is requested for
	a specific size, don't change that size.
	(try_font_list): Try a scalable font also in the case that a
	pattern string is specified.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xfaces.c (Fface_font): New optional arg CHARACTER.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* charset.h (CHARSET_OFFSET): New macro.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xterm.c (x_get_font_repertory): Fix for non-Unicode-bmp charset.

	* fontset.c (fontset_face): Handle the case that repertory is a
	char-table.
	(find_font_encoding): Return nil for unknown encoding.
	(Fset_fontset_font): Ignore a font of unknown encoding.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* keymap.c (describe_vector): Handle default value of a char table.

	* fontset.c (fontset_face): Handle fallback fonts correctly.
	(Ffontset_info): Return infomation about fallback fonts.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* fontset.c (FONTSET_DEFAULT): New macro.
	(FONTSET_ADD, fontset_add): Handle the case that range is nil.
	(Fset_fontset_font): Change the 2nd arg name to TARGET, and handle
	the case that it is nil.
	(dump_fontset): Call FONTSET_DEFAULT, not FONTSET_FALLBACK.
	(syms_of_fontset): Set char-table-extra-slots property of fontset to 9.

	* charset.h (CHAR_CHARSET_P): Fix for the case that the method is
	subset or superset.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* emacs.c (main): Call init_charset after syms_of_XXX.

	* charset.c (Vcharset_map_directory): Delete.
	(Vcharset_map_path): New variable.
	(load_charset_map_from_file): Use Vcharset_map_path instead.
	(init_charset): Initialize Vcharset_map_path.
	(syms_of_charset): Delete declaration of "charset-map-directory",
	add declaration of "charset-map-path".

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* fns.c (string_char_to_byte, string_byte_to_char): Optimize for
	ASCII only string.

	* fileio.c (Finsert_file_contents): Avoid detecting a code twice.

	* coding.c (detect_coding_iso_2022): Fix handling of SS2 and SS3.
	(detect_coding, detect_coding_system): Treat '\0' as normal ASCII byte.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.h (SJIS_TO_JIS2, JIS_TO_SJIS2): New macros.

	* coding.c (QCmnemonic, QCdefalut_char)
	(QCdecode_translation_table, QCencode_translation_table)
	(QCpost_read_conversion, QCpre_write_conversion): New variables.
	(get_translation_table): Return a list of translation tables if
	necessary.
	(decode_coding): Call get_translation_table with ENCODEP 0.
	(char_encodable_p): If translation_table is non-nil, always call
	translate_char.
	(Fdefine_coding_system_internal): Accept list of translation
	tables as :encode-translation-table and :decode-translation-table.
	(Fcoding_system_put): New function.
	(syms_of_coding): Declare new symbols.  Defsubr
	Scoding_system_put.
	(decode_coding_sjis, encode_coding_sjis): Handle 4th charset,
	typically JISX0212.

	* charset.c (map_charset_chars): Fix arg to map_charset_chars in
	when the charset is superset type.

	* character.c (translate_char): Accept list of translation tables.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.h (enum coding_attr_index): New member coding_attr_trans_tbl.
	(CODING_ATTR_TRANS_TBL): New macro.

	* coding.c (get_translation_table): New function.
	(translate_chars): Fix the bug of skipping annotation data.
	(decode_coding, encode_coding): Utilize get_translation_table.
	(char_encodable_p, Funencodable_char_position): Translate char if
	necessary.
	(Ffind_coding_systems_region_internal)
	(Fcheck_coding_systems_region): Setup translation table for encode
	in a coding system attribute vector in advance.
	(Fdefine_coding_system_internal): Allow a symbol as translation
	table.  For shift-jis type coding system, allow 4th charset.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* coding.c (decode_coding_sjis): Check the first byte rigidly.

	* xdisp.c (get_next_display_element): Pass -1 as POS to
	FACE_FOR_CHAR if displaying a C-string.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* composite.c (get_composition_id): Handle xoff and yoff in a
	composition rule.

	* composite.h (COMPOSITION_DECODE_RULE): New arg xoff and yoff.
	(struct composition): New member lbearing and rbearing.

	* xdisp.c (move_it_to): Optimize for the case (op & MOVE_TO_Y).
	(x_get_glyph_overhangs): Handle a composition glyph.
	(x_produce_glyphs): Setup lbearing and rbreaing for a composition glyph.

	* xterm.c (x_compute_glyph_string_overhangs): Handle also a
	composition glyph.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* print.c: Include charset.h.
	(Vprint_charset_text_property): New variable.
	(Qdefault): Extern it.
	(PRINT_STRING_NON_CHARSET_FOUND)
	(PRINT_STRING_UNSAFE_CHARSET_FOUND): New macros.
	(print_check_string_result): New variable.
	(print_check_string_charset_prop): New function.
	(print_prune_charset_plist): New variable.
	(print_prune_string_charset): New function.
	(print_object): Call print_prune_string_charset if
	Vprint_charset_text_property is not t.
	(print_interval): Print nothing if itnerval->plist is nil.
	(syms_of_print): Declare Vprint_charset_text_property as a lisp
	variable.  Init and staticpro print_prune_charset_plist.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* fontset.c (new_fontset_from_font_name): Use the specified font
	for all characters in the new fontset.

	* macterm.c (x_set_mouse_face_gc): Call FACE_FOR_CHAR with POS and
	OBJECT args.

	* xdisp.c (x_produce_glyphs): Call FACE_FOR_CHAR with POS and
	OBJECT args for composition too.

	* w32term.c (x_set_mouse_face_gc): Call FACE_FOR_CHAR with POS and
	OBJECT args.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* dispextern.h (FACE_FOR_CHAR): New args POS and OBJECT.

	* fontset.c (reorder_font_vector): Adjust for the change of
	FONT_DEF format.
	(fontset_face): New arg id.  Change caller.
	(face_for_char): New args pos and object.
	(make_fontset_for_ascii_face): Adjust for the change of FONT_DEF format.
	(fs_query_fontset): Check NAME by Fassoc too.
	(Fset_fontset_font): Allow non-XLFD font name.
	(Ffontset_info): Adjust for the change of FONT_DEF format.

	* fontset.h (face_for_char): Adjust prototype.

	* xdisp.c (face_before_or_after_it_pos, get_next_display_element)
	(append_space, extend_face_to_end_of_line)
	(get_char_face_and_encoding, BUILD_COMPOSITE_GLYPH_STRING)
	(x_produce_glyphs): Call FACE_FOR_CHAR with POS and OBJECT args.

	* xfaces.c (compute_char_face): Call FACE_FOR_CHAR with
	POS and OBJECT args.

	* xterm.c (x_set_mouse_face_gc): Call FACE_FOR_CHAR with
	POS and OBJECT args.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32select.c (Fw32_set_clipboard_data): Avoid potential realloc
	of GlobalAlloc'ed memory.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* ccl.c (Fccl_execute_on_string): Fix the condition of loop.

	* charset.h (charset_table_used): Delete extern.

	* charset.c (charset_table_used): Make it static.
	(map_charset_chars): Fix args to c_function with.

	* chartab.c (map_sub_char_table_for_charset): Fix args to
	c_function with.

	* coding.h (enum coding_result_code): Delete
	CODING_RESULT_INSUFFICIENT_CMP, add CODING_RESULT_INVALID_SRC.

	* coding.c (Qinsufficient_source, Qinconsistent_eol)
	(Qinvalid_source, Qinterrupted, Qinsufficient_memory): New variables.
	(Vlast_code_conversion_error): New variables.
	(syms_of_coding): DEFSYM or DEFVAR_LISP them.
	(ONE_MORE_BYTE): Record error if any instead of signaling an
	error.  If non-ASCII multibyte char is found, return the negative
	value of the code.  All callers changed to check it.
	(ONE_MORE_BYTE_NO_CHECK): Likewise.
	(record_conversion_result): New function.  Change all codes setting
	coding->result to call this function.
	(detect_coding_utf_8, decode_coding_utf_8)
	(detect_coding_emacs_mule, detect_coding_sji, detect_coding_big5):
	Don't use the local variable incomplete.
	(emacs_mule_char): Change the second arg to `const'.
	(decode_coding): Fix of flushing out unprocessed data.
	(make_conversion_work_buffer): Fix making of a work buffer.
	(decode_coding_object): Return coding->dst_object.

	* fontset.c (set_fontset_font): Fix args.

	* lisp.h (CHARACTERBITS): Define as 22.

	* process.c (send_process): Be sure to set coding->src_multibyte.

	* xdisp.c (handle_auto_composed_prop): Fix setting of limit.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (handle_auto_composed_prop): Give limit to
	Fnext_single_char_property_change.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* composite.c (syms_of_composite): Don't make the composition hash
	table weak.

	* fontset.c (Fset_fontset_font): Fix docstring.

	* lisp.h (detect_coding_system): Adjust prototype.

	* fileio.c (kill_workbuf_unwind): Delete this function.
	(Finsert_file_contents): Adjust the call of detect_coding_system.
	Get conversion_buffer by code_conversion_save.  Use the macor
	CODING_MAY_REQUIRE_DECODING.  After decoding, update
	coding_system.

	* coding.h (make_conversion_work_buffer): Delete extern.
	(code_conversion_save): Extern it.

	* coding.c (enum iso_code_class_type): Delete ISO_carriage_return.
	(CODING_GET_INFO): Delete argument eol_type.  Change callers.
	(decode_coding_utf_8): Don't do eol converion.
	(detect_coding_utf_16): Check coding->src_chars, not
	coding->src_bytes.  Add heuristics for those that have no signature.
	(decode_coding_emacs_mule, decode_coding_iso_2022)
	(decode_coding_sjis, decode_coding_big5, decode_coding_charset):
	Don't do eol converion.
	(adjust_coding_eol_type): Return a new coding system.
	(detect_coding): Don't detect eol.  Fix for utf-16 detection.
	(decode_eol): In case of CRLF->LF conversion, use del_range_2 on
	each change.
	(decode_coding): Pay attention to undo_list.  Do eol convesion for
	all types of coding-systems (if necessary).
	(Vcode_conversion_work_buf_list): Delete it.
	(Vcode_conversion_reused_workbuf): Rename from
	Vcode_conversion_reused_work_buf.
	(Vcode_conversion_workbuf_name): New variable.
	(reused_workbuf_in_use): New variable.
	(make_conversion_work_buffer): Delete the arg DEPTH.
	(code_conversion_restore): Change argument to cons.
	(code_conversion_save): Delete the argument BUFFER.  Change callers.
	(detect_coding_system): New argument src_chars.  Change callers.
	Fix for utf-16 detection.
	(init_coding_once): Don't use ISO_carriage_return.
	(syms_of_coding): Initialize Vcode_conversion_workbuf_name and
	reused_workbuf_in_use.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* keymap.c (store_in_keymap): Pay attention to the case that idx
	is a cons specifying a character range.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (handle_auto_composed_prop): Fix the case of returning
	HANDLED_RECOMPUTE_PROPS.

	* coding.c (Fdefine_coding_system_internal): Fix checking of
	ascii compatibility.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* charset.c (find_charsets_in_text): Delete unused locale variable.
	(Fset_charset_priority): Update Vemacs_mule_charset_list too.

	* coding.c (encode_coding_emacs_mule): Emit bytes with MSB.
	Resync charset_list to Vemacs_mule_charset_list.

	* keymap.c (store_in_keymap): Pay attention to the case that idx
	is a cons specifying a character range.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* composite.c (update_compositions): Bind inhibit-read-only, etc
	to t before calling remove-list-of-text-properties.

	* print.c (print_object): Always print ASCII chars as is.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* keymap.c (Fdefine_key): Fix handling of Lucid style event type list.

	* fns.c (Fmapconcat, Fmapcar, Fmapc): Signal an error if SEQUENCE
	is a char table.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* syntax.c (skip_chars): Be sure to alloca char_ranges when necessary.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xfaces.c (set_lface_from_font_name): Fix for the case that
	FONTNAME is not fontset name.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* fns.c (base64_encode_1): Fix previous change.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* fontset.c (set_fontset_font): New function.
	(Fset_fontset_font): If a font is specified for a charset, use
	map_charset_chars to store the font spec in a fontset.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* fontset.c (fontset_face): Create a fallback fontset on demand.
	(make_fontset): Don't create a fallback fontset here.
	(free_face_fontset): Free a fallback fontset (if any) too.
	(n_auto_fontsets): Delete this variable.
	(auto_fontset_alist): New variable.
	(new_fontset_from_font_name): Check auto_fontset_alist.
	(dump_fontset) [FONTSET_DEBUG]: Fully re-written.
	(Ffontset_list_all) [FONTSET_DEBUG]: New function.
	(syms_of_fontset): Initialize and staticpro auto_fontset_alist.
	Defsubr Sfontset_list_all.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xterm.c (x_list_fonts): Fix excluding of auto-scaled fonts.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* fontset.c (Fnew_fontset): Check NAME more rigidly.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* editfns.c (Fgoto_char): Fix docstring.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* insdel.c (insert_from_gap): Adjust intervals correctly.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (GLYPHSET, WCRANGE): Define if system headers don't.
	(pfnGetFontUnicodeRanges): New dynamically loaded function.
	(w32_initialize): Try to load it.
	(x_get_font_repertory): Use it if available.
	(w32_encode_char): Add shortcut for unicode output.

	* w32fns.c (w32_load_system_font): Default charset to -1.
	(x_to_w32_charset): Match all fonts for unicode.
	(w32_to_x_charset): New parameter matching.  Don't return partial
	or wildcard charsets.
	(w32_to_all_x_charsets): Don't return partial or wildcard charsets.
	(w32_codepage_for_font): Return CP_UNICODE for unicode.
	(w32_to_x_font): Match charset to real charset.
	(enum_font_cb2): Always list unicode versions.

	* makefile.w32-in (temacs): Increase EMHEAP.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (w32_encode_char): New charset parameter.
	font_info.encoding becomes encoding_type.
	(x_get_font_repertory): New function.  Warning: stub only!
	(x_new_font): Return quickly if font already set.
	(x_new_fontset): fontsetname parameter is Lisp_Object.
	Use new fs_query_fontset.  Try new_fontset_from_font_name.
	Use fontset_name for return value.

	* w32term.h: Declare x_get_font_repertory.

	* w32select.c (Fw32_set_clipboard_data): Use string_x_string_p in
	place of find_charset_in_text.  Use encode_coding_object in place
	of encode_coding.
	(Fw32_get_clipboard_data): Use decode_coding_c_string in place of
	decode_coding.

	* w32fns.c (Fx_create_frame, x_create_tip_frame): Use new version
	of x_new_fontset.
	(w32_load_system_font): Initialize charset as unicode.
	font_info.encoding becomes encoding_type.
	(w32_to_x_font): Use decode_coding_c_string in place of decode_coding.
	(x_to_w32_font): Use encode_coding_object in place of encode_coding.
	(syms_of_w32fns): Set get_font_repertory_func.

	* w32console.c: Include character.h.  Use terminal_encode_buffer
	from term.c.
	(write_glyphs): Use new version of encode_terminal_code.  Use
	encode_coding_object in place of encode_coding.

	* w32bdf.c (w32_load_bdf_font): Clear font_info before filling.
	encoding becomes encoding_type.

	* term.c (terminal_encode_buffer): Make externally visible.

	* makefile.w32-in: Add character.h dependancies.
	(character.o, chartab.o): New targets.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* fileio.c (Finsert_file_contents) [DOS_NT]: Use the macro
	CODING_ID_EOL_TYPE.

2008-02-01  Andreas Schwab  <schwab@suse.de>

	* coding.c (produce_chars): Revert last change.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* charset.h (charset_unicode): Extern it.

	* charset.c (string_xstring_p): Check by (C >= 0x100).
	(find_charsets_in_text): Change format of the arc CHARSETS.  New
	arg MULTIBYTE.
	(Ffind_charset_region, Ffind_charset_string): Adjust for the
	change of find_charsets_in_text.
	(Fsplit_char): Fix doc.  Never return unknown.

	* chartab.c (char_table_translate): Use CHARACTERP, not INETEGERP.

	* coding.c (Fdefine_coding_system_alias): Update
	Vcoding_system_list.

	* fontset.c (load_font_get_repertory): Pay attention to the case
	that ENCODING of a font is specified by a char-table.

	* xterm.c (x_get_font_repertory): Handle the case that the
	encoding of font is other than Unicode.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* term.c (encode_terminal_code): Don't handle glyph-table.  Check
	if a character is encodable by the terminal coding system.  If
	not, produces proper number of `?'s.  Update
	terminal_encode_buffer and terminal_encode_buf_size if necessary.
	(produce_glyphs): Check by CHAR_BYTE8_P, not SINGLE_BYTE_CHAR_P.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* term.c (terminal_encode_buffer, terminal_encode_buf_size): New
	variables.
	(encode_terminal_code): Change argument.  Encode multiple
	characters at once.  Store the result of encoding in
	terminal_encode_buffer.
	(write_glyphs, insert_glyphs): Adjust for the change of
	encode_terminal_code.
	(term_init): Initialize terminal_encode_buffer and
	terminal_encode_buf_size.

	* coding.c (consume_chars): If coding->src_object is nil, don't
	check annotation.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* character.c (char_string): Use ASCII_CHAR_P instead of
	SINGLE_BYTE_CHAR_P.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (handle_auto_composed_prop): Check if the last
	characters of auto-composed region is newly composed with the
	following characters.
	(handle_composition_prop): Fix checking of point being inside
	composition.

2008-02-01  Kenichi Handa  <handa@m17n.org>

	* fns.c (concat): Don't change multibyteness of the result by
	concatenating an 8-bit character.

	* data.c (Faset): Check newelt by CHECK_CHARACTER.  Don't change
	multibyteness of the result when newelt is an 8-bit character.

2008-02-01  Dave Love  <fx@gnu.org>

	* xmenu.c (find_and_call_menu_selection): Make menu_bar_items_used
	EMACS_INT.

	* xfns.c (DefaultDepthOfScreen, x_encode_text): Remove unused vars.

	* xfaces.c (face_numeric_value): Declare dim size_t.
	(Finternal_lisp_face_equal_p): Remove unused f.

	* xdisp.c (BUILD_CHAR_GLYPH_STRINGS, display_and_set_cursor)
	(MATRIX_ROW): Remove unused vars.
	(draw_glyphs, x_insert_glyphs, fast_find_position)
	(fast_find_position, fast_find_string_pos): Use EMACS_INT for
	byte/char counts.

	* regex.c (regex_compile): Remove unused var.

	* minibuf.c (Fminibuffer_complete_word): Remove unused var.

	* keymap.c (Fset_keymap_parent, map_keymap, Fcopy_keymap)
	(Faccessible_keymaps, where_is_internal): Remove unused vars.

	* keyboard.c (cancel_hourglass_unwind): Return Qnil.

	* frame.c (frame_name_fnn_p): Make len EMACS_INT.

	* fileio.c (Fwrite_region): Remove unused var.

	* dispnew.c (adjust_frame_glyphs_for_frame_redisplay)
	(adjust_frame_glyphs_for_window_redisplay): Remove unused ch_dim.

	* composite.c (Fremove_list_of_text_properties): Declare.

	* coding.c (inhibit_pre_post_conversion): Remove (unused).
	(alloc_destination, produce_chars): Use EMACS_INT for byte/char counts.
	(coding_inherit_eol_type): Remove unused attrs.
